/* A Bison parser, made by GNU Bison 2.7.  */

/* Bison implementation for Yacc-like parsers in C
   
      Copyright (C) 1984, 1989-1990, 2000-2012 Free Software Foundation, Inc.
   
   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.
   
   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
   
   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.
   
   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Bison version.  */
#define YYBISON_VERSION "2.7"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1


/* Substitute the variable and function names.  */
#define yyparse         cf_parse
#define yylex           cf_lex
#define yyerror         cf_error
#define yylval          cf_lval
#define yychar          cf_char
#define yydebug         cf_debug
#define yynerrs         cf_nerrs

/* Copy the first part of user declarations.  */
/* Line 371 of yacc.c  */
#line 1 "cf-parse.y"

/* Headers from ../../conf/confbase.Y */

#define PARSER 1

#include "nest/bird.h"
#include "conf/conf.h"
#include "lib/resource.h"
#include "lib/socket.h"
#include "lib/timer.h"
#include "lib/string.h"
#include "nest/protocol.h"
#include "nest/iface.h"
#include "nest/route.h"
#include "nest/cli.h"
#include "filter/filter.h"

/* FIXME: Turn on YYERROR_VERBOSE and work around lots of bison bugs? */

/* Defines from ../../conf/confbase.Y */

static void
check_u16(unsigned val)
{
  if (val > 0xFFFF)
    cf_error("Value %d out of range (0-65535)", val);
}

/* Headers from ../../sysdep/unix/config.Y */

#include "lib/unix.h"
#include <stdio.h>

/* Headers from ../../sysdep/unix/krt.Y */

#include "lib/krt.h"

/* Defines from ../../sysdep/unix/krt.Y */

#define THIS_KRT ((struct krt_config *) this_proto)
#define THIS_KIF ((struct kif_config *) this_proto)

/* Headers from ../../sysdep/linux/netlink.Y */

/* Headers from ../../nest/config.Y */

#include "nest/rt-dev.h"
#include "nest/password.h"
#include "nest/cmds.h"
#include "lib/lists.h"

/* Defines from ../../nest/config.Y */

static struct proto_config *this_proto;
static struct iface_patt *this_ipatt;
static struct iface_patt_node *this_ipn;
static struct roa_table_config *this_roa_table;
static list *this_p_list;
static struct password_item *this_p_item;
static int password_id;

static inline void
reset_passwords(void)
{
  this_p_list = NULL;
}

static inline list *
get_passwords(void)
{
  list *rv = this_p_list;
  this_p_list = NULL;
  return rv;
}

#define DIRECT_CFG ((struct rt_dev_config *) this_proto)

/* Headers from ../../filter/config.Y */

/* Defines from ../../filter/config.Y */

#define P(a,b) ((a << 8) | b)

static inline u32 pair(u32 a, u32 b) { return (a << 16) | b; }
static inline u32 pair_a(u32 p) { return p >> 16; }
static inline u32 pair_b(u32 p) { return p & 0xFFFF; }


/*
 * Sets and their items are during parsing handled as lists, linked
 * through left ptr. The first item in a list also contains a pointer
 * to the last item in a list (right ptr). For convenience, even items
 * are handled as one-item lists. Lists are merged by f_merge_items().
 */

static inline struct f_tree *
f_new_item(struct f_val from, struct f_val to)
{
  struct f_tree *t = f_new_tree();
  t->right = t;
  t->from = from;
  t->to = to;
  return t;
}

static inline struct f_tree *
f_merge_items(struct f_tree *a, struct f_tree *b)
{
  if (!a) return b;
  a->right->left = b;
  a->right = b->right;
  b->right = NULL;
  return a;
}

static inline struct f_tree *
f_new_pair_item(int fa, int ta, int fb, int tb)
{
  struct f_tree *t = f_new_tree();
  t->right = t;
  t->from.type = t->to.type = T_PAIR;
  t->from.val.i = pair(fa, fb);
  t->to.val.i = pair(ta, tb);
  return t;
}

static inline struct f_tree *
f_new_pair_set(int fa, int ta, int fb, int tb)
{
  struct f_tree *lst = NULL;
  int i;

  if ((fa == ta) || ((fb == 0) && (tb == 0xFFFF)))
    return f_new_pair_item(fa, ta, fb, tb);
  
  if ((ta < fa) || (tb < fb))
    cf_error( "From value cannot be higher that To value in pair sets");

  for (i = fa; i <= ta; i++)
    lst = f_merge_items(lst, f_new_pair_item(i, i, fb, tb));

  return lst;
}

#define EC_ALL 0xFFFFFFFF

static struct f_tree *
f_new_ec_item(u32 kind, u32 ipv4_used, u32 key, u32 vf, u32 vt)
{
  u64 fm, to;

  if (ipv4_used || (key >= 0x10000)) {
    check_u16(vf);
    if (vt == EC_ALL)
      vt = 0xFFFF;
    else
      check_u16(vt);
  }

  if (kind == EC_GENERIC) {
    fm = ec_generic(key, vf);
    to = ec_generic(key, vt);
  }
  else if (ipv4_used) {
    fm = ec_ip4(kind, key, vf);
    to = ec_ip4(kind, key, vt);
  }
  else if (key < 0x10000) {
    fm = ec_as2(kind, key, vf);
    to = ec_as2(kind, key, vt);
  }
  else {
    fm = ec_as4(kind, key, vf);
    to = ec_as4(kind, key, vt);
  }

  struct f_tree *t = f_new_tree();
  t->right = t;
  t->from.type = t->to.type = T_EC;
  t->from.val.ec = fm;
  t->to.val.ec = to;
  return t;
}

static inline struct f_inst *
f_generate_empty(struct f_inst *dyn)
{ 
  struct f_inst *e = f_new_inst();
  e->code = 'E';

  switch (dyn->aux & EAF_TYPE_MASK) {
    case EAF_TYPE_AS_PATH:
      e->aux = T_PATH;
      break;
    case EAF_TYPE_INT_SET:
      e->aux = T_CLIST;
      break;
    case EAF_TYPE_EC_SET:
      e->aux = T_ECLIST;
      break;
    default:
      cf_error("Can't empty that attribute");
  }

  dyn->code = P('e','S');
  dyn->a1.p = e;
  return dyn;
}


static inline struct f_inst *
f_generate_dpair(struct f_inst *t1, struct f_inst *t2)
{
  struct f_inst *rv;

  if ((t1->code == 'c') && (t2->code == 'c')) {
    if ((t1->aux != T_INT) || (t2->aux != T_INT))
      cf_error( "Can't operate with value of non-integer type in pair constructor");

    check_u16(t1->a2.i);
    check_u16(t2->a2.i);

    rv = f_new_inst();
    rv->code = 'c';
    rv->aux = T_PAIR;
    rv->a2.i = pair(t1->a2.i, t2->a2.i);
  }
  else {
    rv = f_new_inst();
    rv->code = P('m', 'p');
    rv->a1.p = t1;
    rv->a2.p = t2;
  }

  return rv;
}

static inline struct f_inst *
f_generate_ec(u16 kind, struct f_inst *tk, struct f_inst *tv)
{
  struct f_inst *rv;
  int c1 = 0, c2 = 0, ipv4_used = 0;
  u32 key = 0, val2 = 0;

  if (tk->code == 'c') {
    c1 = 1;

    if (tk->aux == T_INT) {
      ipv4_used = 0; key = tk->a2.i;
    }
    else if (tk->aux == T_QUAD) {
      ipv4_used = 1; key = tk->a2.i;
    }
    else
      cf_error("Can't operate with key of non-integer/IPv4 type in EC constructor");
  }

#ifndef IPV6
  /* IP->Quad implicit conversion */
  else if (tk->code == 'C') {
    c1 = 1;
    struct f_val *val = tk->a1.p;

    if (val->type == T_INT) {
      ipv4_used = 0; key = val->val.i;
    }
    else if (val->type == T_QUAD) {
      ipv4_used = 1; key = val->val.i;
    }
    else if (val->type == T_IP) {
      ipv4_used = 1; key = ipa_to_u32(val->val.px.ip);
    }
    else
      cf_error("Can't operate with key of non-integer/IPv4 type in EC constructor");
  }
#endif

  if (tv->code == 'c') {
    if (tv->aux != T_INT)
      cf_error("Can't operate with value of non-integer type in EC constructor");
    c2 = 1;
    val2 = tv->a2.i;
  }

  if (c1 && c2) {
    u64 ec;
  
    if (kind == EC_GENERIC) {
      ec = ec_generic(key, val2);
    }
    else if (ipv4_used) {
      check_u16(val2);
      ec = ec_ip4(kind, key, val2);
    }
    else if (key < 0x10000) {
      ec = ec_as2(kind, key, val2);
    }
    else {
      check_u16(val2);
      ec = ec_as4(kind, key, val2);
    }

    NEW_F_VAL;
    rv = f_new_inst();
    rv->code = 'C';
    rv->a1.p = val;    
    val->type = T_EC;
    val->val.ec = ec;
  }
  else {
    rv = f_new_inst();
    rv->code = P('m','c');
    rv->aux = kind;
    rv->a1.p = tk;
    rv->a2.p = tv;
  }

  return rv;
}



/* Headers from ../../proto/bgp/config.Y */

#include "proto/bgp/bgp.h"

/* Defines from ../../proto/bgp/config.Y */

#define BGP_CFG ((struct bgp_config *) this_proto)

/* Headers from ../../proto/ospf/config.Y */

#include "proto/ospf/ospf.h"

/* Defines from ../../proto/ospf/config.Y */

#define OSPF_CFG ((struct ospf_config *) this_proto)
#define OSPF_PATT ((struct ospf_iface_patt *) this_ipatt)

static struct ospf_area_config *this_area;
static struct nbma_node *this_nbma;
static list *this_nets;
static struct area_net_config *this_pref;
static struct ospf_stubnet_config *this_stubnet; 

#ifdef OSPFv2
static void
ospf_iface_finish(void)
{
  struct ospf_iface_patt *ip = OSPF_PATT;

  if (ip->deadint == 0)
    ip->deadint = ip->deadc * ip->helloint;

  ip->passwords = get_passwords();

  if ((ip->autype == OSPF_AUTH_CRYPT) && (ip->helloint < 5))
    log(L_WARN "Hello or poll interval less that 5 makes cryptographic authenication prone to replay attacks");

  if ((ip->autype == OSPF_AUTH_NONE) && (ip->passwords != NULL))
    log(L_WARN "Password option without authentication option does not make sense");
}
#endif

#ifdef OSPFv3
static void
ospf_iface_finish(void)
{
  struct ospf_iface_patt *ip = OSPF_PATT;

  if (ip->deadint == 0)
    ip->deadint = ip->deadc * ip->helloint;

  if ((ip->autype != OSPF_AUTH_NONE) || (get_passwords() != NULL))
    cf_error("Authentication not supported in OSPFv3");
}
#endif

static void
ospf_area_finish(void)
{
  if ((this_area->areaid == 0) && (this_area->type != OPT_E))
    cf_error("Backbone area cannot be stub/NSSA");

  if (this_area->summary && (this_area->type == OPT_E))
    cf_error("Only Stub/NSSA areas can use summary propagation");

  if (this_area->default_nssa && ((this_area->type != OPT_N) || ! this_area->summary))
    cf_error("Only NSSA areas with summary propagation can use NSSA default route");

  if ((this_area->default_cost & LSA_EXT_EBIT) && ! this_area->default_nssa)
    cf_error("Only NSSA default route can use type 2 metric");
}

static void
ospf_proto_finish(void)
{
  struct ospf_config *cf = OSPF_CFG;

  if (EMPTY_LIST(cf->area_list))
    cf_error( "No configured areas in OSPF");

  int areano = 0;
  int backbone = 0;
  struct ospf_area_config *ac;
  WALK_LIST(ac, cf->area_list)
  {
    areano++;
    if (ac->areaid == 0)
     backbone = 1;
  }
  cf->abr = areano > 1;

  if (cf->abr && !backbone)
  {
    struct ospf_area_config *ac = cfg_allocz(sizeof(struct ospf_area_config));
    ac->type = OPT_E; /* Backbone is non-stub */
    add_head(&cf->area_list, NODE ac);
    init_list(&ac->patt_list);
    init_list(&ac->net_list);
    init_list(&ac->enet_list);
    init_list(&ac->stubnet_list);
  }

  if (!cf->abr && !EMPTY_LIST(cf->vlink_list))
    cf_error( "Vlinks cannot be used on single area router");
}

static inline void
check_defcost(int cost)
{
  if ((cost <= 0) || (cost >= LSINFINITY))
   cf_error("Default cost must be in range 1-%d", LSINFINITY-1);
}

static inline void
set_instance_id(unsigned id)
{
#ifdef OSPFv3
  OSPF_PATT->instance_id = id;
#else
  cf_error("Instance ID requires OSPFv3");
#endif
}

/* Headers from ../../proto/pipe/config.Y */

#include "proto/pipe/pipe.h"

/* Defines from ../../proto/pipe/config.Y */

#define PIPE_CFG ((struct pipe_config *) this_proto)

/* Headers from ../../proto/radv/config.Y */

#include "proto/radv/radv.h"

/* Defines from ../../proto/radv/config.Y */

#define RADV_CFG ((struct radv_config *) this_proto)
#define RADV_IFACE ((struct radv_iface_config *) this_ipatt)
#define RADV_PREFIX this_radv_prefix
#define RADV_RDNSS (&this_radv_rdnss)
#define RADV_DNSSL (&this_radv_dnssl)

static struct radv_prefix_config *this_radv_prefix;
static struct radv_rdnss_config this_radv_rdnss;
static struct radv_dnssl_config this_radv_dnssl;
static list radv_dns_list;	/* Used by radv_rdnss and radv_dnssl */
static u8 radv_mult_val;	/* Used by radv_mult for second return value */


/* Headers from ../../proto/rip/config.Y */

#include "proto/rip/rip.h"
#include "nest/iface.h"

/* Defines from ../../proto/rip/config.Y */

#define RIP_CFG ((struct rip_proto_config *) this_proto)
#define RIP_IPATT ((struct rip_patt *) this_ipatt)

#ifdef IPV6
#define RIP_DEFAULT_TTL_SECURITY 2
#else
#define RIP_DEFAULT_TTL_SECURITY 0
#endif

/* Headers from ../../proto/static/config.Y */

#include "proto/static/static.h"

/* Defines from ../../proto/static/config.Y */

#define STATIC_CFG ((struct static_config *) this_proto)
static struct static_route *this_srt, *this_srt_nh, *last_srt_nh;


/* Line 371 of yacc.c  */
#line 574 "cf-parse.tab.c"

# ifndef YY_NULL
#  if defined __cplusplus && 201103L <= __cplusplus
#   define YY_NULL nullptr
#  else
#   define YY_NULL 0
#  endif
# endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

/* In a future release of Bison, this section will be replaced
   by #include "cf-parse.tab.h".  */
#ifndef YY_CF_CF_PARSE_TAB_H_INCLUDED
# define YY_CF_CF_PARSE_TAB_H_INCLUDED
/* Enabling traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif
#if YYDEBUG
extern int cf_debug;
#endif

/* Tokens.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
   /* Put the tokens into the symbol table, so that GDB and other debuggers
      know about them.  */
   enum yytokentype {
     END = 258,
     CLI_MARKER = 259,
     INVALID_TOKEN = 260,
     ELSECOL = 261,
     DDOT = 262,
     GEQ = 263,
     LEQ = 264,
     NEQ = 265,
     AND = 266,
     OR = 267,
     PO = 268,
     PC = 269,
     NUM = 270,
     ENUM = 271,
     RTRID = 272,
     IPA = 273,
     SYM = 274,
     TEXT = 275,
     PREFIX_DUMMY = 276,
     DEFINE = 277,
     ON = 278,
     OFF = 279,
     YES = 280,
     NO = 281,
     LOG = 282,
     SYSLOG = 283,
     ALL = 284,
     DEBUG = 285,
     TRACE = 286,
     INFO = 287,
     REMOTE = 288,
     WARNING = 289,
     ERROR = 290,
     AUTH = 291,
     FATAL = 292,
     BUG = 293,
     STDERR = 294,
     SOFT = 295,
     TIMEFORMAT = 296,
     ISO = 297,
     SHORT = 298,
     LONG = 299,
     BASE = 300,
     NAME = 301,
     CONFIRM = 302,
     UNDO = 303,
     CHECK = 304,
     TIMEOUT = 305,
     CONFIGURE = 306,
     DOWN = 307,
     KERNEL = 308,
     PERSIST = 309,
     SCAN = 310,
     TIME = 311,
     LEARN = 312,
     DEVICE = 313,
     ROUTES = 314,
     KRT_SOURCE = 315,
     KRT_METRIC = 316,
     TABLE = 317,
     KRT_PREFSRC = 318,
     KRT_REALM = 319,
     ROUTER = 320,
     ID = 321,
     PROTOCOL = 322,
     TEMPLATE = 323,
     PREFERENCE = 324,
     DISABLED = 325,
     DIRECT = 326,
     INTERFACE = 327,
     IMPORT = 328,
     EXPORT = 329,
     FILTER = 330,
     NONE = 331,
     STATES = 332,
     FILTERS = 333,
     RECEIVE = 334,
     LIMIT = 335,
     ACTION = 336,
     WARN = 337,
     BLOCK = 338,
     RESTART = 339,
     DISABLE = 340,
     KEEP = 341,
     FILTERED = 342,
     PASSWORD = 343,
     FROM = 344,
     PASSIVE = 345,
     TO = 346,
     EVENTS = 347,
     PACKETS = 348,
     PROTOCOLS = 349,
     INTERFACES = 350,
     PRIMARY = 351,
     STATS = 352,
     COUNT = 353,
     FOR = 354,
     COMMANDS = 355,
     PREEXPORT = 356,
     GENERATE = 357,
     ROA = 358,
     MAX = 359,
     FLUSH = 360,
     LISTEN = 361,
     BGP = 362,
     V6ONLY = 363,
     DUAL = 364,
     ADDRESS = 365,
     PORT = 366,
     PASSWORDS = 367,
     DESCRIPTION = 368,
     SORTED = 369,
     RELOAD = 370,
     IN = 371,
     OUT = 372,
     MRTDUMP = 373,
     MESSAGES = 374,
     RESTRICT = 375,
     MEMORY = 376,
     IGP_METRIC = 377,
     CLASS = 378,
     DSCP = 379,
     SHOW = 380,
     STATUS = 381,
     SUMMARY = 382,
     ROUTE = 383,
     SYMBOLS = 384,
     ADD = 385,
     DELETE = 386,
     DUMP = 387,
     RESOURCES = 388,
     SOCKETS = 389,
     NEIGHBORS = 390,
     ATTRIBUTES = 391,
     EVAL = 392,
     ECHO = 393,
     ENABLE = 394,
     FUNCTION = 395,
     PRINT = 396,
     PRINTN = 397,
     UNSET = 398,
     RETURN = 399,
     ACCEPT = 400,
     REJECT = 401,
     QUITBIRD = 402,
     INT = 403,
     BOOL = 404,
     IP = 405,
     PREFIX = 406,
     PAIR = 407,
     QUAD = 408,
     EC = 409,
     SET = 410,
     STRING = 411,
     BGPMASK = 412,
     BGPPATH = 413,
     CLIST = 414,
     ECLIST = 415,
     IF = 416,
     THEN = 417,
     ELSE = 418,
     CASE = 419,
     TRUE = 420,
     FALSE = 421,
     RT = 422,
     RO = 423,
     UNKNOWN = 424,
     GENERIC = 425,
     GW = 426,
     NET = 427,
     MASK = 428,
     PROTO = 429,
     SOURCE = 430,
     SCOPE = 431,
     CAST = 432,
     DEST = 433,
     LEN = 434,
     DEFINED = 435,
     CONTAINS = 436,
     RESET = 437,
     PREPEND = 438,
     FIRST = 439,
     LAST = 440,
     MATCH = 441,
     ROA_CHECK = 442,
     EMPTY = 443,
     WHERE = 444,
     LOCAL = 445,
     NEIGHBOR = 446,
     AS = 447,
     HOLD = 448,
     CONNECT = 449,
     RETRY = 450,
     KEEPALIVE = 451,
     MULTIHOP = 452,
     STARTUP = 453,
     VIA = 454,
     NEXT = 455,
     HOP = 456,
     SELF = 457,
     DEFAULT = 458,
     PATH = 459,
     METRIC = 460,
     START = 461,
     DELAY = 462,
     FORGET = 463,
     WAIT = 464,
     AFTER = 465,
     BGP_PATH = 466,
     BGP_LOCAL_PREF = 467,
     BGP_MED = 468,
     BGP_ORIGIN = 469,
     BGP_NEXT_HOP = 470,
     BGP_ATOMIC_AGGR = 471,
     BGP_AGGREGATOR = 472,
     BGP_COMMUNITY = 473,
     BGP_EXT_COMMUNITY = 474,
     RR = 475,
     RS = 476,
     CLIENT = 477,
     CLUSTER = 478,
     AS4 = 479,
     ADVERTISE = 480,
     IPV4 = 481,
     CAPABILITIES = 482,
     PREFER = 483,
     OLDER = 484,
     MISSING = 485,
     LLADDR = 486,
     DROP = 487,
     IGNORE = 488,
     REFRESH = 489,
     INTERPRET = 490,
     COMMUNITIES = 491,
     BGP_ORIGINATOR_ID = 492,
     BGP_CLUSTER_LIST = 493,
     IGP = 494,
     GATEWAY = 495,
     RECURSIVE = 496,
     MED = 497,
     TTL = 498,
     SECURITY = 499,
     DETERMINISTIC = 500,
     SECONDARY = 501,
     OSPF = 502,
     AREA = 503,
     OSPF_METRIC1 = 504,
     OSPF_METRIC2 = 505,
     OSPF_TAG = 506,
     OSPF_ROUTER_ID = 507,
     RFC1583COMPAT = 508,
     STUB = 509,
     TICK = 510,
     COST = 511,
     COST2 = 512,
     RETRANSMIT = 513,
     HELLO = 514,
     TRANSMIT = 515,
     PRIORITY = 516,
     DEAD = 517,
     TYPE = 518,
     BROADCAST = 519,
     BCAST = 520,
     NONBROADCAST = 521,
     NBMA = 522,
     POINTOPOINT = 523,
     PTP = 524,
     POINTOMULTIPOINT = 525,
     PTMP = 526,
     SIMPLE = 527,
     AUTHENTICATION = 528,
     STRICT = 529,
     CRYPTOGRAPHIC = 530,
     ELIGIBLE = 531,
     POLL = 532,
     NETWORKS = 533,
     HIDDEN = 534,
     VIRTUAL = 535,
     LINK = 536,
     ONLY = 537,
     RX = 538,
     BUFFER = 539,
     LARGE = 540,
     NORMAL = 541,
     STUBNET = 542,
     TAG = 543,
     EXTERNAL = 544,
     LSADB = 545,
     ECMP = 546,
     WEIGHT = 547,
     NSSA = 548,
     TRANSLATOR = 549,
     STABILITY = 550,
     GLOBAL = 551,
     LSID = 552,
     INSTANCE = 553,
     REAL = 554,
     NETMASK = 555,
     TX = 556,
     TOPOLOGY = 557,
     STATE = 558,
     PIPE = 559,
     PEER = 560,
     MODE = 561,
     OPAQUE = 562,
     TRANSPARENT = 563,
     RADV = 564,
     MIN = 565,
     RA = 566,
     INTERVAL = 567,
     MANAGED = 568,
     OTHER = 569,
     CONFIG = 570,
     MTU = 571,
     REACHABLE = 572,
     RETRANS = 573,
     TIMER = 574,
     CURRENT = 575,
     VALID = 576,
     PREFERRED = 577,
     MULT = 578,
     LIFETIME = 579,
     SKIP = 580,
     ONLINK = 581,
     AUTONOMOUS = 582,
     RDNSS = 583,
     DNSSL = 584,
     NS = 585,
     DOMAIN = 586,
     TRIGGER = 587,
     SENSITIVE = 588,
     RIP = 589,
     INFINITY = 590,
     PERIOD = 591,
     GARBAGE = 592,
     MULTICAST = 593,
     QUIET = 594,
     NOLISTEN = 595,
     VERSION1 = 596,
     PLAINTEXT = 597,
     MD5 = 598,
     HONOR = 599,
     NEVER = 600,
     ALWAYS = 601,
     RIP_METRIC = 602,
     RIP_TAG = 603,
     STATIC = 604,
     PROHIBIT = 605,
     MULTIPATH = 606,
     BLACKHOLE = 607,
     UNREACHABLE = 608
   };
#endif


#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED
typedef union YYSTYPE
{
/* Line 387 of yacc.c  */
#line 502 "cf-parse.y"

  int i;
  u32 i32;
  ip_addr a;
  struct symbol *s;
  char *t;
  struct rtable_config *r;
  struct f_inst *x;
  struct filter *f;
  struct f_tree *e;
  struct f_trie *trie;
  struct f_val v;
  struct f_path_mask *h;
  struct password_item *p;
  struct rt_show_data *ra;
  struct roa_show_data *ro;
  struct sym_show_data *sd;
  struct lsadb_show_data *ld;
  struct iface *iface;
  struct roa_table *rot;
  void *g;
  bird_clock_t time;
  struct prefix px;
  struct proto_spec ps;
  struct timeformat *tf;


/* Line 387 of yacc.c  */
#line 998 "cf-parse.tab.c"
} YYSTYPE;
# define YYSTYPE_IS_TRIVIAL 1
# define yystype YYSTYPE /* obsolescent; will be withdrawn */
# define YYSTYPE_IS_DECLARED 1
#endif

extern YYSTYPE cf_lval;

#ifdef YYPARSE_PARAM
#if defined __STDC__ || defined __cplusplus
int cf_parse (void *YYPARSE_PARAM);
#else
int cf_parse ();
#endif
#else /* ! YYPARSE_PARAM */
#if defined __STDC__ || defined __cplusplus
int cf_parse (void);
#else
int cf_parse ();
#endif
#endif /* ! YYPARSE_PARAM */

#endif /* !YY_CF_CF_PARSE_TAB_H_INCLUDED  */

/* Copy the second part of user declarations.  */

/* Line 390 of yacc.c  */
#line 1026 "cf-parse.tab.c"

#ifdef short
# undef short
#endif

#ifdef YYTYPE_UINT8
typedef YYTYPE_UINT8 yytype_uint8;
#else
typedef unsigned char yytype_uint8;
#endif

#ifdef YYTYPE_INT8
typedef YYTYPE_INT8 yytype_int8;
#elif (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
typedef signed char yytype_int8;
#else
typedef short int yytype_int8;
#endif

#ifdef YYTYPE_UINT16
typedef YYTYPE_UINT16 yytype_uint16;
#else
typedef unsigned short int yytype_uint16;
#endif

#ifdef YYTYPE_INT16
typedef YYTYPE_INT16 yytype_int16;
#else
typedef short int yytype_int16;
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif ! defined YYSIZE_T && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned int
# endif
#endif

#define YYSIZE_MAXIMUM ((YYSIZE_T) -1)

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(E) ((void) (E))
#else
# define YYUSE(E) /* empty */
#endif

/* Identity function, used to suppress warnings about constant conditions.  */
#ifndef lint
# define YYID(N) (N)
#else
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static int
YYID (int yyi)
#else
static int
YYID (yyi)
    int yyi;
#endif
{
  return yyi;
}
#endif

#if ! defined yyoverflow || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
      /* Use EXIT_SUCCESS as a witness for stdlib.h.  */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's `empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (YYID (0))
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
	     && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* ! defined yyoverflow || YYERROR_VERBOSE */


#if (! defined yyoverflow \
     && (! defined __cplusplus \
	 || (defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yytype_int16 yyss_alloc;
  YYSTYPE yyvs_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (yytype_int16) + sizeof (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)				\
    do									\
      {									\
	YYSIZE_T yynewbytes;						\
	YYCOPY (&yyptr->Stack_alloc, Stack, yysize);			\
	Stack = &yyptr->Stack_alloc;					\
	yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
	yyptr += yynewbytes / sizeof (*yyptr);				\
      }									\
    while (YYID (0))

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, (Count) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYSIZE_T yyi;                         \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (YYID (0))
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  66
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   2710

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  375
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  269
/* YYNRULES -- Number of rules.  */
#define YYNRULES  845
/* YYNRULES -- Number of states.  */
#define YYNSTATES  1583

/* YYTRANSLATE(YYLEX) -- Bison symbol number corresponding to YYLEX.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   608

#define YYTRANSLATE(YYX)						\
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[YYLEX] -- Bison symbol number corresponding to YYLEX.  */
static const yytype_uint16 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,    31,     2,     2,     2,    30,     2,     2,
     366,   367,    28,    26,   371,    27,    32,    29,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,   368,   365,
      23,    22,    24,   372,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,   373,     2,   374,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,   369,     2,   370,    25,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    33,    34,    35,
      36,    37,    38,    39,    40,    41,    42,    43,    44,    45,
      46,    47,    48,    49,    50,    51,    52,    53,    54,    55,
      56,    57,    58,    59,    60,    61,    62,    63,    64,    65,
      66,    67,    68,    69,    70,    71,    72,    73,    74,    75,
      76,    77,    78,    79,    80,    81,    82,    83,    84,    85,
      86,    87,    88,    89,    90,    91,    92,    93,    94,    95,
      96,    97,    98,    99,   100,   101,   102,   103,   104,   105,
     106,   107,   108,   109,   110,   111,   112,   113,   114,   115,
     116,   117,   118,   119,   120,   121,   122,   123,   124,   125,
     126,   127,   128,   129,   130,   131,   132,   133,   134,   135,
     136,   137,   138,   139,   140,   141,   142,   143,   144,   145,
     146,   147,   148,   149,   150,   151,   152,   153,   154,   155,
     156,   157,   158,   159,   160,   161,   162,   163,   164,   165,
     166,   167,   168,   169,   170,   171,   172,   173,   174,   175,
     176,   177,   178,   179,   180,   181,   182,   183,   184,   185,
     186,   187,   188,   189,   190,   191,   192,   193,   194,   195,
     196,   197,   198,   199,   200,   201,   202,   203,   204,   205,
     206,   207,   208,   209,   210,   211,   212,   213,   214,   215,
     216,   217,   218,   219,   220,   221,   222,   223,   224,   225,
     226,   227,   228,   229,   230,   231,   232,   233,   234,   235,
     236,   237,   238,   239,   240,   241,   242,   243,   244,   245,
     246,   247,   248,   249,   250,   251,   252,   253,   254,   255,
     256,   257,   258,   259,   260,   261,   262,   263,   264,   265,
     266,   267,   268,   269,   270,   271,   272,   273,   274,   275,
     276,   277,   278,   279,   280,   281,   282,   283,   284,   285,
     286,   287,   288,   289,   290,   291,   292,   293,   294,   295,
     296,   297,   298,   299,   300,   301,   302,   303,   304,   305,
     306,   307,   308,   309,   310,   311,   312,   313,   314,   315,
     316,   317,   318,   319,   320,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,   344,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364
};

#if YYDEBUG
/* YYPRHS[YYN] -- Index of the first RHS symbol of rule number YYN in
   YYRHS.  */
static const yytype_uint16 yyprhs[] =
{
       0,     0,     3,     6,     9,    10,    13,    19,    21,    25,
      27,    29,    31,    33,    35,    37,    38,    40,    42,    43,
      46,    49,    51,    53,    56,    59,    61,    63,    64,    69,
      72,    73,    75,    78,    80,    82,    86,    88,    92,    94,
      96,    98,   100,   102,   104,   106,   108,   110,   115,   119,
     121,   123,   125,   127,   130,   135,   139,   143,   147,   152,
     158,   162,   166,   171,   174,   175,   177,   178,   180,   183,
     186,   189,   193,   196,   200,   203,   207,   211,   215,   220,
     226,   228,   230,   232,   237,   238,   241,   244,   247,   249,
     251,   252,   254,   258,   262,   263,   272,   274,   279,   281,
     283,   284,   286,   290,   291,   294,   297,   300,   303,   306,
     309,   313,   317,   321,   326,   329,   333,   336,   339,   341,
     343,   345,   346,   349,   352,   355,   358,   361,   363,   365,
     369,   373,   374,   376,   378,   381,   382,   384,   388,   390,
     394,   395,   398,   401,   404,   407,   411,   415,   419,   420,
     424,   426,   428,   432,   434,   438,   440,   442,   444,   446,
     448,   450,   452,   454,   458,   460,   464,   466,   468,   473,
     475,   476,   480,   485,   487,   490,   491,   497,   503,   509,
     515,   520,   524,   528,   533,   539,   541,   542,   546,   551,
     556,   557,   560,   564,   568,   572,   575,   578,   581,   584,
     588,   592,   595,   598,   600,   602,   607,   608,   612,   616,
     620,   621,   623,   625,   630,   631,   634,   637,   640,   643,
     646,   649,   652,   653,   656,   666,   676,   681,   685,   689,
     693,   697,   701,   705,   709,   713,   718,   720,   722,   726,
     727,   729,   733,   737,   741,   745,   750,   755,   760,   765,
     768,   770,   772,   774,   776,   777,   779,   780,   785,   788,
     790,   792,   794,   796,   798,   800,   802,   804,   806,   808,
     810,   812,   815,   818,   819,   823,   825,   829,   831,   833,
     835,   838,   842,   845,   850,   851,   857,   858,   860,   862,
     865,   867,   871,   873,   875,   877,   879,   881,   883,   887,
     889,   891,   893,   895,   897,   901,   903,   909,   921,   923,
     925,   927,   930,   932,   940,   950,   958,   960,   962,   964,
     968,   970,   972,   974,   978,   980,   984,   986,   990,   994,
     996,   999,  1002,  1009,  1011,  1015,  1016,  1021,  1025,  1027,
    1031,  1035,  1039,  1042,  1045,  1048,  1051,  1052,  1055,  1058,
    1059,  1061,  1063,  1065,  1067,  1069,  1071,  1073,  1077,  1081,
    1083,  1085,  1091,  1099,  1100,  1105,  1107,  1109,  1111,  1113,
    1115,  1117,  1119,  1121,  1123,  1127,  1131,  1135,  1139,  1143,
    1147,  1151,  1155,  1159,  1163,  1167,  1171,  1175,  1179,  1182,
    1187,  1189,  1191,  1193,  1195,  1198,  1201,  1205,  1209,  1216,
    1220,  1224,  1228,  1232,  1238,  1245,  1252,  1259,  1266,  1271,
    1280,  1285,  1287,  1289,  1291,  1293,  1295,  1297,  1299,  1300,
    1302,  1306,  1308,  1312,  1313,  1315,  1320,  1327,  1332,  1336,
    1342,  1348,  1353,  1360,  1364,  1367,  1373,  1379,  1388,  1397,
    1406,  1415,  1418,  1422,  1426,  1432,  1439,  1447,  1454,  1459,
    1464,  1470,  1477,  1484,  1490,  1494,  1499,  1505,  1511,  1517,
    1523,  1529,  1534,  1539,  1545,  1551,  1557,  1563,  1569,  1575,
    1581,  1587,  1594,  1601,  1610,  1617,  1624,  1630,  1635,  1641,
    1646,  1652,  1657,  1663,  1668,  1674,  1680,  1683,  1687,  1691,
    1693,  1696,  1700,  1703,  1708,  1711,  1713,  1716,  1721,  1722,
    1726,  1729,  1731,  1734,  1738,  1742,  1746,  1750,  1753,  1757,
    1758,  1764,  1765,  1771,  1774,  1777,  1779,  1784,  1786,  1788,
    1789,  1793,  1796,  1799,  1802,  1808,  1811,  1812,  1816,  1817,
    1820,  1823,  1827,  1830,  1833,  1837,  1840,  1843,  1846,  1848,
    1852,  1855,  1858,  1861,  1864,  1867,  1870,  1874,  1877,  1880,
    1883,  1886,  1889,  1892,  1895,  1898,  1902,  1906,  1910,  1913,
    1917,  1920,  1924,  1928,  1933,  1936,  1939,  1942,  1946,  1950,
    1954,  1957,  1961,  1965,  1970,  1972,  1973,  1976,  1980,  1982,
    1983,  1985,  1988,  1989,  1992,  1993,  1995,  1999,  2000,  2001,
    2004,  2005,  2009,  2010,  2014,  2019,  2021,  2022,  2027,  2034,
    2041,  2048,  2056,  2063,  2071,  2077,  2078,  2081,  2085,  2088,
    2092,  2096,  2099,  2103,  2106,  2109,  2113,  2117,  2123,  2128,
    2133,  2136,  2138,  2141,  2144,  2145,  2149,  2150,  2154,  2157,
    2158,  2162,  2168,  2169,  2174,  2179,  2183,  2186,  2190,  2194,
    2198,  2202,  2207,  2212,  2215,  2216,  2220,  2221,  2225,  2229,
    2233,  2234,  2235,  2239,  2240,  2244,  2249,  2251,  2254,  2257,
    2260,  2265,  2270,  2271,  2272,  2276,  2277,  2281,  2285,  2287,
    2288,  2289,  2292,  2295,  2296,  2297,  2301,  2303,  2309,  2311,
    2312,  2313,  2316,  2319,  2320,  2321,  2325,  2327,  2333,  2335,
    2338,  2339,  2342,  2345,  2349,  2353,  2358,  2363,  2368,  2374,
    2380,  2385,  2389,  2394,  2399,  2404,  2409,  2411,  2413,  2415,
    2417,  2419,  2421,  2423,  2425,  2426,  2429,  2432,  2435,  2439,
    2443,  2448,  2449,  2453,  2454,  2458,  2459,  2463,  2466,  2470,
    2474,  2480,  2486,  2490,  2493,  2497,  2501,  2503,  2506,  2511,
    2515,  2519,  2523,  2526,  2529,  2532,  2535,  2538,  2543,  2545,
    2547,  2549,  2551,  2553,  2555,  2557,  2559,  2561,  2563,  2565,
    2567,  2569,  2571,  2573,  2575,  2577,  2579,  2581,  2583,  2585,
    2587,  2589,  2591,  2593,  2595,  2597,  2599,  2601,  2603,  2605,
    2607,  2609,  2611,  2613,  2615,  2617,  2619,  2621,  2623,  2625,
    2627,  2629,  2631,  2633,  2635,  2637,  2639,  2641,  2643,  2645,
    2647,  2649,  2651,  2653,  2655,  2657,  2659,  2661,  2664,  2667,
    2670,  2673,  2676,  2679,  2681,  2684,  2687,  2691,  2695,  2699,
    2703,  2707,  2711,  2715,  2717,  2719,  2721,  2723,  2725,  2727,
    2729,  2731,  2733,  2735,  2737,  2739,  2741,  2743,  2745,  2747,
    2749,  2751,  2753,  2755,  2757,  2759
};

/* YYRHS -- A `-1'-separated list of the rules' RHS.  */
static const yytype_int16 yyrhs[] =
{
     376,     0,    -1,   377,     3,    -1,     4,   639,    -1,    -1,
     377,   638,    -1,    33,    19,    22,   537,   365,    -1,    15,
      -1,   366,   537,   367,    -1,    19,    -1,   379,    -1,    34,
      -1,    36,    -1,    35,    -1,    37,    -1,    -1,    18,    -1,
      19,    -1,    -1,    30,    19,    -1,   381,   385,    -1,   383,
      -1,   381,    -1,    29,   379,    -1,   368,   381,    -1,    20,
      -1,    20,    -1,    -1,    38,   390,   391,   365,    -1,    57,
      20,    -1,    -1,    20,    -1,    39,   389,    -1,    50,    -1,
      40,    -1,   369,   392,   370,    -1,   393,    -1,   392,   371,
     393,    -1,    41,    -1,    42,    -1,    43,    -1,    44,    -1,
      45,    -1,    46,    -1,    47,    -1,    48,    -1,    49,    -1,
     129,   105,   444,   365,    -1,   129,    20,   365,    -1,   139,
      -1,    78,    -1,    56,    -1,    38,    -1,   395,    20,    -1,
     395,    20,   379,    20,    -1,   395,    53,    54,    -1,   395,
      53,    55,    -1,    52,   396,   365,    -1,    62,   404,   405,
       3,    -1,    62,    51,   404,   405,     3,    -1,    62,    58,
       3,    -1,    62,    59,     3,    -1,    62,    60,   404,     3,
      -1,    63,     3,    -1,    -1,    20,    -1,    -1,    61,    -1,
      61,   379,    -1,   421,    64,    -1,    65,   380,    -1,    66,
      67,   379,    -1,    68,   380,    -1,    69,    70,   380,    -1,
     421,    69,    -1,    66,    67,   379,    -1,   107,   387,   384,
      -1,    64,    73,   379,    -1,    76,    77,   412,   365,    -1,
      76,    77,   100,   435,   365,    -1,    15,    -1,    17,    -1,
      18,    -1,   117,   118,   414,   365,    -1,    -1,   414,   415,
      -1,   121,   381,    -1,   122,   379,    -1,   119,    -1,   120,
      -1,    -1,   125,    -1,    73,    19,   416,    -1,   114,    73,
      19,    -1,    -1,   419,   114,   383,   115,    15,   203,    15,
     365,    -1,   418,    -1,   418,   369,   419,   370,    -1,    78,
      -1,    79,    -1,    -1,    19,    -1,    19,   100,    19,    -1,
      -1,    80,   379,    -1,    81,   380,    -1,    41,   441,    -1,
     129,   444,    -1,    84,   424,    -1,    85,   424,    -1,    90,
      91,   426,    -1,    84,    91,   426,    -1,    85,    91,   426,
      -1,    84,    97,    98,   380,    -1,    73,   427,    -1,    76,
      77,   412,    -1,   124,    20,    -1,    86,   501,    -1,   502,
      -1,    40,    -1,    87,    -1,    -1,    92,    93,    -1,    92,
      94,    -1,    92,    95,    -1,    92,    96,    -1,   379,   425,
      -1,    35,    -1,    19,    -1,    41,   105,   441,    -1,    41,
     111,   379,    -1,    -1,    20,    -1,   384,    -1,    20,   384,
      -1,    -1,    27,    -1,   429,   431,   430,    -1,   432,    -1,
     433,   371,   432,    -1,    -1,   434,   433,    -1,   134,   379,
      -1,   135,   379,    -1,   421,    82,    -1,   437,   422,   369,
      -1,   438,   423,   365,    -1,   438,   440,   365,    -1,    -1,
      83,   439,   433,    -1,    40,    -1,    35,    -1,   369,   442,
     370,    -1,   443,    -1,   442,   371,   443,    -1,    88,    -1,
      70,    -1,    89,    -1,   106,    -1,   103,    -1,   104,    -1,
      40,    -1,    35,    -1,   369,   445,   370,    -1,   446,    -1,
     445,   371,   446,    -1,    88,    -1,   130,    -1,   123,   369,
     448,   370,    -1,   449,    -1,    -1,   449,   365,   448,    -1,
     450,   369,   451,   370,    -1,   450,    -1,    99,    20,    -1,
      -1,   113,   100,   386,   365,   451,    -1,   113,   102,   386,
     365,   451,    -1,   156,   100,   386,   365,   451,    -1,   156,
     102,   386,   365,   451,    -1,    77,   379,   365,   451,    -1,
     136,   137,     3,    -1,   136,   132,     3,    -1,   136,   105,
     492,     3,    -1,   136,   105,    40,   492,     3,    -1,    19,
      -1,    -1,   136,   106,     3,    -1,   136,   106,   138,     3,
      -1,   136,   139,   460,     3,    -1,    -1,   460,   383,    -1,
     460,   110,   384,    -1,   460,    73,    19,    -1,   460,    86,
     501,    -1,   460,   502,    -1,   460,    40,    -1,   460,   107,
      -1,   460,    98,    -1,   460,   461,    19,    -1,   460,    78,
      19,    -1,   460,   108,    -1,   460,   109,    -1,   112,    -1,
      85,    -1,   136,   114,   463,     3,    -1,    -1,   463,   464,
     383,    -1,   463,   203,    15,    -1,   463,    73,    19,    -1,
      -1,   127,    -1,   110,    -1,   136,   140,   466,     3,    -1,
      -1,   466,    73,    -1,   466,   151,    -1,   466,    86,    -1,
     466,    78,    -1,   466,    79,    -1,   466,   114,    -1,   466,
      19,    -1,    -1,    73,    19,    -1,   141,   114,   383,   115,
      15,   203,    15,   467,     3,    -1,   142,   114,   383,   115,
      15,   203,    15,   467,     3,    -1,   116,   114,   467,     3,
      -1,   143,   144,     3,    -1,   143,   145,     3,    -1,   143,
     106,     3,    -1,   143,   146,     3,    -1,   143,   147,     3,
      -1,   143,    70,     3,    -1,   143,   105,     3,    -1,   148,
     537,     3,    -1,   149,   480,   481,     3,    -1,    40,    -1,
      35,    -1,   369,   392,   370,    -1,    -1,    15,    -1,    96,
     491,     3,    -1,   150,   491,     3,    -1,    95,   491,     3,
      -1,   126,   491,     3,    -1,   126,   127,   491,     3,    -1,
     126,   128,   491,     3,    -1,    41,   491,   441,     3,    -1,
     129,   491,   444,     3,    -1,   131,     3,    -1,    19,    -1,
      40,    -1,    20,    -1,    19,    -1,    -1,    20,    -1,    -1,
      86,    19,   494,   500,    -1,   148,   537,    -1,   159,    -1,
     160,    -1,   161,    -1,   162,    -1,   163,    -1,   164,    -1,
     165,    -1,   167,    -1,   168,    -1,   169,    -1,   170,    -1,
     171,    -1,   496,   166,    -1,   496,    19,    -1,    -1,   497,
     365,   498,    -1,   497,    -1,   497,   365,   499,    -1,   504,
      -1,    19,    -1,   500,    -1,   200,   537,    -1,   366,   499,
     367,    -1,   366,   367,    -1,   498,   369,   507,   370,    -1,
      -1,   151,    19,   506,   503,   504,    -1,    -1,   508,    -1,
     543,    -1,   508,   543,    -1,   543,    -1,   369,   507,   370,
      -1,    18,    -1,   379,    -1,    17,    -1,   510,    -1,    16,
      -1,    15,    -1,   366,   537,   367,    -1,    17,    -1,   510,
      -1,    16,    -1,   537,    -1,   513,    -1,   513,     7,   513,
      -1,    28,    -1,   366,   514,   371,   514,   367,    -1,   366,
     514,   371,   514,   367,     7,   366,   513,   371,   513,   367,
      -1,   537,    -1,   178,    -1,   179,    -1,   180,    15,    -1,
     181,    -1,   366,   517,   371,   516,   371,   516,   367,    -1,
     366,   517,   371,   516,   371,   516,     7,   516,   367,    -1,
     366,   517,   371,   516,   371,    28,   367,    -1,   515,    -1,
     518,    -1,   511,    -1,   511,     7,   511,    -1,   515,    -1,
     518,    -1,   512,    -1,   512,     7,   512,    -1,   519,    -1,
     521,   371,   519,    -1,   520,    -1,   522,   371,   520,    -1,
      18,    29,    15,    -1,   523,    -1,   523,    26,    -1,   523,
      27,    -1,   523,   369,    15,   371,    15,   370,    -1,   524,
      -1,   525,   371,   524,    -1,    -1,   526,   522,   368,   507,
      -1,   526,     6,   507,    -1,   535,    -1,   366,   537,   367,
      -1,    13,   529,    14,    -1,    29,   530,    29,    -1,    15,
     529,    -1,    28,   529,    -1,   372,   529,    -1,   527,   529,
      -1,    -1,    15,   530,    -1,   372,   530,    -1,    -1,    15,
      -1,   176,    -1,   177,    -1,    20,    -1,   510,    -1,   523,
      -1,    17,    -1,   373,   521,   374,    -1,   373,   525,   374,
      -1,    16,    -1,   528,    -1,   366,   537,   371,   537,   367,
      -1,   366,   517,   371,   537,   371,   537,   367,    -1,    -1,
      19,   366,   542,   367,    -1,    19,    -1,   100,    -1,   182,
      -1,   183,    -1,   185,    -1,   186,    -1,   187,    -1,   188,
      -1,   189,    -1,   366,   537,   367,    -1,   537,    26,   537,
      -1,   537,    27,   537,    -1,   537,    28,   537,    -1,   537,
      29,   537,    -1,   537,    11,   537,    -1,   537,    12,   537,
      -1,   537,    22,   537,    -1,   537,    10,   537,    -1,   537,
      23,   537,    -1,   537,     9,   537,    -1,   537,    24,   537,
      -1,   537,     8,   537,    -1,   537,    25,   537,    -1,    31,
     537,    -1,   191,   366,   537,   367,    -1,   535,    -1,   531,
      -1,   532,    -1,    80,    -1,   533,   536,    -1,   533,   643,
      -1,   537,    32,   161,    -1,   537,    32,   190,    -1,   537,
      32,   184,   366,   537,   367,    -1,   537,    32,   195,    -1,
     537,    32,   196,    -1,    26,   199,    26,    -1,    27,   199,
      27,    -1,    27,    27,   199,    27,    27,    -1,   194,   366,
     537,   371,   537,   367,    -1,   141,   366,   537,   371,   537,
     367,    -1,   142,   366,   537,   371,   537,   367,    -1,    86,
     366,   537,   371,   537,   367,    -1,   198,   366,    19,   367,
      -1,   198,   366,    19,   371,   537,   371,   537,   367,    -1,
      19,   366,   542,   367,    -1,   158,    -1,   156,    -1,   157,
      -1,    46,    -1,   152,    -1,   153,    -1,   537,    -1,    -1,
     539,    -1,   539,   371,   540,    -1,   537,    -1,   537,   371,
     541,    -1,    -1,   541,    -1,   172,   537,   173,   509,    -1,
     172,   537,   173,   509,   174,   509,    -1,    19,    22,   537,
     365,    -1,   155,   537,   365,    -1,   533,   643,    22,   537,
     365,    -1,   533,   536,    22,   537,   365,    -1,    80,    22,
     537,   365,    -1,   154,   366,   533,   643,   367,   365,    -1,
     538,   540,   365,    -1,   534,   365,    -1,   175,   537,   369,
     526,   370,    -1,   533,   643,    32,   199,   365,    -1,   533,
     643,    32,   194,   366,   537,   367,   365,    -1,   533,   643,
      32,   141,   366,   537,   367,   365,    -1,   533,   643,    32,
     142,   366,   537,   367,   365,    -1,   533,   643,    32,    86,
     366,   537,   367,   365,    -1,   421,   118,    -1,   544,   422,
     369,    -1,   545,   423,   365,    -1,   545,   201,   203,   379,
     365,    -1,   545,   201,   381,   203,   379,   365,    -1,   545,
     202,   381,   382,   203,   379,   365,    -1,   545,   231,   234,
      77,   412,   365,    -1,   545,   231,   233,   365,    -1,   545,
     232,   233,   365,    -1,   545,   204,    67,   379,   365,    -1,
     545,   209,   204,    67,   379,   365,    -1,   545,   205,   206,
      67,   379,   365,    -1,   545,   207,    67,   379,   365,    -1,
     545,   208,   365,    -1,   545,   208,   379,   365,    -1,   545,
     211,   212,   213,   365,    -1,   545,   211,   212,    97,   365,
      -1,   545,   241,   242,   213,   365,    -1,   545,   241,   242,
     243,   365,    -1,   545,   241,   242,   244,   365,    -1,   545,
     251,    82,   365,    -1,   545,   251,   252,   365,    -1,   545,
     215,   216,   380,   365,    -1,   545,   253,   216,   380,   365,
      -1,   545,   250,   216,   380,   365,    -1,   545,   239,   240,
     380,   365,    -1,   545,   256,   253,   380,   365,    -1,   545,
     214,   224,   379,   365,    -1,   545,   214,   223,   379,   365,
      -1,   545,   186,   121,   381,   365,    -1,   545,   217,   218,
      67,   379,   365,    -1,   545,    46,   219,    67,   379,   365,
      -1,   545,    46,   220,    67,   379,   371,   379,   365,    -1,
     545,    96,   221,    46,   380,   365,    -1,   545,   150,   139,
     245,   380,   365,    -1,   545,   150,   235,   380,   365,    -1,
     545,   238,   380,   365,    -1,   545,   236,   237,   380,   365,
      -1,   545,    99,    20,   365,    -1,   545,   139,    91,   379,
     365,    -1,   545,   101,   380,   365,    -1,   545,   246,   247,
     380,   365,    -1,   545,   257,   380,   365,    -1,   545,   250,
      73,   427,   365,    -1,   545,   254,   255,   380,   365,    -1,
     421,   258,    -1,   546,   422,   369,    -1,   547,   548,   365,
      -1,   423,    -1,   264,   380,    -1,   265,    76,   380,    -1,
     302,   380,    -1,   302,   380,    91,   379,    -1,   266,   379,
      -1,   550,    -1,   259,   412,    -1,   549,   369,   551,   370,
      -1,    -1,   551,   552,   365,    -1,   265,   380,    -1,   304,
      -1,   138,   380,    -1,   214,   304,   380,    -1,   214,   267,
     379,    -1,   214,   268,   379,    -1,   265,   267,   379,    -1,
     305,   380,    -1,   305,   306,   379,    -1,    -1,   289,   553,
     369,   564,   370,    -1,    -1,   300,   554,   369,   564,   370,
      -1,   298,   555,    -1,    83,   575,    -1,   559,    -1,   556,
     369,   557,   370,    -1,   556,    -1,   383,    -1,    -1,   557,
     558,   365,    -1,   290,   380,    -1,   138,   380,    -1,   267,
     379,    -1,   562,   572,   369,   560,   370,    -1,   562,   572,
      -1,    -1,   560,   561,   365,    -1,    -1,   270,   379,    -1,
     269,   379,    -1,   271,   218,   379,    -1,   220,   379,    -1,
     273,   379,    -1,   273,   109,   379,    -1,   284,    87,    -1,
     284,   283,    -1,   284,   286,    -1,   447,    -1,   291,   292,
     412,    -1,   267,   379,    -1,   270,   379,    -1,   288,   379,
      -1,   269,   379,    -1,   220,   379,    -1,   273,   379,    -1,
     273,   109,   379,    -1,   274,   275,    -1,   274,   276,    -1,
     274,   277,    -1,   274,   278,    -1,   274,   279,    -1,   274,
     280,    -1,   274,   281,    -1,   274,   282,    -1,   310,   275,
     380,    -1,   280,   311,   380,    -1,   271,   218,   379,    -1,
     272,   379,    -1,   285,   277,   380,    -1,   265,   380,    -1,
      60,   292,   380,    -1,   302,   303,   379,    -1,   146,   369,
     568,   370,    -1,   284,    87,    -1,   284,   283,    -1,   284,
     286,    -1,   294,   295,   296,    -1,   294,   295,   297,    -1,
     294,   295,   379,    -1,   312,   436,    -1,   312,   272,   379,
      -1,   254,   255,   380,    -1,   254,   255,   312,   293,    -1,
     447,    -1,    -1,   564,   565,    -1,   566,   567,   365,    -1,
     383,    -1,    -1,   290,    -1,   299,   379,    -1,    -1,   568,
     570,    -1,    -1,   287,    -1,    18,   569,   365,    -1,    -1,
      -1,   309,   379,    -1,    -1,   573,   563,   365,    -1,    -1,
     369,   573,   370,    -1,   571,   433,   572,   574,    -1,    20,
      -1,    -1,   136,   258,   456,     3,    -1,   136,   258,   146,
     456,   576,     3,    -1,   136,   258,    83,   456,   576,     3,
      -1,   136,   258,   313,   456,   576,     3,    -1,   136,   258,
     313,    40,   456,   576,     3,    -1,   136,   258,   314,   456,
     576,     3,    -1,   136,   258,   314,    40,   456,   576,     3,
      -1,   136,   258,   301,   585,     3,    -1,    -1,   585,   307,
      -1,   585,   259,   412,    -1,   585,   292,    -1,   585,   274,
      15,    -1,   585,   308,   412,    -1,   585,   213,    -1,   585,
      76,   412,    -1,   585,    19,    -1,   421,   315,    -1,   586,
     422,   369,    -1,   587,   423,   365,    -1,   587,   316,    73,
      19,   365,    -1,   587,   317,   318,   365,    -1,   587,   317,
     319,   365,    -1,   421,   320,    -1,   423,    -1,    83,   601,
      -1,   162,   607,    -1,    -1,   339,   590,   613,    -1,    -1,
     340,   591,   619,    -1,   343,   383,    -1,    -1,   592,   589,
     365,    -1,   588,   422,   369,   592,   370,    -1,    -1,   321,
     322,   323,   379,    -1,   115,   322,   323,   379,    -1,   321,
     218,   379,    -1,   324,   380,    -1,   325,   326,   380,    -1,
     292,   327,   379,    -1,   328,    67,   379,    -1,   329,   330,
     379,    -1,   331,   212,    91,   379,    -1,   214,   335,   379,
     621,    -1,   162,   607,    -1,    -1,   339,   596,   613,    -1,
      -1,   340,   597,   619,    -1,   339,   201,   380,    -1,   340,
     201,   380,    -1,    -1,    -1,   599,   595,   365,    -1,    -1,
     369,   599,   370,    -1,   594,   433,   600,   598,    -1,   383,
      -1,   336,   380,    -1,   337,   380,    -1,   338,   380,    -1,
     332,   335,   379,   621,    -1,   333,   335,   379,   621,    -1,
      -1,    -1,   605,   603,   365,    -1,    -1,   369,   605,   370,
      -1,   602,   606,   604,    -1,   381,    -1,    -1,    -1,   341,
     608,    -1,   335,   620,    -1,    -1,    -1,   612,   610,   365,
      -1,   608,    -1,   369,   609,   612,   370,   611,    -1,    20,
      -1,    -1,    -1,   342,   614,    -1,   335,   620,    -1,    -1,
      -1,   618,   616,   365,    -1,   614,    -1,   369,   615,   618,
     370,   617,    -1,   379,    -1,   334,   379,    -1,    -1,   344,
     380,    -1,   421,   345,    -1,   622,   422,   369,    -1,   623,
     423,   365,    -1,   623,   346,   379,   365,    -1,   623,   122,
     379,   365,    -1,   623,   347,   379,   365,    -1,   623,   348,
      67,   379,   365,    -1,   623,    61,    67,   379,   365,    -1,
     623,   284,   624,   365,    -1,   623,   447,   365,    -1,   623,
     355,   357,   365,    -1,   623,   355,   202,   365,    -1,   623,
     355,   356,   365,    -1,   623,    83,   630,   365,    -1,   353,
      -1,   354,    -1,    87,    -1,   275,    -1,   349,    -1,   350,
      -1,   351,    -1,   352,    -1,    -1,   216,   379,    -1,   317,
     625,    -1,   312,   436,    -1,   312,   272,   379,    -1,   254,
     255,   380,    -1,   254,   255,   312,   293,    -1,    -1,   627,
     626,   365,    -1,    -1,   369,   627,   370,    -1,    -1,   629,
     433,   628,    -1,   421,   360,    -1,   631,   422,   369,    -1,
     632,   423,   365,    -1,   632,    60,   292,   380,   365,    -1,
     632,   250,    73,   427,   365,    -1,   632,   636,   365,    -1,
     139,   383,    -1,   210,   381,   382,    -1,   634,   303,   379,
      -1,   634,    -1,   635,   634,    -1,   633,   210,   381,   382,
      -1,   633,   210,    20,    -1,   633,   362,   635,    -1,   633,
     252,   381,    -1,   633,   243,    -1,   633,   157,    -1,   633,
     363,    -1,   633,   364,    -1,   633,   361,    -1,   136,   360,
     456,     3,    -1,   365,    -1,   378,    -1,   388,    -1,   394,
      -1,   397,    -1,   411,    -1,   413,    -1,   417,    -1,   420,
      -1,   640,    -1,   428,    -1,   493,    -1,   495,    -1,   505,
      -1,   398,    -1,   399,    -1,   400,    -1,   401,    -1,   402,
      -1,   403,    -1,   452,    -1,   453,    -1,   454,    -1,   455,
      -1,   457,    -1,   458,    -1,   459,    -1,   462,    -1,   465,
      -1,   468,    -1,   469,    -1,   470,    -1,   471,    -1,   472,
      -1,   473,    -1,   474,    -1,   475,    -1,   476,    -1,   477,
      -1,   478,    -1,   479,    -1,   482,    -1,   483,    -1,   484,
      -1,   485,    -1,   486,    -1,   487,    -1,   488,    -1,   489,
      -1,   490,    -1,   577,    -1,   578,    -1,   579,    -1,   580,
      -1,   581,    -1,   582,    -1,   583,    -1,   584,    -1,   637,
      -1,   641,   370,    -1,   642,   370,    -1,   438,   370,    -1,
     545,   370,    -1,   547,   370,    -1,   587,   370,    -1,   593,
      -1,   623,   370,    -1,   632,   370,    -1,   406,   422,   369,
      -1,   641,   423,   365,    -1,   641,   407,   365,    -1,   641,
     410,   365,    -1,   408,   422,   369,    -1,   642,   423,   365,
      -1,   642,   409,   365,    -1,    71,    -1,    72,    -1,    74,
      -1,    75,    -1,   133,    -1,     5,    -1,   225,    -1,   222,
      -1,   226,    -1,   224,    -1,   223,    -1,   227,    -1,   228,
      -1,   229,    -1,   248,    -1,   249,    -1,   230,    -1,   260,
      -1,   261,    -1,   262,    -1,   263,    -1,   358,    -1,   359,
      -1
};

/* YYRLINE[YYN] -- source line where rule number YYN was defined.  */
static const yytype_uint16 yyrline[] =
{
       0,   684,   684,   685,   688,   690,   698,   707,   708,   709,
     719,   720,   721,   722,   723,   724,   730,   731,   738,   739,
     743,   750,   751,   755,   759,   766,   774,   775,   781,   790,
     791,   795,   800,   801,   805,   806,   810,   811,   815,   816,
     817,   818,   819,   820,   821,   822,   823,   829,   830,   839,
     840,   841,   842,   845,   846,   847,   848,   852,   859,   862,
     869,   872,   875,   878,   882,   883,   887,   888,   889,   897,
     902,   903,   907,   914,   920,   925,   929,   943,   957,   958,
     962,   963,   964,   975,   977,   979,   983,   984,   985,   986,
     993,   994,   998,  1006,  1010,  1012,  1018,  1019,  1026,  1027,
    1031,  1037,  1041,  1051,  1053,  1057,  1058,  1059,  1060,  1061,
    1062,  1063,  1064,  1065,  1066,  1067,  1068,  1072,  1073,  1074,
    1075,  1079,  1080,  1081,  1082,  1083,  1087,  1093,  1097,  1105,
    1106,  1114,  1122,  1123,  1124,  1128,  1129,  1133,  1138,  1139,
    1142,  1150,  1154,  1155,  1161,  1168,  1169,  1170,  1174,  1182,
    1188,  1189,  1190,  1194,  1195,  1199,  1200,  1201,  1202,  1203,
    1204,  1210,  1211,  1212,  1216,  1217,  1221,  1222,  1228,  1229,
    1232,  1234,  1238,  1239,  1243,  1261,  1262,  1263,  1264,  1265,
    1266,  1274,  1277,  1280,  1283,  1287,  1288,  1291,  1294,  1298,
    1302,  1307,  1313,  1320,  1325,  1330,  1335,  1339,  1343,  1347,
    1357,  1365,  1369,  1376,  1377,  1382,  1386,  1393,  1400,  1404,
    1412,  1413,  1414,  1419,  1423,  1426,  1427,  1428,  1429,  1430,
    1431,  1432,  1437,  1442,  1450,  1457,  1464,  1472,  1474,  1476,
    1478,  1480,  1482,  1484,  1487,  1491,  1497,  1498,  1499,  1503,
    1504,  1510,  1512,  1514,  1516,  1518,  1520,  1524,  1528,  1531,
    1535,  1536,  1537,  1541,  1542,  1543,  1551,  1551,  1561,  1565,
    1566,  1567,  1568,  1569,  1570,  1571,  1572,  1573,  1574,  1575,
    1576,  1577,  1598,  1609,  1610,  1617,  1618,  1625,  1634,  1638,
    1642,  1666,  1667,  1671,  1684,  1684,  1700,  1701,  1704,  1705,
    1709,  1712,  1721,  1734,  1735,  1736,  1737,  1741,  1742,  1743,
    1744,  1745,  1749,  1752,  1753,  1754,  1758,  1761,  1770,  1773,
    1774,  1775,  1776,  1780,  1781,  1782,  1786,  1787,  1788,  1789,
    1793,  1794,  1795,  1796,  1800,  1801,  1805,  1806,  1810,  1817,
    1818,  1819,  1820,  1827,  1828,  1831,  1832,  1839,  1851,  1852,
    1856,  1857,  1861,  1862,  1863,  1864,  1865,  1869,  1870,  1871,
    1875,  1876,  1877,  1878,  1879,  1880,  1881,  1882,  1883,  1884,
    1885,  1889,  1890,  1900,  1904,  1927,  1941,  1943,  1944,  1945,
    1946,  1947,  1948,  1949,  1953,  1954,  1955,  1956,  1957,  1958,
    1959,  1960,  1961,  1962,  1963,  1964,  1965,  1966,  1967,  1968,
    1970,  1971,  1972,  1974,  1976,  1978,  1980,  1981,  1982,  1983,
    1984,  1994,  1995,  1996,  1997,  1998,  1999,  2000,  2002,  2003,
    2008,  2031,  2032,  2033,  2034,  2035,  2036,  2040,  2043,  2044,
    2045,  2053,  2060,  2069,  2070,  2074,  2080,  2090,  2099,  2105,
    2110,  2117,  2122,  2128,  2129,  2130,  2138,  2139,  2140,  2141,
    2142,  2148,  2169,  2170,  2171,  2172,  2173,  2183,  2184,  2185,
    2186,  2187,  2188,  2189,  2190,  2191,  2192,  2193,  2194,  2195,
    2196,  2197,  2198,  2199,  2200,  2201,  2202,  2203,  2204,  2205,
    2206,  2207,  2208,  2209,  2210,  2211,  2212,  2213,  2214,  2215,
    2216,  2221,  2222,  2223,  2224,  2225,  2236,  2246,  2247,  2251,
    2252,  2253,  2254,  2255,  2256,  2257,  2260,  2275,  2278,  2280,
    2284,  2285,  2286,  2287,  2288,  2289,  2290,  2291,  2292,  2293,
    2293,  2294,  2294,  2295,  2296,  2297,  2301,  2302,  2306,  2314,
    2316,  2320,  2321,  2322,  2326,  2327,  2330,  2332,  2335,  2336,
    2337,  2338,  2339,  2340,  2341,  2342,  2343,  2344,  2345,  2348,
    2370,  2371,  2372,  2373,  2374,  2375,  2376,  2377,  2378,  2379,
    2380,  2381,  2382,  2383,  2384,  2385,  2386,  2387,  2388,  2389,
    2390,  2391,  2392,  2393,  2394,  2395,  2396,  2397,  2398,  2399,
    2400,  2401,  2402,  2403,  2404,  2407,  2409,  2412,  2414,  2423,
    2425,  2426,  2429,  2431,  2435,  2436,  2439,  2449,  2472,  2474,
    2477,  2479,  2482,  2484,  2488,  2492,  2493,  2498,  2501,  2504,
    2509,  2512,  2517,  2520,  2524,  2528,  2531,  2532,  2533,  2534,
    2535,  2536,  2537,  2538,  2544,  2551,  2552,  2553,  2558,  2559,
    2565,  2575,  2576,  2577,  2578,  2578,  2579,  2579,  2580,  2587,
    2589,  2593,  2597,  2614,  2615,  2616,  2617,  2618,  2619,  2620,
    2621,  2622,  2623,  2628,  2629,  2629,  2630,  2630,  2631,  2632,
    2636,  2654,  2656,  2659,  2661,  2665,  2668,  2681,  2682,  2683,
    2684,  2689,  2697,  2705,  2707,  2710,  2712,  2716,  2720,  2730,
    2735,  2736,  2737,  2741,  2753,  2755,  2759,  2760,  2764,  2777,
    2782,  2783,  2784,  2788,  2800,  2802,  2806,  2807,  2812,  2813,
    2817,  2818,  2824,  2831,  2832,  2833,  2834,  2835,  2836,  2837,
    2838,  2839,  2840,  2841,  2842,  2843,  2847,  2848,  2849,  2854,
    2855,  2856,  2857,  2858,  2861,  2862,  2863,  2864,  2865,  2866,
    2867,  2870,  2872,  2875,  2877,  2881,  2893,  2900,  2907,  2908,
    2909,  2910,  2911,  2914,  2923,  2931,  2938,  2939,  2943,  2948,
    2954,  2957,  2962,  2963,  2964,  2965,  2966,  2969,  2976,  2976,
    2976,  2976,  2976,  2976,  2976,  2976,  2976,  2976,  2976,  2976,
    2976,  2976,  2977,  2977,  2977,  2977,  2977,  2977,  2977,  2977,
    2977,  2977,  2977,  2977,  2977,  2977,  2977,  2977,  2977,  2977,
    2977,  2977,  2977,  2977,  2977,  2977,  2977,  2977,  2977,  2977,
    2977,  2977,  2977,  2977,  2977,  2977,  2977,  2977,  2977,  2977,
    2977,  2977,  2977,  2977,  2977,  2977,  2977,  2978,  2978,  2978,
    2978,  2978,  2978,  2978,  2978,  2978,  2979,  2979,  2979,  2979,
    2980,  2980,  2980,  2981,  2981,  2981,  2981,  2981,  2982,  2982,
    2983,  2984,  2985,  2986,  2987,  2988,  2989,  2990,  2991,  2992,
    2993,  2993,  2993,  2993,  2993,  2993
};
#endif

#if YYDEBUG || YYERROR_VERBOSE || 0
/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "END", "CLI_MARKER", "INVALID_TOKEN",
  "ELSECOL", "DDOT", "GEQ", "LEQ", "NEQ", "AND", "OR", "PO", "PC", "NUM",
  "ENUM", "RTRID", "IPA", "SYM", "TEXT", "PREFIX_DUMMY", "'='", "'<'",
  "'>'", "'~'", "'+'", "'-'", "'*'", "'/'", "'%'", "'!'", "'.'", "DEFINE",
  "ON", "OFF", "YES", "NO", "LOG", "SYSLOG", "ALL", "DEBUG", "TRACE",
  "INFO", "REMOTE", "WARNING", "ERROR", "AUTH", "FATAL", "BUG", "STDERR",
  "SOFT", "TIMEFORMAT", "ISO", "SHORT", "LONG", "BASE", "NAME", "CONFIRM",
  "UNDO", "CHECK", "TIMEOUT", "CONFIGURE", "DOWN", "KERNEL", "PERSIST",
  "SCAN", "TIME", "LEARN", "DEVICE", "ROUTES", "KRT_SOURCE", "KRT_METRIC",
  "TABLE", "KRT_PREFSRC", "KRT_REALM", "ROUTER", "ID", "PROTOCOL",
  "TEMPLATE", "PREFERENCE", "DISABLED", "DIRECT", "INTERFACE", "IMPORT",
  "EXPORT", "FILTER", "NONE", "STATES", "FILTERS", "RECEIVE", "LIMIT",
  "ACTION", "WARN", "BLOCK", "RESTART", "DISABLE", "KEEP", "FILTERED",
  "PASSWORD", "FROM", "PASSIVE", "TO", "EVENTS", "PACKETS", "PROTOCOLS",
  "INTERFACES", "PRIMARY", "STATS", "COUNT", "FOR", "COMMANDS",
  "PREEXPORT", "GENERATE", "ROA", "MAX", "FLUSH", "LISTEN", "BGP",
  "V6ONLY", "DUAL", "ADDRESS", "PORT", "PASSWORDS", "DESCRIPTION",
  "SORTED", "RELOAD", "IN", "OUT", "MRTDUMP", "MESSAGES", "RESTRICT",
  "MEMORY", "IGP_METRIC", "CLASS", "DSCP", "SHOW", "STATUS", "SUMMARY",
  "ROUTE", "SYMBOLS", "ADD", "DELETE", "DUMP", "RESOURCES", "SOCKETS",
  "NEIGHBORS", "ATTRIBUTES", "EVAL", "ECHO", "ENABLE", "FUNCTION", "PRINT",
  "PRINTN", "UNSET", "RETURN", "ACCEPT", "REJECT", "QUITBIRD", "INT",
  "BOOL", "IP", "PREFIX", "PAIR", "QUAD", "EC", "SET", "STRING", "BGPMASK",
  "BGPPATH", "CLIST", "ECLIST", "IF", "THEN", "ELSE", "CASE", "TRUE",
  "FALSE", "RT", "RO", "UNKNOWN", "GENERIC", "GW", "NET", "MASK", "PROTO",
  "SOURCE", "SCOPE", "CAST", "DEST", "LEN", "DEFINED", "CONTAINS", "RESET",
  "PREPEND", "FIRST", "LAST", "MATCH", "ROA_CHECK", "EMPTY", "WHERE",
  "LOCAL", "NEIGHBOR", "AS", "HOLD", "CONNECT", "RETRY", "KEEPALIVE",
  "MULTIHOP", "STARTUP", "VIA", "NEXT", "HOP", "SELF", "DEFAULT", "PATH",
  "METRIC", "START", "DELAY", "FORGET", "WAIT", "AFTER", "BGP_PATH",
  "BGP_LOCAL_PREF", "BGP_MED", "BGP_ORIGIN", "BGP_NEXT_HOP",
  "BGP_ATOMIC_AGGR", "BGP_AGGREGATOR", "BGP_COMMUNITY",
  "BGP_EXT_COMMUNITY", "RR", "RS", "CLIENT", "CLUSTER", "AS4", "ADVERTISE",
  "IPV4", "CAPABILITIES", "PREFER", "OLDER", "MISSING", "LLADDR", "DROP",
  "IGNORE", "REFRESH", "INTERPRET", "COMMUNITIES", "BGP_ORIGINATOR_ID",
  "BGP_CLUSTER_LIST", "IGP", "GATEWAY", "RECURSIVE", "MED", "TTL",
  "SECURITY", "DETERMINISTIC", "SECONDARY", "OSPF", "AREA", "OSPF_METRIC1",
  "OSPF_METRIC2", "OSPF_TAG", "OSPF_ROUTER_ID", "RFC1583COMPAT", "STUB",
  "TICK", "COST", "COST2", "RETRANSMIT", "HELLO", "TRANSMIT", "PRIORITY",
  "DEAD", "TYPE", "BROADCAST", "BCAST", "NONBROADCAST", "NBMA",
  "POINTOPOINT", "PTP", "POINTOMULTIPOINT", "PTMP", "SIMPLE",
  "AUTHENTICATION", "STRICT", "CRYPTOGRAPHIC", "ELIGIBLE", "POLL",
  "NETWORKS", "HIDDEN", "VIRTUAL", "LINK", "ONLY", "RX", "BUFFER", "LARGE",
  "NORMAL", "STUBNET", "TAG", "EXTERNAL", "LSADB", "ECMP", "WEIGHT",
  "NSSA", "TRANSLATOR", "STABILITY", "GLOBAL", "LSID", "INSTANCE", "REAL",
  "NETMASK", "TX", "TOPOLOGY", "STATE", "PIPE", "PEER", "MODE", "OPAQUE",
  "TRANSPARENT", "RADV", "MIN", "RA", "INTERVAL", "MANAGED", "OTHER",
  "CONFIG", "MTU", "REACHABLE", "RETRANS", "TIMER", "CURRENT", "VALID",
  "PREFERRED", "MULT", "LIFETIME", "SKIP", "ONLINK", "AUTONOMOUS", "RDNSS",
  "DNSSL", "NS", "DOMAIN", "TRIGGER", "SENSITIVE", "RIP", "INFINITY",
  "PERIOD", "GARBAGE", "MULTICAST", "QUIET", "NOLISTEN", "VERSION1",
  "PLAINTEXT", "MD5", "HONOR", "NEVER", "ALWAYS", "RIP_METRIC", "RIP_TAG",
  "STATIC", "PROHIBIT", "MULTIPATH", "BLACKHOLE", "UNREACHABLE", "';'",
  "'('", "')'", "':'", "'{'", "'}'", "','", "'?'", "'['", "']'", "$accept",
  "config", "conf_entries", "definition", "expr", "bool", "ipa",
  "ipa_scope", "prefix", "prefix_or_ipa", "pxlen", "datetime",
  "text_or_none", "log_config", "syslog_name", "log_file", "log_mask",
  "log_mask_list", "log_cat", "mrtdump_base", "timeformat_which",
  "timeformat_spec", "timeformat_base", "cmd_CONFIGURE",
  "cmd_CONFIGURE_SOFT", "cmd_CONFIGURE_CONFIRM", "cmd_CONFIGURE_UNDO",
  "cmd_CONFIGURE_CHECK", "cmd_DOWN", "cfg_name", "cfg_timeout",
  "kern_proto_start", "kern_item", "kif_proto_start", "kif_item",
  "kern_sys_item", "rtrid", "idval", "listen", "listen_opts", "listen_opt",
  "tab_sorted", "newtab", "roa_table_start", "roa_table_opts", "roa_table",
  "proto_start", "proto_name", "proto_item", "imexport", "limit_action",
  "limit_spec", "rtable", "debug_default", "iface_patt_node_init",
  "iface_patt_node_body", "iface_negate", "iface_patt_node",
  "iface_patt_list", "iface_patt_init", "iface_patt", "tos",
  "dev_proto_start", "dev_proto", "dev_iface_init", "dev_iface_patt",
  "debug_mask", "debug_list", "debug_flag", "mrtdump_mask", "mrtdump_list",
  "mrtdump_flag", "password_list", "password_items", "password_item",
  "password_item_begin", "password_item_params", "cmd_SHOW_STATUS",
  "cmd_SHOW_MEMORY", "cmd_SHOW_PROTOCOLS", "cmd_SHOW_PROTOCOLS_ALL",
  "optsym", "cmd_SHOW_INTERFACES", "cmd_SHOW_INTERFACES_SUMMARY",
  "cmd_SHOW_ROUTE", "r_args", "export_or_preexport", "cmd_SHOW_ROA",
  "roa_args", "roa_mode", "cmd_SHOW_SYMBOLS", "sym_args", "roa_table_arg",
  "cmd_ADD_ROA", "cmd_DELETE_ROA", "cmd_FLUSH_ROA", "cmd_DUMP_RESOURCES",
  "cmd_DUMP_SOCKETS", "cmd_DUMP_INTERFACES", "cmd_DUMP_NEIGHBORS",
  "cmd_DUMP_ATTRIBUTES", "cmd_DUMP_ROUTES", "cmd_DUMP_PROTOCOLS",
  "cmd_EVAL", "cmd_ECHO", "echo_mask", "echo_size", "cmd_DISABLE",
  "cmd_ENABLE", "cmd_RESTART", "cmd_RELOAD", "cmd_RELOAD_IN",
  "cmd_RELOAD_OUT", "cmd_DEBUG", "cmd_MRTDUMP", "cmd_RESTRICT",
  "proto_patt", "proto_patt2", "filter_def", "$@1", "filter_eval", "type",
  "one_decl", "decls", "declsn", "filter_body", "filter", "where_filter",
  "function_params", "function_body", "function_def", "$@2", "cmds",
  "cmds_int", "block", "fipa", "set_atom", "switch_atom", "pair_expr",
  "pair_atom", "pair_item", "ec_expr", "ec_kind", "ec_item", "set_item",
  "switch_item", "set_items", "switch_items", "fprefix_s", "fprefix",
  "fprefix_set", "switch_body", "bgp_path_expr", "bgp_path",
  "bgp_path_tail1", "bgp_path_tail2", "constant", "constructor", "rtadot",
  "function_call", "symbol", "static_attr", "term", "break_command",
  "print_one", "print_list", "var_listn", "var_list", "cmd",
  "bgp_proto_start", "bgp_proto", "ospf_proto_start", "ospf_proto",
  "ospf_proto_item", "ospf_area_start", "ospf_area", "ospf_area_opts",
  "ospf_area_item", "$@3", "$@4", "ospf_stubnet", "ospf_stubnet_start",
  "ospf_stubnet_opts", "ospf_stubnet_item", "ospf_vlink",
  "ospf_vlink_opts", "ospf_vlink_item", "ospf_vlink_start",
  "ospf_iface_item", "pref_list", "pref_item", "pref_base", "pref_opt",
  "nbma_list", "nbma_eligible", "nbma_item", "ospf_iface_start",
  "ospf_instance_id", "ospf_iface_opts", "ospf_iface_opt_list",
  "ospf_iface", "opttext", "cmd_SHOW_OSPF", "cmd_SHOW_OSPF_NEIGHBORS",
  "cmd_SHOW_OSPF_INTERFACE", "cmd_SHOW_OSPF_TOPOLOGY",
  "cmd_SHOW_OSPF_TOPOLOGY_ALL", "cmd_SHOW_OSPF_STATE",
  "cmd_SHOW_OSPF_STATE_ALL", "cmd_SHOW_OSPF_LSADB", "lsadb_args",
  "pipe_proto_start", "pipe_proto", "radv_proto_start", "radv_proto_item",
  "$@5", "$@6", "radv_proto_opts", "radv_proto", "radv_iface_start",
  "radv_iface_item", "$@7", "$@8", "radv_iface_finish", "radv_iface_opts",
  "radv_iface_opt_list", "radv_iface", "radv_prefix_start",
  "radv_prefix_item", "radv_prefix_finish", "radv_prefix_opts",
  "radv_prefix_opt_list", "radv_prefix", "radv_rdnss_node",
  "radv_rdnss_start", "radv_rdnss_item", "radv_rdnss_finish",
  "radv_rdnss_opts", "radv_rdnss", "radv_dnssl_node", "radv_dnssl_start",
  "radv_dnssl_item", "radv_dnssl_finish", "radv_dnssl_opts", "radv_dnssl",
  "radv_mult", "radv_sensitive", "rip_cfg_start", "rip_cfg", "rip_auth",
  "rip_mode", "rip_iface_item", "rip_iface_opts", "rip_iface_opt_list",
  "rip_iface_init", "rip_iface", "static_proto_start", "static_proto",
  "stat_route0", "stat_multipath1", "stat_multipath", "stat_route",
  "cmd_SHOW_STATIC", "conf", "cli_cmd", "proto", "kern_proto", "kif_proto",
  "dynamic_attr", YY_NULL
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[YYLEX-NUM] -- Internal token number corresponding to
   token YYLEX-NUM.  */
static const yytype_uint16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,    61,    60,    62,   126,    43,    45,    42,    47,
      37,    33,    46,   277,   278,   279,   280,   281,   282,   283,
     284,   285,   286,   287,   288,   289,   290,   291,   292,   293,
     294,   295,   296,   297,   298,   299,   300,   301,   302,   303,
     304,   305,   306,   307,   308,   309,   310,   311,   312,   313,
     314,   315,   316,   317,   318,   319,   320,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,   333,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
     344,   345,   346,   347,   348,   349,   350,   351,   352,   353,
     354,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,   365,   366,   367,   368,   369,   370,   371,   372,   373,
     374,   375,   376,   377,   378,   379,   380,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,   392,   393,
     394,   395,   396,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   431,   432,   433,
     434,   435,   436,   437,   438,   439,   440,   441,   442,   443,
     444,   445,   446,   447,   448,   449,   450,   451,   452,   453,
     454,   455,   456,   457,   458,   459,   460,   461,   462,   463,
     464,   465,   466,   467,   468,   469,   470,   471,   472,   473,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   490,   491,   492,   493,
     494,   495,   496,   497,   498,   499,   500,   501,   502,   503,
     504,   505,   506,   507,   508,   509,   510,   511,   512,   513,
     514,   515,   516,   517,   518,   519,   520,   521,   522,   523,
     524,   525,   526,   527,   528,   529,   530,   531,   532,   533,
     534,   535,   536,   537,   538,   539,   540,   541,   542,   543,
     544,   545,   546,   547,   548,   549,   550,   551,   552,   553,
     554,   555,   556,   557,   558,   559,   560,   561,   562,   563,
     564,   565,   566,   567,   568,   569,   570,   571,   572,   573,
     574,   575,   576,   577,   578,   579,   580,   581,   582,   583,
     584,   585,   586,   587,   588,   589,   590,   591,   592,   593,
     594,   595,   596,   597,   598,   599,   600,   601,   602,   603,
     604,   605,   606,   607,   608,    59,    40,    41,    58,   123,
     125,    44,    63,    91,    93
};
# endif

/* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_uint16 yyr1[] =
{
       0,   375,   376,   376,   377,   377,   378,   379,   379,   379,
     380,   380,   380,   380,   380,   380,   381,   381,   382,   382,
     383,   384,   384,   385,   385,   386,   387,   387,   388,   389,
     389,   390,   390,   390,   391,   391,   392,   392,   393,   393,
     393,   393,   393,   393,   393,   393,   393,   394,   394,   395,
     395,   395,   395,   396,   396,   396,   396,   397,   398,   399,
     400,   401,   402,   403,   404,   404,   405,   405,   405,   406,
     407,   407,   407,   407,   408,   409,   409,   410,   411,   411,
     412,   412,   412,   413,   414,   414,   415,   415,   415,   415,
     416,   416,   417,   418,   419,   419,   420,   420,   421,   421,
     422,   422,   422,   423,   423,   423,   423,   423,   423,   423,
     423,   423,   423,   423,   423,   423,   423,   424,   424,   424,
     424,   425,   425,   425,   425,   425,   426,   426,   427,   428,
     428,   429,   430,   430,   430,   431,   431,   432,   433,   433,
     434,   435,   436,   436,   437,   438,   438,   438,   439,   440,
     441,   441,   441,   442,   442,   443,   443,   443,   443,   443,
     443,   444,   444,   444,   445,   445,   446,   446,   447,   447,
     448,   448,   449,   449,   450,   451,   451,   451,   451,   451,
     451,   452,   453,   454,   455,   456,   456,   457,   458,   459,
     460,   460,   460,   460,   460,   460,   460,   460,   460,   460,
     460,   460,   460,   461,   461,   462,   463,   463,   463,   463,
     464,   464,   464,   465,   466,   466,   466,   466,   466,   466,
     466,   466,   467,   467,   468,   469,   470,   471,   472,   473,
     474,   475,   476,   477,   478,   479,   480,   480,   480,   481,
     481,   482,   483,   484,   485,   486,   487,   488,   489,   490,
     491,   491,   491,   492,   492,   492,   494,   493,   495,   496,
     496,   496,   496,   496,   496,   496,   496,   496,   496,   496,
     496,   496,   497,   498,   498,   499,   499,   500,   501,   501,
     502,   503,   503,   504,   506,   505,   507,   507,   508,   508,
     509,   509,   510,   511,   511,   511,   511,   512,   512,   512,
     512,   512,   513,   514,   514,   514,   515,   515,   516,   517,
     517,   517,   517,   518,   518,   518,   519,   519,   519,   519,
     520,   520,   520,   520,   521,   521,   522,   522,   523,   524,
     524,   524,   524,   525,   525,   526,   526,   526,   527,   527,
     528,   528,   529,   529,   529,   529,   529,   530,   530,   530,
     531,   531,   531,   531,   531,   531,   531,   531,   531,   531,
     531,   532,   532,   533,   534,   535,   536,   536,   536,   536,
     536,   536,   536,   536,   537,   537,   537,   537,   537,   537,
     537,   537,   537,   537,   537,   537,   537,   537,   537,   537,
     537,   537,   537,   537,   537,   537,   537,   537,   537,   537,
     537,   537,   537,   537,   537,   537,   537,   537,   537,   537,
     537,   538,   538,   538,   538,   538,   538,   539,   540,   540,
     540,   541,   541,   542,   542,   543,   543,   543,   543,   543,
     543,   543,   543,   543,   543,   543,   543,   543,   543,   543,
     543,   544,   545,   545,   545,   545,   545,   545,   545,   545,
     545,   545,   545,   545,   545,   545,   545,   545,   545,   545,
     545,   545,   545,   545,   545,   545,   545,   545,   545,   545,
     545,   545,   545,   545,   545,   545,   545,   545,   545,   545,
     545,   545,   545,   545,   545,   545,   546,   547,   547,   548,
     548,   548,   548,   548,   548,   548,   549,   550,   551,   551,
     552,   552,   552,   552,   552,   552,   552,   552,   552,   553,
     552,   554,   552,   552,   552,   552,   555,   555,   556,   557,
     557,   558,   558,   558,   559,   559,   560,   560,   561,   561,
     561,   561,   561,   561,   561,   561,   561,   561,   561,   562,
     563,   563,   563,   563,   563,   563,   563,   563,   563,   563,
     563,   563,   563,   563,   563,   563,   563,   563,   563,   563,
     563,   563,   563,   563,   563,   563,   563,   563,   563,   563,
     563,   563,   563,   563,   563,   564,   564,   565,   566,   567,
     567,   567,   568,   568,   569,   569,   570,   571,   572,   572,
     573,   573,   574,   574,   575,   576,   576,   577,   578,   579,
     580,   581,   582,   583,   584,   585,   585,   585,   585,   585,
     585,   585,   585,   585,   586,   587,   587,   587,   587,   587,
     588,   589,   589,   589,   590,   589,   591,   589,   589,   592,
     592,   593,   594,   595,   595,   595,   595,   595,   595,   595,
     595,   595,   595,   595,   596,   595,   597,   595,   595,   595,
     598,   599,   599,   600,   600,   601,   602,   603,   603,   603,
     603,   603,   604,   605,   605,   606,   606,   607,   608,   609,
     610,   610,   610,   611,   612,   612,   613,   613,   614,   615,
     616,   616,   616,   617,   618,   618,   619,   619,   620,   620,
     621,   621,   622,   623,   623,   623,   623,   623,   623,   623,
     623,   623,   623,   623,   623,   623,   624,   624,   624,   625,
     625,   625,   625,   625,   626,   626,   626,   626,   626,   626,
     626,   627,   627,   628,   628,   629,   630,   631,   632,   632,
     632,   632,   632,   633,   634,   634,   635,   635,   636,   636,
     636,   636,   636,   636,   636,   636,   636,   637,   638,   638,
     638,   638,   638,   638,   638,   638,   638,   638,   638,   638,
     638,   638,   639,   639,   639,   639,   639,   639,   639,   639,
     639,   639,   639,   639,   639,   639,   639,   639,   639,   639,
     639,   639,   639,   639,   639,   639,   639,   639,   639,   639,
     639,   639,   639,   639,   639,   639,   639,   639,   639,   639,
     639,   639,   639,   639,   639,   639,   639,   640,   640,   640,
     640,   640,   640,   640,   640,   640,   641,   641,   641,   641,
     642,   642,   642,   643,   643,   643,   643,   643,   643,   643,
     643,   643,   643,   643,   643,   643,   643,   643,   643,   643,
     643,   643,   643,   643,   643,   643
};

/* YYR2[YYN] -- Number of symbols composing right hand side of rule YYN.  */
static const yytype_uint8 yyr2[] =
{
       0,     2,     2,     2,     0,     2,     5,     1,     3,     1,
       1,     1,     1,     1,     1,     0,     1,     1,     0,     2,
       2,     1,     1,     2,     2,     1,     1,     0,     4,     2,
       0,     1,     2,     1,     1,     3,     1,     3,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     4,     3,     1,
       1,     1,     1,     2,     4,     3,     3,     3,     4,     5,
       3,     3,     4,     2,     0,     1,     0,     1,     2,     2,
       2,     3,     2,     3,     2,     3,     3,     3,     4,     5,
       1,     1,     1,     4,     0,     2,     2,     2,     1,     1,
       0,     1,     3,     3,     0,     8,     1,     4,     1,     1,
       0,     1,     3,     0,     2,     2,     2,     2,     2,     2,
       3,     3,     3,     4,     2,     3,     2,     2,     1,     1,
       1,     0,     2,     2,     2,     2,     2,     1,     1,     3,
       3,     0,     1,     1,     2,     0,     1,     3,     1,     3,
       0,     2,     2,     2,     2,     3,     3,     3,     0,     3,
       1,     1,     3,     1,     3,     1,     1,     1,     1,     1,
       1,     1,     1,     3,     1,     3,     1,     1,     4,     1,
       0,     3,     4,     1,     2,     0,     5,     5,     5,     5,
       4,     3,     3,     4,     5,     1,     0,     3,     4,     4,
       0,     2,     3,     3,     3,     2,     2,     2,     2,     3,
       3,     2,     2,     1,     1,     4,     0,     3,     3,     3,
       0,     1,     1,     4,     0,     2,     2,     2,     2,     2,
       2,     2,     0,     2,     9,     9,     4,     3,     3,     3,
       3,     3,     3,     3,     3,     4,     1,     1,     3,     0,
       1,     3,     3,     3,     3,     4,     4,     4,     4,     2,
       1,     1,     1,     1,     0,     1,     0,     4,     2,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     2,     2,     0,     3,     1,     3,     1,     1,     1,
       2,     3,     2,     4,     0,     5,     0,     1,     1,     2,
       1,     3,     1,     1,     1,     1,     1,     1,     3,     1,
       1,     1,     1,     1,     3,     1,     5,    11,     1,     1,
       1,     2,     1,     7,     9,     7,     1,     1,     1,     3,
       1,     1,     1,     3,     1,     3,     1,     3,     3,     1,
       2,     2,     6,     1,     3,     0,     4,     3,     1,     3,
       3,     3,     2,     2,     2,     2,     0,     2,     2,     0,
       1,     1,     1,     1,     1,     1,     1,     3,     3,     1,
       1,     5,     7,     0,     4,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     2,     4,
       1,     1,     1,     1,     2,     2,     3,     3,     6,     3,
       3,     3,     3,     5,     6,     6,     6,     6,     4,     8,
       4,     1,     1,     1,     1,     1,     1,     1,     0,     1,
       3,     1,     3,     0,     1,     4,     6,     4,     3,     5,
       5,     4,     6,     3,     2,     5,     5,     8,     8,     8,
       8,     2,     3,     3,     5,     6,     7,     6,     4,     4,
       5,     6,     6,     5,     3,     4,     5,     5,     5,     5,
       5,     4,     4,     5,     5,     5,     5,     5,     5,     5,
       5,     6,     6,     8,     6,     6,     5,     4,     5,     4,
       5,     4,     5,     4,     5,     5,     2,     3,     3,     1,
       2,     3,     2,     4,     2,     1,     2,     4,     0,     3,
       2,     1,     2,     3,     3,     3,     3,     2,     3,     0,
       5,     0,     5,     2,     2,     1,     4,     1,     1,     0,
       3,     2,     2,     2,     5,     2,     0,     3,     0,     2,
       2,     3,     2,     2,     3,     2,     2,     2,     1,     3,
       2,     2,     2,     2,     2,     2,     3,     2,     2,     2,
       2,     2,     2,     2,     2,     3,     3,     3,     2,     3,
       2,     3,     3,     4,     2,     2,     2,     3,     3,     3,
       2,     3,     3,     4,     1,     0,     2,     3,     1,     0,
       1,     2,     0,     2,     0,     1,     3,     0,     0,     2,
       0,     3,     0,     3,     4,     1,     0,     4,     6,     6,
       6,     7,     6,     7,     5,     0,     2,     3,     2,     3,
       3,     2,     3,     2,     2,     3,     3,     5,     4,     4,
       2,     1,     2,     2,     0,     3,     0,     3,     2,     0,
       3,     5,     0,     4,     4,     3,     2,     3,     3,     3,
       3,     4,     4,     2,     0,     3,     0,     3,     3,     3,
       0,     0,     3,     0,     3,     4,     1,     2,     2,     2,
       4,     4,     0,     0,     3,     0,     3,     3,     1,     0,
       0,     2,     2,     0,     0,     3,     1,     5,     1,     0,
       0,     2,     2,     0,     0,     3,     1,     5,     1,     2,
       0,     2,     2,     3,     3,     4,     4,     4,     5,     5,
       4,     3,     4,     4,     4,     4,     1,     1,     1,     1,
       1,     1,     1,     1,     0,     2,     2,     2,     3,     3,
       4,     0,     3,     0,     3,     0,     3,     2,     3,     3,
       5,     5,     3,     2,     3,     3,     1,     2,     4,     3,
       3,     3,     2,     2,     2,     2,     2,     4,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     2,     2,     2,
       2,     2,     2,     1,     2,     2,     3,     3,     3,     3,
       3,     3,     3,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1
};

/* YYDEFACT[STATE-NAME] -- Default reduction number in state STATE-NUM.
   Performed when YYTABLE doesn't specify something else to do.  Zero
   means the default is an error.  */
static const yytype_uint16 yydefact[] =
{
       4,     0,     0,     0,     0,    64,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   363,     0,     0,
     762,   763,   764,   765,   766,   767,   768,   769,   770,   771,
     772,   773,   774,   775,   776,   777,   778,   779,   780,   781,
     782,   783,   784,   785,   786,   787,   788,   789,   790,   791,
     792,   793,   794,   795,   796,   797,   798,   799,   800,   801,
     802,   803,   804,   805,   806,     3,     1,     2,     0,     0,
       0,     0,     0,     0,    98,    99,     0,     0,     0,     0,
     363,     0,   748,   749,   750,   751,   752,   100,   100,   753,
     754,   755,    96,   756,     0,   758,   100,   103,   759,   760,
     761,   100,   103,   100,   103,   100,   103,   100,   813,   100,
     103,   100,   103,     5,   757,   103,   103,   250,   252,   251,
       0,    65,    64,     0,     0,    64,    66,    63,     0,     0,
     222,     0,     0,     0,     0,   249,   254,     0,   206,     0,
       0,   190,   214,   186,   186,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   346,   350,   359,   356,   292,   365,
     353,     0,     0,   349,   363,   393,     0,     0,     0,   351,
     352,     0,     0,     0,   363,     0,   354,   355,   360,   391,
     392,     0,   390,     0,   237,   236,     0,   239,     0,     0,
      31,    30,    33,     0,     0,     0,    52,    51,    50,    49,
       0,     0,    90,     0,   256,     0,    84,     0,     0,   258,
     284,   101,     0,     0,    94,    69,    74,   144,   441,   486,
     614,   620,   692,   727,     0,     0,     0,     0,     0,    15,
     148,     0,     0,     0,     0,     0,   809,     0,     0,     0,
       0,     0,     0,    15,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    15,     0,     0,     0,     0,     0,     0,     0,     0,
      15,   810,     0,     0,     0,    15,     0,     0,    15,   811,
     489,     0,     0,   495,     0,     0,     0,   812,     0,     0,
       0,     0,   725,     0,     0,     0,     0,     0,     0,     0,
       0,   814,     0,     0,   169,   173,     0,     0,     0,     0,
     815,     0,     0,     0,     0,    15,     0,    15,     0,   807,
       0,     0,     0,     0,    27,   808,     0,     0,   151,   150,
       0,     0,    66,    60,    61,     0,    67,     0,   243,   241,
       0,     0,     0,     0,   244,   162,   161,     0,     0,   253,
     255,   254,     0,   187,     0,   210,   182,   181,     0,     0,
     185,   186,   186,   605,   186,   186,     0,     0,    16,    17,
       0,     0,     0,   232,   233,   229,   227,   228,   230,   231,
     346,   365,   346,   363,   346,   346,     0,   338,     0,   363,
       0,     0,     0,   349,   349,     0,   388,   363,   363,   363,
     363,   363,     0,   309,   310,     0,   312,     0,     0,     7,
     296,   294,     9,   363,   293,   295,   318,   316,   317,   324,
       0,   329,   333,     0,   828,   823,   824,   825,   826,   366,
     827,   367,   368,   369,   370,   371,   372,   373,   830,   833,
     832,   829,   831,   834,   835,   836,   839,   837,   838,   840,
     841,   842,   843,   844,   845,   394,   395,   234,   363,   363,
     363,   363,   363,   363,   363,   363,   363,   363,   363,   363,
     363,     0,    38,    39,    40,    41,    42,    43,    44,    45,
      46,     0,    36,   240,     0,   242,   363,     0,    32,    34,
       0,     0,   129,   363,   130,    53,     0,    57,    91,    92,
      80,    81,    82,   140,     0,   273,    93,     0,    48,     0,
       0,     0,   816,   820,     0,   145,   106,   128,   114,     0,
     104,    11,    13,    12,    14,    10,   105,   131,   119,   273,
     120,     0,     0,   363,   108,   118,     0,   109,     0,   116,
     107,   146,   147,   442,     0,     0,     0,     0,     0,     0,
       0,    15,     0,     0,     0,    18,     0,     0,     0,   454,
       0,     0,     0,     0,     0,    15,     0,     0,     0,     0,
      15,     0,    15,     0,    15,     0,    15,     0,     0,    15,
      15,    15,     0,   443,   487,   496,   490,    15,   494,   492,
     488,   498,   615,     0,     0,     0,   616,   629,   693,     0,
     131,     0,   174,     0,   170,   708,   706,   707,     0,     0,
       0,     0,     0,     0,     0,   694,   701,   175,   728,    15,
     733,     0,   729,   743,     0,   742,     0,   746,     0,   744,
     745,   732,     0,    70,     0,    72,    15,   818,   819,   817,
       0,    26,     0,   822,   821,   156,   155,   157,   159,   160,
     158,     0,   153,   247,     0,    62,    68,    58,   223,   226,
     245,   246,   166,   167,     0,   164,   248,     0,   183,   188,
     205,     0,   212,   211,     0,     0,   189,   196,     0,     0,
     204,   273,   198,   197,   201,   202,     0,   203,   191,     0,
     195,   213,   221,   215,   218,   219,   217,   220,   216,   596,
     596,     0,   186,   596,   186,   596,   597,   747,     0,     0,
      20,     0,     0,   342,   343,     0,   344,   345,   340,   328,
     421,   424,     0,   401,     0,   402,   347,   348,   341,     0,
       0,     0,     0,     0,     0,   311,   363,   374,   363,   305,
     303,     0,     0,   302,     0,     0,   357,   330,   331,     0,
       0,   358,   386,   384,   382,   379,   380,   381,   383,   385,
     387,   375,   376,   377,   378,   396,     0,   397,   399,   400,
     238,     0,   235,     0,    29,     0,    28,     0,     0,    55,
      56,   131,     0,    78,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,     0,     0,     0,   257,
     277,    88,    89,     0,     0,    83,    85,    47,     0,   273,
     102,     0,    97,   115,   135,   138,   149,   278,   279,   117,
     127,   121,   111,    15,   280,   112,   110,     0,     0,    15,
     479,   481,     0,    15,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   455,     0,     0,     0,     0,     0,     0,
       0,   448,     0,   449,     0,   477,     0,     0,     0,     0,
       0,     0,     0,   461,   462,     0,     0,     0,   483,   491,
       0,     0,     0,   618,   619,   103,     0,   723,   705,   696,
       0,     0,   700,   695,   697,     0,   703,   704,   702,     0,
       0,     0,     0,     0,     0,   739,    18,   741,     0,   736,
     740,    77,    71,    73,    75,    22,    21,    76,   152,     0,
      59,   163,     0,   184,   209,   208,   207,   193,   200,   194,
     192,   199,   595,     0,     0,   604,   613,     0,   611,     0,
       0,   608,   606,     0,   596,     0,   596,     0,    23,    24,
       0,     0,   339,   363,   410,     0,   363,   363,   363,   389,
     363,   408,   363,     0,     0,   363,   363,   363,     8,   292,
     319,   325,     0,     0,   334,   363,    37,     6,    35,    54,
     141,    79,   272,   271,   273,   363,    86,    87,   282,   275,
       0,   285,     0,   136,     0,   131,     0,   126,   113,     0,
       0,     0,   480,     0,   476,   470,   444,     0,    19,     0,
     450,     0,   453,     0,   457,   456,   469,   468,   463,     0,
       0,   478,   466,   458,   459,   460,   482,   484,   465,   464,
     485,   467,   493,   587,    15,     0,    15,   509,     0,     0,
     511,   501,    15,   497,     0,   515,   588,   617,   632,     0,
     624,   626,     0,   631,   621,     0,   699,   721,   726,   168,
     170,   698,     0,     0,     0,     0,     0,   172,   730,   731,
     738,    18,     0,   737,   154,   165,   599,   598,   612,   607,
     609,   610,     0,   600,     0,   602,     0,     0,   422,   403,
       0,     0,     0,     0,     0,   363,   361,   304,   302,     0,
       0,   308,     0,     0,   274,     0,   414,     0,   415,   416,
       0,   363,   412,   413,   411,   363,   363,     0,   363,     0,
       0,   363,   288,     0,   281,     0,   132,   133,   137,   139,
     122,   123,   124,   125,   472,     0,   474,   475,   445,     0,
     452,   451,   471,   447,   131,   514,   502,     0,     0,    15,
       0,   500,     0,     0,   518,   513,   517,     0,     0,   507,
     499,     0,   525,   131,   622,   656,   665,   623,     0,     0,
     628,   630,   714,   171,   175,    25,     0,     0,     0,     0,
     734,   735,   601,   603,   222,   222,   407,   405,   406,   404,
     363,     0,   306,   363,     0,   398,   363,   363,   363,   363,
       0,     0,     0,   283,   289,     0,     0,   434,   417,   419,
       0,   276,     0,   134,     0,   446,   588,   504,   505,   503,
     506,   575,   539,   519,   575,   508,   589,   526,   653,   663,
     662,   669,   668,   676,   625,   678,   679,   686,   627,     0,
       0,     0,     0,   724,     0,   180,   175,   175,   175,   175,
       0,     0,     0,   362,     0,     0,     0,   332,     0,     0,
       0,     0,   428,   363,   335,   363,   363,     0,   363,   433,
       0,   473,   592,     0,     0,     0,   528,   651,   650,     0,
     667,   674,   684,   715,    15,     0,     0,     0,   717,   709,
     710,   711,   712,   713,   716,   722,   176,   177,   178,   179,
     224,   225,   409,   363,   315,   363,   313,   427,   364,   431,
       0,   363,   425,   290,     0,     0,     0,     0,     0,     0,
       0,     0,   420,     0,   590,   594,   510,   578,   576,   579,
      15,     0,    15,   516,     0,   512,     0,     0,     0,     0,
       0,     0,   524,   538,     0,     0,   655,     0,     0,    15,
      15,    15,   666,     0,   670,   680,     0,   719,   142,   143,
     718,     0,     0,     0,     0,   363,   363,   297,   301,   299,
     363,   435,   300,   322,   320,   321,   326,     0,   430,   429,
     363,   363,   363,   363,   436,    95,     0,   580,     0,     0,
     522,   523,   521,   520,   532,   530,   529,     0,     0,   533,
     535,   536,   537,   527,     0,     0,     0,     0,     0,    15,
       0,     0,     0,     0,   644,   646,   654,     0,     0,     0,
     657,   658,   659,   664,     0,     0,   673,     0,     0,     0,
     683,     0,   720,   363,   314,   432,   291,   426,   337,   302,
       0,   363,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    15,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   593,   574,     0,
     581,   577,   531,   534,     0,   643,     0,     0,     0,     0,
     636,    15,     0,     0,     0,    15,     0,    15,     0,   652,
     690,   690,     0,   688,   672,   671,   677,   675,   682,   681,
     687,   685,     0,   298,   363,   323,   336,   327,     0,     0,
       0,     0,    15,   582,   544,    15,   560,   540,   543,   541,
       0,   558,     0,   545,   547,   548,   549,   550,   551,   552,
     553,   554,    15,   564,   565,   566,    15,   542,     0,     0,
      15,     0,   570,   591,     0,   690,   638,   635,     0,   637,
     639,   640,     0,   648,   645,   649,   647,    15,   660,   661,
     689,   307,     0,   440,   438,   439,   437,   561,     0,     0,
     572,   557,   546,   556,   559,   567,   568,   569,   562,   555,
     571,   634,   642,   633,   641,   691,   584,   563,   583,   573,
     585,     0,   586
};

/* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
      -1,     2,     3,    83,   525,   526,   370,   839,   906,   907,
     710,  1166,   642,    84,   488,   193,   491,   481,   482,    85,
     200,   201,    86,    20,    21,    22,    23,    24,    25,   126,
     337,    87,   320,    88,   326,   321,    89,   504,    90,   507,
     806,   499,    91,    92,   514,    93,    94,   212,   237,   534,
     987,   822,   518,    95,   814,  1118,   984,   815,   816,   781,
     782,  1278,    96,    97,   527,   238,   331,   651,   652,   348,
     664,   665,   303,   880,   304,   305,   892,    26,    27,    28,
      29,   366,    30,    31,    32,   358,   689,    33,   355,   675,
      34,   359,   341,    35,    36,    37,    38,    39,    40,    41,
      42,    43,    44,    45,    46,   187,   484,    47,    48,    49,
      50,    51,    52,    53,    54,    55,   120,   352,    98,   505,
      99,   796,   797,   798,   980,   818,   819,   535,   809,   800,
     100,   510,  1107,  1108,  1302,   176,   416,  1363,   740,   741,
     417,  1090,   742,   418,   419,  1366,   420,  1367,   177,   422,
     423,  1304,   385,   178,   386,   395,   179,   180,   181,  1110,
     182,   455,  1088,  1111,  1199,  1200,   721,   722,  1112,   101,
     102,   103,   104,   281,   282,   283,   871,  1034,  1142,  1147,
    1145,  1146,  1264,  1324,  1035,  1266,  1334,  1036,  1459,  1263,
    1318,  1319,  1379,  1558,  1581,  1578,  1134,  1152,  1376,  1315,
    1135,   923,    56,    57,    58,    59,    60,    61,    62,    63,
     701,   105,   106,   107,  1045,  1158,  1159,   875,   108,  1153,
    1407,  1476,  1478,  1336,  1335,  1268,  1154,  1156,  1343,  1270,
    1269,  1220,  1157,  1223,  1271,  1417,  1486,  1344,  1224,  1227,
    1272,  1421,  1490,  1345,  1228,  1484,  1548,   109,   110,   608,
    1284,  1234,  1162,  1048,   600,   601,   111,   112,   312,   899,
     900,   313,    64,   113,    65,   114,   115,   116,   456
};

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
#define YYPACT_NINF -1216
static const yytype_int16 yypact[] =
{
     151,  2472,    98,   634,   658,   721,   241,   658,   658,   173,
     717,   658,   323,   774,   279,   284,   915,  1426,   129,   658,
   -1216, -1216, -1216, -1216, -1216, -1216, -1216, -1216, -1216, -1216,
   -1216, -1216, -1216, -1216, -1216, -1216, -1216, -1216, -1216, -1216,
   -1216, -1216, -1216, -1216, -1216, -1216, -1216, -1216, -1216, -1216,
   -1216, -1216, -1216, -1216, -1216, -1216, -1216, -1216, -1216, -1216,
   -1216, -1216, -1216, -1216, -1216, -1216, -1216, -1216,   412,   508,
     325,   647,   419,   379, -1216, -1216,   445,   399,   381,    63,
    1426,   488, -1216, -1216, -1216, -1216, -1216,   507,   507, -1216,
   -1216, -1216,   229, -1216,  1148, -1216,   507,  1236, -1216, -1216,
   -1216,   507,  2183,   507,  1981,   507,  1029,   507, -1216,   507,
    1968,   507,  2272, -1216, -1216,  2137,  2060, -1216, -1216, -1216,
     198, -1216,   561,   611,   643,   561,   550, -1216,   688,   699,
     598,   658,   658,   701,   210, -1216,   668,    53, -1216,   719,
     740, -1216, -1216,   181,   730,   462,   462,   753,   761,   771,
     784,   819,   821,   837,    13, -1216, -1216, -1216,   786,   476,
   -1216,   657,    38,    -3,  1426, -1216,   480,   494,   502, -1216,
   -1216,   533,   536,   541,  1020,   161, -1216, -1216, -1216, -1216,
   -1216,  1931, -1216,  2567, -1216, -1216,  1539,   859,   875,   869,
   -1216,   868, -1216,    -4,   198,   109, -1216, -1216, -1216, -1216,
      62,   582,   824,   453, -1216,   932, -1216,   592,   210,  2621,
   -1216,   861,   596,   600, -1216, -1216, -1216, -1216, -1216, -1216,
   -1216, -1216, -1216, -1216,   617,   198,   968,   918,   109,   137,
   -1216,   818,   423,   899,   972,   210, -1216,   632,   636,   633,
     312,   787,   985,   137,   926,   -72,   898,   274,   462,   959,
     828,   963,    92,   827,   829,   439,   826,   830,   447,   810,
     813,   137,   823,   822,   820,    54,    66,   850,   832,   839,
     137, -1216,   700,   705,   803,   137,  1001,   109,   137, -1216,
   -1216,   714,   711, -1216,   712,  1010,   428, -1216,   725,   727,
     729,  1036, -1216,  1084,   109,   738,   -25,   109,   109,  1041,
      76, -1216,   746,   747, -1216,   748,   749,   843,   462,  1042,
   -1216,   751,   532,   755,  1049,   137,  1057,   137,  1066, -1216,
     782,   783,   789,  1083,  1131, -1216,   790,   791, -1216, -1216,
     871,  1154,   550, -1216, -1216,  1156,   109,  1157, -1216, -1216,
    1145,  1162,  1164,  1165, -1216, -1216, -1216,   100,  1171, -1216,
   -1216,   733,  1172, -1216,  1173,   470, -1216, -1216,  2340,  1228,
   -1216,   730,   730, -1216,   389,   465,  1177,  1178, -1216, -1216,
       0,  1073,  1074, -1216, -1216, -1216, -1216, -1216, -1216, -1216,
      13, -1216,    13,  1426,    13,    13,  1179, -1216,  1176,   812,
    1169,  1003,  1181,    -3,    -3,  1174,  1183,  1426,  1426,  1426,
    1426,  1426,  1185, -1216, -1216,  1190, -1216,   838,    68, -1216,
   -1216, -1216, -1216,   625, -1216, -1216,  1203, -1216, -1216, -1216,
     186,     7, -1216,   212, -1216, -1216, -1216, -1216, -1216, -1216,
   -1216, -1216, -1216, -1216, -1216, -1216, -1216, -1216, -1216, -1216,
   -1216, -1216, -1216, -1216, -1216, -1216, -1216, -1216, -1216, -1216,
   -1216, -1216, -1216, -1216, -1216, -1216, -1216, -1216,  1426,  1426,
    1426,  1426,  1426,  1426,  1426,  1426,  1426,  1426,  1426,  1426,
    1426,   593, -1216, -1216, -1216, -1216, -1216, -1216, -1216, -1216,
   -1216,   511, -1216, -1216,  1210, -1216,  1426,  1196, -1216, -1216,
    1539,   855, -1216,  1426, -1216,   109,   835, -1216, -1216, -1216,
   -1216, -1216, -1216, -1216,   862,  1120, -1216,   213, -1216,   863,
     870,  1221, -1216, -1216,   -45, -1216, -1216, -1216, -1216,   803,
   -1216, -1216, -1216, -1216, -1216, -1216, -1216, -1216, -1216,  1393,
   -1216,   190,  1144,  1426, -1216, -1216,   190, -1216,   190, -1216,
   -1216, -1216, -1216, -1216,  1182,  1184,  1199,   864,   881,   109,
    1005,   137,   462,   109,  1045,  1225,   109,  1192,   109, -1216,
     892,  1193,   246,   109,   109,   137,  1194,   897,  1186,   902,
     137,   910,   137,   332,   137,   968,   137,   911,   928,   137,
     137,   137,   929, -1216, -1216, -1216, -1216,   137, -1216,  1205,
   -1216, -1216, -1216,  1278,   939,   940, -1216, -1216, -1216,   109,
   -1216,   945, -1216,   946,  1214, -1216, -1216, -1216,   950,   953,
     960,   109,   962,   965,   967, -1216, -1216,   254, -1216,   137,
   -1216,   968, -1216, -1216,   772, -1216,   462, -1216,  1123, -1216,
   -1216, -1216,   109, -1216,   109, -1216,   137, -1216, -1216, -1216,
     109, -1216,   462, -1216, -1216, -1216, -1216, -1216, -1216, -1216,
   -1216,   557, -1216, -1216,  1331, -1216, -1216, -1216, -1216, -1216,
   -1216, -1216, -1216, -1216,   602, -1216, -1216,  1332, -1216, -1216,
   -1216,  1317, -1216, -1216,  1322,   462, -1216, -1216,  1320,  1321,
   -1216,  1393, -1216, -1216, -1216, -1216,   462, -1216, -1216,  1325,
   -1216, -1216, -1216, -1216, -1216, -1216, -1216, -1216, -1216,  1329,
    1329,   663,   730,  1329,   730,  1329, -1216, -1216,   109,   462,
   -1216,  1326,  1335, -1216, -1216,   706, -1216, -1216, -1216, -1216,
      94, -1216,   984, -1216,  1330, -1216, -1216, -1216, -1216,   231,
     257,   287,   785,   330,   373, -1216,  1426, -1216,  1426, -1216,
    1345,   987,   988,   825,   196,   203, -1216, -1216, -1216,  1346,
    1349, -1216,  2646,  2646,  2646,  2657,  2657,  2646,  2646,  2646,
    2646,   695,   695,  1183,  1183, -1216,   997, -1216, -1216, -1216,
   -1216,  1539, -1216,  1117, -1216,   608, -1216,   825,  1344, -1216,
   -1216, -1216,  1006, -1216, -1216, -1216, -1216, -1216, -1216, -1216,
   -1216, -1216, -1216, -1216, -1216, -1216,    82,  1007,  1008, -1216,
   -1216, -1216, -1216,   462,   109, -1216, -1216, -1216,   702,  1120,
   -1216,   462, -1216, -1216,  1343, -1216,  1004, -1216, -1216, -1216,
   -1216,  1282, -1216,   137,  2621, -1216, -1216,   109,   109,   137,
   -1216, -1216,  1011,   137,  1013,  1015,  1016,   109,  1369,  1188,
    1024,   109,  1027, -1216,   109,  1030,  1031,  1037,  1040,  1043,
     109, -1216,   803, -1216,  1054, -1216,  1055,  1056,  1058,  1063,
    1065,  1067,  1068, -1216, -1216,  1070,  1071,  1075, -1216, -1216,
     109,   612,  1082, -1216, -1216,  2212,  1085,   146, -1216, -1216,
    1052,  1086, -1216, -1216, -1216,  1091, -1216, -1216, -1216,   109,
     520,   525,  1061,  1094,  1095, -1216,  1225, -1216,   462,  1098,
    1123, -1216, -1216, -1216, -1216,     0, -1216, -1216, -1216,   871,
   -1216, -1216,   100, -1216, -1216, -1216, -1216, -1216, -1216, -1216,
   -1216, -1216, -1216,  1407,  1435, -1216, -1216,   803, -1216,   803,
    1433, -1216, -1216,   803,  1329,  1446,  1329,  1458, -1216, -1216,
    1261,  1262, -1216,  1426, -1216,  1439,  1426,  1426,  1426, -1216,
    1426, -1216,  1426,   512,  1463,  1426,   996,  1426, -1216, -1216,
   -1216, -1216,  1096,   786, -1216,  1426, -1216, -1216, -1216, -1216,
    1004, -1216, -1216, -1216,  1120,   148, -1216, -1216, -1216,  1104,
    1103, -1216,  1361, -1216,   780, -1216,   849, -1216, -1216,  1115,
    1110,  1118, -1216,  1129, -1216, -1216, -1216,  1132, -1216,   109,
   -1216,  1133, -1216,  1139, -1216, -1216, -1216, -1216, -1216,  1140,
    1142, -1216, -1216, -1216, -1216, -1216, -1216, -1216, -1216, -1216,
   -1216, -1216, -1216, -1216,   137,   281,    23, -1216,  1204,   462,
   -1216, -1216,    95, -1216,  1146, -1216,  1200, -1216, -1216,   462,
   -1216, -1216,   462, -1216, -1216,  1159, -1216, -1216, -1216, -1216,
    1214, -1216,  1160,  1490,  1490,  1490,  1490, -1216, -1216, -1216,
   -1216,  1225,   109,  1098, -1216, -1216, -1216, -1216, -1216, -1216,
   -1216, -1216,  1518, -1216,  1523, -1216,  1507,  1517, -1216, -1216,
    1491,  1519,  1603,  1628,   581,  1426, -1216, -1216,  2621,  1166,
    1163,  2621,  1520,  1653, -1216,    -2, -1216,  1514, -1216, -1216,
    1207,  1426, -1216, -1216, -1216,  1426,  1426,  1167,    29,  1931,
    1201,  1206, -1216,  1120, -1216,  1534,   462, -1216, -1216, -1216,
   -1216, -1216, -1216, -1216, -1216,   109, -1216, -1216, -1216,  1211,
   -1216, -1216, -1216, -1216, -1216, -1216, -1216,   109,   109,   137,
     109, -1216,  1208,   803, -1216, -1216,  1209,  1222,   109, -1216,
   -1216,   109,  1224, -1216, -1216, -1216,  1226, -1216,    31,    17,
   -1216, -1216,   309, -1216,   254, -1216,  1229,  1232,  1233,  1234,
   -1216, -1216, -1216, -1216,   598,   598, -1216, -1216, -1216, -1216,
    1426,  1678,  1531,  1398,  1180, -1216,  1426,   812,  1426, -1216,
    1865,  2537,   607, -1216, -1216,  1537,   391, -1216,  2621,  1198,
    1235, -1216,  1362, -1216,  1239, -1216,  -119, -1216, -1216, -1216,
   -1216, -1216, -1216, -1216, -1216, -1216, -1216, -1216,   305, -1216,
   -1216, -1216, -1216, -1216, -1216, -1216, -1216, -1216, -1216,   109,
    1315,   293,   298, -1216,  1240, -1216,   254,   254,   254,   254,
    1587,  1598,  1703, -1216,  1241,  1242,    10, -1216,  1890,  1243,
    1915,  2009, -1216,   900, -1216,  1426,  1426,   388,  1206, -1216,
    1593, -1216,  1247,     3,    70,     8,   489, -1216, -1216,   630,
   -1216, -1216, -1216, -1216,    51,   109,   109,   109, -1216, -1216,
   -1216, -1216, -1216, -1216, -1216, -1216, -1216, -1216, -1216, -1216,
   -1216, -1216, -1216,  1426, -1216,  1426, -1216, -1216, -1216, -1216,
    1251,   148,  1445, -1216,    37,  1940,  1965,  1255,  1256,  1257,
    1267,  1269, -1216,  1284, -1216, -1216, -1216, -1216, -1216,   107,
     137,   109,   137, -1216,  1293, -1216,   109,   109,   109,  1441,
     127,   -57, -1216, -1216,  1301,  2202, -1216,  1333,  1334,   137,
     137,   137, -1216,  1302,   329,   224,  1377, -1216, -1216, -1216,
   -1216,  1300,  1305,  1308,  1304,   900,   119, -1216, -1216, -1216,
     625, -1216, -1216,  1676, -1216, -1216, -1216,   228, -1216, -1216,
    1426,  1426,  1426,  1426, -1216, -1216,  2188, -1216,   109,  1319,
   -1216, -1216, -1216, -1216, -1216, -1216, -1216,   109,   109, -1216,
   -1216, -1216, -1216, -1216,  1370,   462,  1356,  1367,   -15,   137,
    1371,  1626,  1365,  1484,  1497,  1498, -1216,  1351,   109,   109,
   -1216, -1216, -1216, -1216,   126,   462, -1216,  1352,   126,  1688,
   -1216,  1353, -1216,  1426, -1216, -1216, -1216, -1216, -1216,  1728,
      56,   119,   180,  1757,  1785,  1810,  1837,  1417,  1350,   109,
    1465,   137,   109,   109,   109,  1503,   109,   302,  1366,  1411,
      64,  1447,   109,  1428,  1430,  1459,   352, -1216, -1216,  1376,
   -1216, -1216, -1216, -1216,  1419, -1216,   109,   109,   109,  1420,
   -1216,   137,   109,   109,  1654,   137,    31,   137,    17, -1216,
    1400,  1400,   109, -1216, -1216, -1216, -1216, -1216, -1216, -1216,
   -1216, -1216,  1379, -1216,  1426, -1216, -1216, -1216,  1382,  1383,
    1384,  1394,   137, -1216, -1216,   125, -1216, -1216, -1216, -1216,
     109, -1216,   109, -1216, -1216, -1216, -1216, -1216, -1216, -1216,
   -1216, -1216,   137, -1216, -1216, -1216,   137, -1216,    49,   109,
     137,   109, -1216, -1216,   109,  1400, -1216, -1216,   109, -1216,
   -1216, -1216,   109, -1216, -1216, -1216, -1216,   137, -1216, -1216,
   -1216, -1216,  1728, -1216, -1216, -1216, -1216, -1216,     5,  1468,
   -1216, -1216, -1216, -1216, -1216, -1216, -1216, -1216, -1216, -1216,
   -1216, -1216, -1216, -1216, -1216, -1216,  1471, -1216, -1216, -1216,
   -1216,  1397, -1216
};

/* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
   -1216, -1216, -1216, -1216,  -144,   -68,  -208,  -815,  -142,  -662,
   -1216,  -170, -1216, -1216, -1216, -1216, -1216,  1273,   999, -1216,
   -1216, -1216, -1216, -1216, -1216, -1216, -1216, -1216, -1216,   249,
    1440, -1216, -1216, -1216, -1216, -1216, -1216,  -268, -1216, -1216,
   -1216, -1216, -1216, -1216, -1216, -1216, -1216,   990,   -97,  1541,
   -1216,   156,  -463, -1216, -1216, -1216, -1216,   792,  -592, -1216,
   -1216,   318, -1216, -1216, -1216, -1216,   -55, -1216,   866,   153,
   -1216,   876, -1153,   726,  -588, -1216,  -468, -1216, -1216, -1216,
   -1216,  -130, -1216, -1216, -1216, -1216, -1216, -1216, -1216, -1216,
   -1216, -1216,  -191, -1216, -1216, -1216, -1216, -1216, -1216, -1216,
   -1216, -1216, -1216, -1216, -1216, -1216, -1216, -1216, -1216, -1216,
   -1216, -1216, -1216, -1216, -1216, -1216,   913,  1427, -1216, -1216,
   -1216, -1216,  -783,   816,   674,  1286,  1119,  1443, -1216,   989,
   -1216, -1216,  -931, -1216,   448,  -174,  1060,   372,  -944,   860,
   -1215, -1034,  1631, -1205,  1078,   374, -1216, -1216,  -173,  1076,
   -1216, -1216, -1216, -1216,   554,   635, -1216, -1216,  -965, -1216,
     170,   715,   -17, -1216, -1216,   567,   872,   640, -1047, -1216,
   -1216, -1216, -1216, -1216, -1216, -1216, -1216, -1216, -1216, -1216,
   -1216, -1216, -1216, -1216, -1216, -1216, -1216, -1216, -1216,   614,
   -1216, -1216, -1216, -1216, -1216, -1216, -1216,   623, -1216, -1216,
   -1216,  -279, -1216, -1216, -1216, -1216, -1216, -1216, -1216, -1216,
   -1216, -1216, -1216, -1216, -1216, -1216, -1216, -1216, -1216, -1216,
   -1216, -1216, -1216, -1216, -1216, -1216, -1216, -1216, -1216, -1216,
   -1216, -1216,   436,   425, -1216, -1216, -1216, -1216,   365,   424,
   -1216, -1216, -1216, -1216,   366,   432, -1133, -1216, -1216, -1216,
   -1216, -1216, -1216, -1216, -1216, -1216, -1216, -1216, -1216,   951,
   -1216, -1216, -1216, -1216, -1216, -1216, -1216, -1216,  -847
};

/* YYTABLE[YYPACT[STATE-NUM]].  What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule which
   number is the opposite.  If YYTABLE_NINF, syntax error.  */
#define YYTABLE_NINF -424
static const yytype_int16 yytable[] =
{
     183,   415,   421,   371,   372,   272,   585,   280,   877,   288,
    1109,  1087,   393,   302,   367,   311,   881,  1295,   322,   327,
    1186,   368,   369,  1576,   920,   979,   368,   369,   380,   708,
    1390,   414,   381,   747,   748,  -287,   489,  1225,   409,   554,
     555,   382,   412,  1356,  -287,  -287,  -287,  -287,  1095,   368,
     369,   494,  1357,  1358,  1359,   959,   353,   521,   522,   523,
     524,  1194,   605,   209,   409,   391,   409,   550,   412,   811,
     412,  1357,  1358,  1359,   959,  1096,   458,   459,   460,   461,
     462,  1060,   495,   207,   520,   521,   522,   523,   524,  1364,
     463,   464,   465,   466,   467,   468,   469,   470,    66,  1365,
     471,   972,   458,   459,   460,   461,   462,   409,   560,  1097,
     409,   412,   861,  1333,   412,   496,   463,   464,   465,   466,
     467,   468,   469,   470,   409,  -286,   471,   575,   412,   521,
     522,   523,   524,   588,  -286,  -286,  -286,  -286,  1095,   492,
     409,   409,   409,  1109,   412,   412,   412,   396,   577,  1246,
     603,  1523,   409,   609,   610,     1,   412,   408,   894,   521,
     522,   523,   524,   551,   184,  1096,   620,  1095,   208,   185,
     516,   521,   522,   523,   524,   548,   409,   410,   411,   158,
     412,  1098,  1099,  1100,  1101,  1102,  1103,  1104,   662,   970,
    1151,   354,   656,   571,  1096,  1357,  1358,  1359,   959,  1097,
     360,  1105,   582,  1468,  1106,   409,  1303,   586,  1320,   412,
     589,   409,   410,   411,   959,   412,   688,  1364,   409,   410,
     411,   959,   412,  1458,  1251,   820,  1391,  1365,  1097,  1392,
     663,   699,   700,   328,   703,   705,  1388,   392,   329,   458,
     459,   460,   461,   462,   127,   345,  1170,   633,   973,   635,
     346,   813,   985,   463,   464,   465,   466,   467,   468,   469,
     470,  1352,  1196,   471,   361,   458,   459,   460,   461,   462,
     576,  1098,  1099,  1100,  1101,  1102,  1103,  1104,   612,   463,
     464,   465,   466,   467,   468,   469,   470,   130,  1109,   471,
    1140,  1105,   368,   369,  1106,   458,   459,   460,   461,   462,
    1098,  1099,  1100,  1101,  1102,  1103,  1104,  1469,  1303,   463,
     464,   465,   466,   467,   468,   469,   470,   409,   578,   471,
    1105,   412,  1117,  1106,   387,   812,   135,   362,   606,   607,
     979,   889,   801,   802,   803,   804,  1109,  1321,   458,   459,
     460,   461,   462,   845,   835,  1565,  1566,  1524,  1549,  1351,
    1525,   778,   463,   464,   465,   466,   467,   468,   469,   470,
    1322,   509,   471,  1346,  1187,   490,   715,   890,   709,   394,
    1354,   332,   720,  1316,   335,  1577,   749,  1296,  1325,   383,
     729,   730,   731,   732,   733,   384,  1226,   821,   540,   493,
    1109,  1109,   821,   145,   821,  -287,   743,  1377,   146,  -287,
    1221,  1148,  1572,  1360,  1300,   832,  1378,  1361,   360,   836,
     891,  1512,   840,  1256,   842,   493,   896,   493,   897,   847,
     848,   924,  1494,  1257,   935,  1428,   937,  1275,  1276,   702,
     194,   189,   613,   614,   905,   737,   195,  1559,   202,   738,
    1323,   752,   753,   754,   755,   756,   757,   758,   759,   760,
     761,   762,   763,   764,  1203,   876,   203,   559,   493,   846,
    1482,   493,   881,   528,   204,   943,  1109,   885,   500,   773,
     501,   502,   205,   670,  1307,   493,   777,   553,   905,  1492,
     368,   369,   363,   834,   360,  -286,  1275,  1276,   901,  -286,
     902,   493,   493,   493,   364,   365,   904,   849,   186,   206,
    1496,   939,   854,   493,   856,   704,   860,   210,   862,   529,
     530,   865,   866,   867,   536,  1047,   824,   985,  -286,   869,
     458,   459,   460,   461,   462,  1229,   211,   413,   190,  1308,
    1309,   544,   545,   916,   463,   464,   465,   466,   467,   468,
     469,   470,  1206,   671,   471,   857,  1360,   191,  1137,  1138,
     387,   893,   387,   503,   387,   387,   493,   745,   192,  1418,
     746,  1218,   493,  1230,   938,  1277,  1419,   330,   903,   413,
     415,   415,   934,  1279,   936,   858,   859,   421,   805,   347,
     672,   121,  1310,   750,  1010,  1139,   751,  1311,   293,   458,
     459,   460,   461,   462,  1420,   976,  1431,   673,   214,  1432,
     414,   414,   946,   463,   464,   465,   466,   467,   468,   469,
     470,   336,   295,   471,   333,   458,   459,   460,   461,   462,
    1053,  1231,  1054,   533,  1531,  1055,  1232,  1056,   947,   463,
     464,   465,   466,   467,   468,   469,   470,    67,   154,   471,
     155,   156,   157,   158,   159,   160,   334,  1280,  1281,  1282,
    1283,   161,   162,   739,   163,  1072,   164,  1074,   948,  1068,
     977,  1069,   563,   564,  1414,  1071,   925,    68,   493,   982,
    1415,   340,    69,   674,  1267,    70,   985,   117,   118,  1233,
     567,   568,   926,   989,   990,   196,    71,   349,   350,   623,
    1061,   338,   825,   997,   826,  1023,  1235,  1001,   119,  1416,
    1003,   950,   339,   197,   344,   165,  1009,    72,   351,  1326,
      73,   166,    74,    75,   458,   459,   460,   461,   462,   953,
      76,   954,   356,   469,   470,   198,  1022,   471,   463,   464,
     465,   466,   467,   468,   469,   470,   117,   118,   471,   927,
     951,   121,   624,   357,   952,  1052,   594,   595,    77,   360,
    1024,    78,   349,   350,   765,   988,   373,   119,  1327,  1328,
    1329,   991,  1330,    79,   374,   993,   167,   168,  1286,  1287,
    1288,  1289,   122,  1331,   375,   625,   905,   766,  1044,   123,
     124,   125,    80,   767,   626,    81,   199,   376,   768,   769,
     368,   369,   895,   458,   459,   460,   461,   462,   368,   369,
    1116,   169,   170,   403,   404,   405,   406,   463,   464,   465,
     466,   467,   468,   469,   470,   388,   171,   471,   500,   172,
     501,   502,   377,   173,   378,   154,  1025,   155,   156,   157,
     158,   159,   160,   458,   459,   460,   461,   462,   161,   162,
     379,   163,   389,   164,   131,   132,   397,   463,   464,   465,
     466,   467,   468,   469,   470,  1129,   390,   471,   528,  1332,
     398,   784,   785,   786,   787,   788,   789,   790,   399,   791,
     792,   793,   794,   795,   483,  1212,   928,  1026,   485,   136,
     137,   770,   771,  1085,  1167,  1168,  1169,  1144,   138,   779,
     780,   486,   165,   627,   628,   629,   630,  1155,   166,   400,
    1160,  1027,   401,  1028,   529,   530,   139,   402,   905,   531,
    1029,   140,  1030,   141,   142,   532,  1031,  1032,  1171,  1095,
     128,   129,   929,   133,   134,   487,   720,   908,   909,  1080,
    1081,  1082,   188,  1083,   713,  1084,   714,   930,   716,   717,
    1091,   645,  1120,  1121,  1122,  1123,  1096,   497,  1093,   498,
    1222,   506,  1180,   167,   168,   931,  1136,   508,  1141,   646,
     647,   511,  1337,  1338,  1149,   512,  1339,  1340,  1341,   513,
     932,   933,   911,   912,   648,   649,  1254,   650,   968,   771,
    1097,  1204,  1033,  1240,  1241,   147,   515,   517,   169,   170,
     538,   174,   539,  1207,  1208,   519,  1210,   541,   175,    82,
    1342,   542,   543,   171,  1215,   547,   172,  1216,   546,   154,
     173,   155,   156,   157,   158,   159,   160,   549,   533,   552,
     148,   149,   161,   162,   739,   163,   556,   164,   726,   727,
     558,   561,   143,   154,   557,   155,   156,   157,   158,   159,
     160,   562,   565,   569,   342,   343,   161,   162,   566,   163,
     570,   164,  1098,  1099,  1100,  1101,  1102,  1103,  1104,   150,
     151,   152,   153,   572,   573,   583,   579,   574,  1181,   978,
     225,  1209,  1105,   942,   584,  1106,   165,   587,   213,   590,
     591,   592,   166,   593,  1190,  1273,   224,   580,  1191,  1192,
     596,   239,   581,   273,  1198,   284,   597,   289,   598,   290,
     165,   306,   226,   599,   602,   227,   166,   604,   611,   228,
     229,   615,   616,   231,   232,   621,   622,   617,   618,   233,
     631,  1317,   632,  1317,   634,   458,   459,   460,   461,   462,
    1362,  1348,  1349,  1350,   144,   619,   636,   167,   168,   463,
     464,   465,   466,   467,   468,   469,   470,   637,   638,   471,
     640,   641,   949,   234,   639,   643,   644,   653,   235,   655,
     657,   167,   168,  1242,   658,   659,  1091,   660,   661,  1248,
     720,  1250,   169,   170,   666,   668,   669,  1381,   174,  -423,
     706,   707,  1384,  1385,  1386,   175,  1389,   171,   711,   712,
     172,   719,   958,   718,   173,   723,   169,   170,   403,   404,
     405,   406,   724,   728,   734,   735,  1347,  1222,   725,   736,
     744,   171,   215,   772,   172,   471,   774,   216,   173,   154,
     776,   155,   156,   157,   158,   159,   160,   783,   807,   830,
     217,   691,   161,   162,  1460,   163,   808,   164,  1305,  1306,
     810,  1198,   823,  1462,  1463,   829,   831,   692,   837,   827,
     833,   828,  1380,  1155,  1382,   838,  1362,   843,  1362,   841,
     844,   850,   851,   852,  1480,  1481,   218,   853,  1222,  1301,
    1483,  1410,  1411,  1412,  1483,   855,   863,   225,  1091,   784,
     785,   786,   787,   788,   789,   790,   165,   791,   792,   793,
     794,   795,   166,   864,   868,  1504,   870,   872,  1507,  1508,
    1509,   693,  1511,  1513,   873,   874,   694,   695,  1527,   226,
     878,   879,   227,   293,   696,   882,   228,   229,   883,   230,
     231,   232,  1535,  1536,  1537,   884,   233,   886,  1540,  1541,
     887,  1470,   888,   898,   910,   913,   914,   915,  1550,   917,
     918,   940,   697,  1429,   921,   285,   286,   167,   168,   922,
     941,   944,   955,  1433,  1434,  1435,  1436,   945,   956,   957,
     234,   962,   174,   965,   969,   235,  1561,   963,  1562,   175,
     983,   971,   974,  1506,   986,   985,   992,   975,   994,   698,
     995,   996,   169,   170,  1567,  1568,   174,  1570,   998,  1000,
    1571,   999,  1002,   175,  1573,  1004,  1005,   171,  1574,   287,
     172,  1062,  1006,  1539,   173,  1007,   219,  1543,  1008,  1545,
    1066,   154,   817,   155,   156,   157,   158,   159,   160,  1011,
    1012,  1013,  1049,  1014,   161,   162,  1245,   163,  1015,   164,
    1016,  1057,  1017,  1018,  1557,  1019,  1020,  1560,  1067,   154,
    1021,   155,   156,   157,   158,   159,   160,  1037,  1070,  1073,
    1046,  1050,   161,   162,  1563,   163,  1051,   164,  1564,  1058,
    1059,  1075,  1569,   220,  1076,  1077,  1079,  1092,   221,  1113,
    1114,   458,   459,   460,   461,   462,  1115,  1552,   165,  1575,
    1124,  1125,   967,  1126,   166,   463,   464,   465,   466,   467,
     468,   469,   470,   222,  1127,   471,  1143,  1128,  1130,   458,
     459,   460,   461,   462,  1131,  1132,   165,  1133,   223,  1151,
    1165,  1150,   166,   463,   464,   465,   466,   467,   468,   469,
     470,  1172,  1174,   471,  1161,  1164,  1173,   458,   459,   460,
     461,   462,  1175,  1182,  1183,  1184,  1188,  1193,  1244,   167,
     168,   463,   464,   465,   466,   467,   468,   469,   470,  1202,
    1247,   471,   784,   785,   786,   787,   788,   789,   790,  1255,
     791,   792,   793,   794,   795,  1260,  1197,   167,   168,  1258,
    1274,  -418,   174,  1189,   169,   170,  1205,  1211,  1213,   175,
     472,   473,   474,   475,   476,   477,   478,   479,   480,   171,
    1290,  1214,   172,  1217,  1236,  1219,   173,  1237,  1238,  1239,
    1259,  1291,   169,   170,  1261,  1285,   236,  1293,  1313,  1294,
    1298,   458,   459,   460,   461,   462,  1314,   171,  1353,  1355,
     172,  1370,  1371,  1372,   173,   463,   464,   465,   466,   467,
     468,   469,   470,  1373,  1374,   471,   458,   459,   460,   461,
     462,  1514,  1515,  1516,  1517,  1518,  1519,  1520,  1521,  1375,
     463,   464,   465,   466,   467,   468,   469,   470,  1383,  1387,
     471,   458,   459,   460,   461,   462,  1393,  1413,  1408,  1409,
    1422,  1423,  1424,  1425,  1426,   463,   464,   465,   466,   467,
     468,   469,   470,  1430,  1461,   471,   458,   459,   460,   461,
     462,  1466,  1464,  1472,  1467,  1473,  1474,  1471,  1475,  1477,
     463,   464,   465,   466,   467,   468,   469,   470,  1225,  1502,
     471,   458,   459,   460,   461,   462,  1479,  1487,  1491,  1503,
    1505,  1510,  1522,  1528,  1526,   463,   464,   465,   466,   467,
     468,   469,   470,  1529,  1530,   471,   458,   459,   460,   461,
     462,  1533,  1534,  1538,  1547,  1542,  1551,  1553,  1554,  1555,
     463,   464,   465,   466,   467,   468,   469,   470,  1580,  1556,
     471,  1579,  1582,   775,   174,   458,   459,   460,   461,   462,
     966,   175,   654,   537,  1532,  1064,  1163,  1119,   667,   463,
     464,   465,   466,   467,   468,   469,   470,  1201,  1065,   471,
    1094,   799,   174,   458,   459,   460,   461,   462,   981,   175,
     919,   690,  1495,  1427,   960,   407,  1497,   463,   464,   465,
     466,   467,   468,   469,   470,  1078,  1089,   471,   458,   459,
     460,   461,   462,   961,  1195,  1312,   964,  1249,  1265,  1262,
    1086,  1465,   463,   464,   465,   466,   467,   468,   469,   470,
    1485,  1544,   471,  1489,  1546,   458,   459,   460,   461,   462,
    1488,  1063,     0,     0,     0,     0,     0,     0,  1176,   463,
     464,   465,   466,   467,   468,   469,   470,     0,     0,   471,
       0,     0,     0,   458,   459,   460,   461,   462,     0,     0,
       0,     0,     0,     0,     0,     0,  1177,   463,   464,   465,
     466,   467,   468,   469,   470,     0,     0,   471,   458,   459,
     460,   461,   462,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   463,   464,   465,   466,   467,   468,   469,   470,
       0,     0,   471,   458,   459,   460,   461,   462,     0,     0,
       0,     0,     0,     0,     0,     0,   424,   463,   464,   465,
     466,   467,   468,   469,   470,     0,     0,   471,   458,   459,
     460,   461,   462,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   463,   464,   465,   466,   467,   468,   469,   470,
    1178,     0,   471,   458,   459,   460,   461,   462,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   463,   464,   465,
     466,   467,   468,   469,   470,  1179,     0,   471,     0,     0,
       0,     0,   425,   426,     0,   427,   428,     0,     0,   225,
       0,     0,     0,     0,   424,     0,     0,     0,     0,     0,
    1185,     0,   225,     0,     0,     0,     0,     0,     0,   291,
       0,   429,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   226,     0,     0,   227,  1243,     0,     0,   228,   229,
       0,   292,   231,   232,   226,     0,     0,   227,   233,     0,
       0,   228,   229,     0,   430,   231,   232,   293,     0,     0,
    1292,   233,     0,     0,     0,     0,     0,     0,     0,     0,
     425,   426,     0,   427,   428,     0,     0,     0,     0,     0,
     294,   295,   234,     0,     0,  1493,     0,   235,     0,     0,
       0,   225,     0,     0,     0,   234,     0,     0,     0,     0,
     235,     0,     0,   431,   432,     0,   433,   434,   435,   436,
     437,     0,     0,     0,  1498,     0,   323,     0,     0,     0,
       0,     0,     0,   226,     0,     0,   227,     0,     0,     0,
     228,   229,   430,     0,   231,   232,     0,     0,     0,     0,
     233,     0,  1499,   438,   439,   440,   441,   442,   443,   444,
     445,   446,     0,     0,     0,     0,     0,   324,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1500,   225,   447,
     448,     0,     0,     0,   234,     0,     0,     0,     0,   235,
       0,   449,   450,   451,   452,     0,     0,     0,     0,     0,
       0,   314,   315,   316,  1501,   317,   318,     0,     0,     0,
     226,     0,     0,   227,     0,     0,     0,   228,   229,     0,
       0,   231,   232,     0,   225,     0,     0,   233,     0,   240,
    1252,   438,   439,   440,   441,   442,   443,   444,   445,   446,
     274,     0,     0,     0,     0,   275,   276,   277,  1437,     0,
       0,     0,   296,   225,     0,  1297,   226,   447,   448,   227,
       0,   234,     0,   228,   229,     0,   235,   231,   232,   449,
     450,   451,   452,   233,     0,     0,     0,     0,     0,   241,
    1299,     0,   242,   278,   243,   226,     0,   293,   227,   453,
     454,     0,   228,   229,     0,  1038,   231,   232,     0,     0,
       0,     0,   233,     0,     0,  1368,     0,   234,     0,     0,
       0,   295,   235,   225,   297,   298,   299,  1394,     0,     0,
       0,     0,   244,   300,     0,     0,     0,     0,     0,     0,
    1369,     0,   307,   245,  1438,     0,   234,     0,   301,     0,
       0,   235,     0,   676,     0,   226,     0,     0,   227,     0,
       0,   279,   228,   229,     0,     0,   231,   232,   368,   369,
       0,     0,   233,     0,  1395,     0,     0,   453,   454,   246,
       0,     0,     0,     0,  1039,     0,     0,     0,     0,     0,
     677,     0,     0,     0,   247,   248,     0,   249,   250,     0,
     251,   252,   253,     0,   254,     0,   234,   255,   256,     0,
     257,   235,     0,     0,     0,     0,     0,     0,  1439,     0,
       0,   308,     0,   678,   258,   259,  1396,     0,   679,   260,
       0,   261,   262,     0,   263,   680,   681,     0,     0,   264,
     325,     0,     0,   265,   266,     0,   267,   268,   682,   269,
     270,     0,  1440,     0,     0,     0,     0,   683,   684,   685,
     686,     0,   687,  1441,     0,  1442,     0,  1443,  1444,  1445,
    1446,  1447,  1448,     0,     0,     0,     0,     0,  1449,     0,
       0,     0,  1450,  1451,     0,     0,  1452,     0,     0,     0,
       0,     0,  1453,     0,     0,     0,     0,     0,     0,     0,
    1454,     0,     0,     0,  1397,     0,     0,     0,  1455,     0,
    1456,     0,     0,     0,     0,     0,     0,   319,     0,     0,
       0,     0,     0,     4,     0,     0,     0,     0,     0,     0,
       0,     0,   309,  1398,     0,     0,  1399,  1400,     0,     0,
    1401,  1402,     0,  1403,     5,     6,     0,     0,     0,     0,
     533,  1404,  1405,     0,     0,   458,   459,   460,   461,   462,
       0,  1040,  1041,   271,     0,  1042,     0,     0,  1457,   463,
     464,   465,   466,   467,   468,   469,   470,     7,     8,   471,
     457,     0,  1406,     0,     0,   458,   459,   460,   461,   462,
       0,     0,  1043,     0,     0,     0,     0,     0,     9,   463,
     464,   465,   466,   467,   468,   469,   470,     0,    10,   471,
       0,    11,     0,    12,     0,     0,     0,     0,    13,     0,
       0,     0,     0,    14,    15,    16,     0,     0,     0,     0,
      17,    18,    19,     0,     0,     0,     0,     0,     0,   458,
     459,   460,   461,   462,     0,     0,     0,     0,     0,     0,
       0,     0,   310,   463,   464,   465,   466,   467,   468,   469,
     470,     0,     0,   471,  -424,  -424,  -424,     0,     0,     0,
       0,     0,     0,     0,     0,   458,   459,   460,  -424,  -424,
    -424,  -424,   467,   468,   469,   470,     0,     0,   471,   463,
     464,   465,   466,   467,   468,   469,   470,     0,     0,   471,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1253
};

#define yypact_value_is_default(Yystate) \
  (!!((Yystate) == (-1216)))

#define yytable_value_is_error(Yytable_value) \
  (!!((Yytable_value) == (-424)))

static const yytype_int16 yycheck[] =
{
      17,   175,   175,   145,   146,   102,   274,   104,   600,   106,
     975,   955,    15,   110,   144,   112,   604,     7,   115,   116,
      22,    18,    19,    18,   686,   808,    18,    19,    15,    29,
      87,   175,    19,    26,    27,     6,    40,    20,    15,   247,
     248,    28,    19,     6,    15,    16,    17,    18,    19,    18,
      19,   195,    15,    16,    17,    18,     3,    34,    35,    36,
      37,  1108,    87,    80,    15,    27,    15,   139,    19,   114,
      19,    15,    16,    17,    18,    46,     8,     9,    10,    11,
      12,   896,    20,    20,   228,    34,    35,    36,    37,  1304,
      22,    23,    24,    25,    26,    27,    28,    29,     0,  1304,
      32,    19,     8,     9,    10,    11,    12,    15,   252,    80,
      15,    19,   575,  1266,    19,    53,    22,    23,    24,    25,
      26,    27,    28,    29,    15,     6,    32,    73,    19,    34,
      35,    36,    37,   277,    15,    16,    17,    18,    19,   194,
      15,    15,    15,  1108,    19,    19,    19,   164,    82,  1183,
     294,    87,    15,   297,   298,     4,    19,   174,   621,    34,
      35,    36,    37,   235,    35,    46,   308,    19,   105,    40,
     225,    34,    35,    36,    37,   243,    15,    16,    17,    18,
      19,   152,   153,   154,   155,   156,   157,   158,    88,   781,
     309,   138,   336,   261,    46,    15,    16,    17,    18,    80,
      19,   172,   270,   218,   175,    15,  1253,   275,   138,    19,
     278,    15,    16,    17,    18,    19,   358,  1432,    15,    16,
      17,    18,    19,  1376,  1189,    35,   283,  1432,    80,   286,
     130,   361,   362,    35,   364,   365,   109,   199,    40,     8,
       9,    10,    11,    12,     3,    35,  1061,   315,   166,   317,
      40,   519,   371,    22,    23,    24,    25,    26,    27,    28,
      29,  1295,  1109,    32,    83,     8,     9,    10,    11,    12,
     216,   152,   153,   154,   155,   156,   157,   158,   202,    22,
      23,    24,    25,    26,    27,    28,    29,   114,  1253,    32,
     267,   172,    18,    19,   175,     8,     9,    10,    11,    12,
     152,   153,   154,   155,   156,   157,   158,   322,  1355,    22,
      23,    24,    25,    26,    27,    28,    29,    15,   252,    32,
     172,    19,   984,   175,   154,   370,     3,   146,   353,   354,
    1113,    77,   119,   120,   121,   122,  1301,   267,     8,     9,
      10,    11,    12,    97,   552,   296,   297,   283,  1481,  1293,
     286,   495,    22,    23,    24,    25,    26,    27,    28,    29,
     290,   208,    32,   312,   366,   369,   383,   113,   368,   372,
    1301,   122,   389,   370,   125,   370,   369,   367,   370,   366,
     397,   398,   399,   400,   401,   372,   369,   531,   235,   366,
    1355,  1356,   536,   114,   538,   366,   413,   290,   114,   370,
     369,   306,  1535,   366,  1251,   549,   299,   370,    19,   553,
     156,   109,   556,    22,   558,   366,   624,   366,   626,   563,
     564,   700,   366,    32,   703,  1356,   705,   134,   135,    40,
     105,    19,   356,   357,   642,   367,   111,   312,    19,   371,
     370,   458,   459,   460,   461,   462,   463,   464,   465,   466,
     467,   468,   469,   470,  1116,   599,    77,   365,   366,   213,
     334,   366,  1050,    40,    19,   371,  1431,   611,    15,   486,
      17,    18,    73,     3,    86,   366,   493,   203,   686,  1423,
      18,    19,   301,   551,    19,   366,   134,   135,   632,   370,
     634,   366,   366,   366,   313,   314,   640,   565,   369,   118,
    1431,   709,   570,   366,   572,    40,   574,    19,   576,    86,
      87,   579,   580,   581,    91,   369,   533,   371,   370,   587,
       8,     9,    10,    11,    12,   216,    19,   366,    20,   141,
     142,   219,   220,   675,    22,    23,    24,    25,    26,    27,
      28,    29,  1134,    73,    32,   213,   366,    39,   267,   268,
     380,   619,   382,   100,   384,   385,   366,   371,    50,   335,
     374,  1153,   366,   254,   708,   272,   342,   369,   636,   366,
     744,   745,   702,   275,   704,   243,   244,   750,   365,   369,
     110,    20,   194,   371,   852,   304,   374,   199,    99,     8,
       9,    10,    11,    12,   370,   803,   368,   127,   369,   371,
     744,   745,   371,    22,    23,    24,    25,    26,    27,    28,
      29,    61,   123,    32,     3,     8,     9,    10,    11,    12,
     100,   312,   102,   200,   272,   100,   317,   102,   371,    22,
      23,    24,    25,    26,    27,    28,    29,     3,    13,    32,
      15,    16,    17,    18,    19,    20,     3,   349,   350,   351,
     352,    26,    27,    28,    29,   934,    31,   936,   371,   927,
     804,   929,   223,   224,   335,   933,     3,    33,   366,   811,
     341,    73,    38,   203,   369,    41,   371,    19,    20,   370,
     233,   234,    19,   827,   828,    38,    52,    19,    20,   157,
     898,     3,   536,   837,   538,    83,  1164,   841,    40,   370,
     844,   371,     3,    56,     3,    80,   850,    73,    40,   220,
      76,    86,    78,    79,     8,     9,    10,    11,    12,   736,
      86,   738,     3,    28,    29,    78,   870,    32,    22,    23,
      24,    25,    26,    27,    28,    29,    19,    20,    32,    76,
     367,    20,   210,     3,   371,   889,   318,   319,   114,    19,
     138,   117,    19,    20,   161,   823,     3,    40,   269,   270,
     271,   829,   273,   129,     3,   833,   141,   142,  1236,  1237,
    1238,  1239,    51,   284,     3,   243,   984,   184,   875,    58,
      59,    60,   148,   190,   252,   151,   139,     3,   195,   196,
      18,    19,    20,     8,     9,    10,    11,    12,    18,    19,
      20,   176,   177,   178,   179,   180,   181,    22,    23,    24,
      25,    26,    27,    28,    29,    29,   191,    32,    15,   194,
      17,    18,     3,   198,     3,    13,   214,    15,    16,    17,
      18,    19,    20,     8,     9,    10,    11,    12,    26,    27,
       3,    29,   366,    31,   127,   128,   366,    22,    23,    24,
      25,    26,    27,    28,    29,   999,   199,    32,    40,   370,
     366,   159,   160,   161,   162,   163,   164,   165,   366,   167,
     168,   169,   170,   171,    15,  1143,   213,   265,     3,   105,
     106,   370,   371,   371,  1054,  1055,  1056,  1029,   114,    54,
      55,    22,    80,   361,   362,   363,   364,  1039,    86,   366,
    1042,   289,   366,   291,    86,    87,   132,   366,  1116,    91,
     298,   137,   300,   139,   140,    97,   304,   305,  1062,    19,
       7,     8,   259,    10,    11,    57,   943,   370,   371,   946,
     947,   948,    19,   950,   380,   952,   382,   274,   384,   385,
     957,    70,    93,    94,    95,    96,    46,   365,   965,   125,
    1158,    19,   371,   141,   142,   292,  1024,   365,  1026,    88,
      89,   100,   332,   333,  1032,   369,   336,   337,   338,   369,
     307,   308,   370,   371,   103,   104,   369,   106,   370,   371,
      80,  1125,   370,  1174,  1175,    70,   369,    19,   176,   177,
      91,   366,    20,  1137,  1138,    77,  1140,   365,   373,   365,
     370,   365,   369,   191,  1148,    20,   194,  1151,   221,    13,
     198,    15,    16,    17,    18,    19,    20,    91,   200,   121,
     105,   106,    26,    27,    28,    29,    67,    31,   393,   394,
      67,   204,   258,    13,   206,    15,    16,    17,    18,    19,
      20,   212,   216,   233,   131,   132,    26,    27,   218,    29,
     237,    31,   152,   153,   154,   155,   156,   157,   158,   144,
     145,   146,   147,   240,   242,   365,   216,   247,  1085,   367,
      41,  1139,   172,   367,   369,   175,    80,    76,    88,   365,
     369,   369,    86,    73,  1101,  1229,    96,   255,  1105,  1106,
     365,   101,   253,   103,  1111,   105,   369,   107,   369,   109,
      80,   111,    73,    67,    20,    76,    86,   369,    67,    80,
      81,   365,   365,    84,    85,    73,   365,   369,   369,    90,
     365,  1263,    73,  1265,    67,     8,     9,    10,    11,    12,
    1304,  1275,  1276,  1277,   360,   292,    70,   141,   142,    22,
      23,    24,    25,    26,    27,    28,    29,   365,   365,    32,
      67,    20,   367,   124,   365,   365,   365,     3,   129,     3,
       3,   141,   142,  1180,    19,     3,  1183,     3,     3,  1186,
    1187,  1188,   176,   177,     3,     3,     3,  1321,   366,   367,
       3,     3,  1326,  1327,  1328,   373,  1330,   191,   115,   115,
     194,    15,   367,    14,   198,    26,   176,   177,   178,   179,
     180,   181,   199,    29,    19,    15,  1274,  1415,    27,   371,
       7,   191,    64,     3,   194,    32,    20,    69,   198,    13,
     365,    15,    16,    17,    18,    19,    20,   365,   365,   365,
      82,     3,    26,    27,  1378,    29,   366,    31,  1255,  1256,
      19,  1258,    98,  1387,  1388,    46,   365,    19,   203,    67,
     245,    67,  1320,  1395,  1322,    30,  1430,   365,  1432,    67,
      67,    67,   365,    77,  1408,  1409,   118,   365,  1476,   369,
    1414,  1339,  1340,  1341,  1418,   365,   365,    41,  1295,   159,
     160,   161,   162,   163,   164,   165,    80,   167,   168,   169,
     170,   171,    86,   365,   365,  1439,    91,    19,  1442,  1443,
    1444,    73,  1446,  1447,   365,   365,    78,    79,  1452,    73,
     365,   365,    76,    99,    86,   365,    80,    81,   365,    83,
      84,    85,  1466,  1467,  1468,   365,    90,   365,  1472,  1473,
     365,  1399,   365,   210,     3,     3,    19,    15,  1482,    19,
      19,    15,   114,  1360,    19,   316,   317,   141,   142,    20,
      15,   367,     7,  1370,  1371,  1372,  1373,    27,   371,   371,
     124,    15,   366,   366,    20,   129,  1510,    18,  1512,   373,
      27,   365,   365,  1441,    92,   371,   365,   369,   365,   151,
     365,   365,   176,   177,  1528,  1529,   366,  1531,    19,   365,
    1534,   203,   365,   373,  1538,   365,   365,   191,  1542,   370,
     194,   303,   365,  1471,   198,   365,   258,  1475,   365,  1477,
       3,    13,    19,    15,    16,    17,    18,    19,    20,   365,
     365,   365,   370,   365,    26,    27,    28,    29,   365,    31,
     365,   370,   365,   365,  1502,   365,   365,  1505,     3,    13,
     365,    15,    16,    17,    18,    19,    20,   365,    15,     3,
     365,   365,    26,    27,  1522,    29,   365,    31,  1526,   365,
     365,     3,  1530,   315,   203,   203,    27,   371,   320,   365,
     367,     8,     9,    10,    11,    12,   115,  1494,    80,  1547,
     365,   371,   365,   365,    86,    22,    23,    24,    25,    26,
      27,    28,    29,   345,   365,    32,   292,   365,   365,     8,
       9,    10,    11,    12,   365,   365,    80,   365,   360,   309,
      20,   365,    86,    22,    23,    24,    25,    26,    27,    28,
      29,     3,    15,    32,   365,   365,     3,     8,     9,    10,
      11,    12,    15,   367,   371,    15,    22,   370,     7,   141,
     142,    22,    23,    24,    25,    26,    27,    28,    29,    15,
     370,    32,   159,   160,   161,   162,   163,   164,   165,    22,
     167,   168,   169,   170,   171,   203,   365,   141,   142,   371,
     255,   365,   366,   366,   176,   177,   365,   369,   369,   373,
      41,    42,    43,    44,    45,    46,    47,    48,    49,   191,
       3,   369,   194,   369,   365,   369,   198,   365,   365,   365,
     365,     3,   176,   177,   365,   365,   370,   366,    15,   367,
     367,     8,     9,    10,    11,    12,   369,   191,   367,   174,
     194,   366,   366,   366,   198,    22,    23,    24,    25,    26,
      27,    28,    29,   366,   365,    32,     8,     9,    10,    11,
      12,   275,   276,   277,   278,   279,   280,   281,   282,   365,
      22,    23,    24,    25,    26,    27,    28,    29,   365,   218,
      32,     8,     9,    10,    11,    12,   365,   365,   335,   335,
     293,   371,   367,   365,   370,    22,    23,    24,    25,    26,
      27,    28,    29,     7,   365,    32,     8,     9,    10,    11,
      12,   335,   322,    67,   327,   330,   212,   326,   201,   201,
      22,    23,    24,    25,    26,    27,    28,    29,    20,   292,
      32,     8,     9,    10,    11,    12,   365,   365,   365,   369,
     255,   218,   311,   295,   277,    22,    23,    24,    25,    26,
      27,    28,    29,   303,   275,    32,     8,     9,    10,    11,
      12,   365,   323,   323,   344,    91,   367,   365,   365,   365,
      22,    23,    24,    25,    26,    27,    28,    29,   287,   365,
      32,   293,   365,   490,   366,     8,     9,    10,    11,    12,
     771,   373,   332,   232,  1456,   909,  1050,   985,   351,    22,
      23,    24,    25,    26,    27,    28,    29,  1113,   912,    32,
     974,   505,   366,     8,     9,    10,    11,    12,   809,   373,
     681,   358,  1430,  1355,   744,   174,  1432,    22,    23,    24,
      25,    26,    27,    28,    29,   943,   956,    32,     8,     9,
      10,    11,    12,   745,  1109,  1258,   750,  1187,  1214,  1206,
     367,  1395,    22,    23,    24,    25,    26,    27,    28,    29,
    1415,  1476,    32,  1419,  1478,     8,     9,    10,    11,    12,
    1418,   900,    -1,    -1,    -1,    -1,    -1,    -1,   367,    22,
      23,    24,    25,    26,    27,    28,    29,    -1,    -1,    32,
      -1,    -1,    -1,     8,     9,    10,    11,    12,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   367,    22,    23,    24,
      25,    26,    27,    28,    29,    -1,    -1,    32,     8,     9,
      10,    11,    12,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    22,    23,    24,    25,    26,    27,    28,    29,
      -1,    -1,    32,     8,     9,    10,    11,    12,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,     5,    22,    23,    24,
      25,    26,    27,    28,    29,    -1,    -1,    32,     8,     9,
      10,    11,    12,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    22,    23,    24,    25,    26,    27,    28,    29,
     367,    -1,    32,     8,     9,    10,    11,    12,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    22,    23,    24,
      25,    26,    27,    28,    29,   367,    -1,    32,    -1,    -1,
      -1,    -1,    71,    72,    -1,    74,    75,    -1,    -1,    41,
      -1,    -1,    -1,    -1,     5,    -1,    -1,    -1,    -1,    -1,
     367,    -1,    41,    -1,    -1,    -1,    -1,    -1,    -1,    61,
      -1,   100,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    73,    -1,    -1,    76,   367,    -1,    -1,    80,    81,
      -1,    83,    84,    85,    73,    -1,    -1,    76,    90,    -1,
      -1,    80,    81,    -1,   133,    84,    85,    99,    -1,    -1,
     367,    90,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      71,    72,    -1,    74,    75,    -1,    -1,    -1,    -1,    -1,
     122,   123,   124,    -1,    -1,   367,    -1,   129,    -1,    -1,
      -1,    41,    -1,    -1,    -1,   124,    -1,    -1,    -1,    -1,
     129,    -1,    -1,   182,   183,    -1,   185,   186,   187,   188,
     189,    -1,    -1,    -1,   367,    -1,    66,    -1,    -1,    -1,
      -1,    -1,    -1,    73,    -1,    -1,    76,    -1,    -1,    -1,
      80,    81,   133,    -1,    84,    85,    -1,    -1,    -1,    -1,
      90,    -1,   367,   222,   223,   224,   225,   226,   227,   228,
     229,   230,    -1,    -1,    -1,    -1,    -1,   107,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   367,    41,   248,
     249,    -1,    -1,    -1,   124,    -1,    -1,    -1,    -1,   129,
      -1,   260,   261,   262,   263,    -1,    -1,    -1,    -1,    -1,
      -1,    64,    65,    66,   367,    68,    69,    -1,    -1,    -1,
      73,    -1,    -1,    76,    -1,    -1,    -1,    80,    81,    -1,
      -1,    84,    85,    -1,    41,    -1,    -1,    90,    -1,    46,
     365,   222,   223,   224,   225,   226,   227,   228,   229,   230,
     259,    -1,    -1,    -1,    -1,   264,   265,   266,    60,    -1,
      -1,    -1,   284,    41,    -1,   365,    73,   248,   249,    76,
      -1,   124,    -1,    80,    81,    -1,   129,    84,    85,   260,
     261,   262,   263,    90,    -1,    -1,    -1,    -1,    -1,    96,
     365,    -1,    99,   302,   101,    73,    -1,    99,    76,   358,
     359,    -1,    80,    81,    -1,    83,    84,    85,    -1,    -1,
      -1,    -1,    90,    -1,    -1,   365,    -1,   124,    -1,    -1,
      -1,   123,   129,    41,   346,   347,   348,   115,    -1,    -1,
      -1,    -1,   139,   355,    -1,    -1,    -1,    -1,    -1,    -1,
     365,    -1,    60,   150,   146,    -1,   124,    -1,   370,    -1,
      -1,   129,    -1,     3,    -1,    73,    -1,    -1,    76,    -1,
      -1,   370,    80,    81,    -1,    -1,    84,    85,    18,    19,
      -1,    -1,    90,    -1,   162,    -1,    -1,   358,   359,   186,
      -1,    -1,    -1,    -1,   162,    -1,    -1,    -1,    -1,    -1,
      40,    -1,    -1,    -1,   201,   202,    -1,   204,   205,    -1,
     207,   208,   209,    -1,   211,    -1,   124,   214,   215,    -1,
     217,   129,    -1,    -1,    -1,    -1,    -1,    -1,   220,    -1,
      -1,   139,    -1,    73,   231,   232,   214,    -1,    78,   236,
      -1,   238,   239,    -1,   241,    85,    86,    -1,    -1,   246,
     370,    -1,    -1,   250,   251,    -1,   253,   254,    98,   256,
     257,    -1,   254,    -1,    -1,    -1,    -1,   107,   108,   109,
     110,    -1,   112,   265,    -1,   267,    -1,   269,   270,   271,
     272,   273,   274,    -1,    -1,    -1,    -1,    -1,   280,    -1,
      -1,    -1,   284,   285,    -1,    -1,   288,    -1,    -1,    -1,
      -1,    -1,   294,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     302,    -1,    -1,    -1,   292,    -1,    -1,    -1,   310,    -1,
     312,    -1,    -1,    -1,    -1,    -1,    -1,   370,    -1,    -1,
      -1,    -1,    -1,    41,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   250,   321,    -1,    -1,   324,   325,    -1,    -1,
     328,   329,    -1,   331,    62,    63,    -1,    -1,    -1,    -1,
     200,   339,   340,    -1,    -1,     8,     9,    10,    11,    12,
      -1,   339,   340,   370,    -1,   343,    -1,    -1,   370,    22,
      23,    24,    25,    26,    27,    28,    29,    95,    96,    32,
       3,    -1,   370,    -1,    -1,     8,     9,    10,    11,    12,
      -1,    -1,   370,    -1,    -1,    -1,    -1,    -1,   116,    22,
      23,    24,    25,    26,    27,    28,    29,    -1,   126,    32,
      -1,   129,    -1,   131,    -1,    -1,    -1,    -1,   136,    -1,
      -1,    -1,    -1,   141,   142,   143,    -1,    -1,    -1,    -1,
     148,   149,   150,    -1,    -1,    -1,    -1,    -1,    -1,     8,
       9,    10,    11,    12,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   370,    22,    23,    24,    25,    26,    27,    28,
      29,    -1,    -1,    32,     8,     9,    10,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,     8,     9,    10,    22,    23,
      24,    25,    26,    27,    28,    29,    -1,    -1,    32,    22,
      23,    24,    25,    26,    27,    28,    29,    -1,    -1,    32,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     173
};

/* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
   symbol of state STATE-NUM.  */
static const yytype_uint16 yystos[] =
{
       0,     4,   376,   377,    41,    62,    63,    95,    96,   116,
     126,   129,   131,   136,   141,   142,   143,   148,   149,   150,
     398,   399,   400,   401,   402,   403,   452,   453,   454,   455,
     457,   458,   459,   462,   465,   468,   469,   470,   471,   472,
     473,   474,   475,   476,   477,   478,   479,   482,   483,   484,
     485,   486,   487,   488,   489,   490,   577,   578,   579,   580,
     581,   582,   583,   584,   637,   639,     0,     3,    33,    38,
      41,    52,    73,    76,    78,    79,    86,   114,   117,   129,
     148,   151,   365,   378,   388,   394,   397,   406,   408,   411,
     413,   417,   418,   420,   421,   428,   437,   438,   493,   495,
     505,   544,   545,   546,   547,   586,   587,   588,   593,   622,
     623,   631,   632,   638,   640,   641,   642,    19,    20,    40,
     491,    20,    51,    58,    59,    60,   404,     3,   491,   491,
     114,   127,   128,   491,   491,     3,   105,   106,   114,   132,
     137,   139,   140,   258,   360,   114,   114,    70,   105,   106,
     144,   145,   146,   147,    13,    15,    16,    17,    18,    19,
      20,    26,    27,    29,    31,    80,    86,   141,   142,   176,
     177,   191,   194,   198,   366,   373,   510,   523,   528,   531,
     532,   533,   535,   537,    35,    40,   369,   480,   491,    19,
      20,    39,    50,   390,   105,   111,    38,    56,    78,   139,
     395,   396,    19,    77,    19,    73,   118,    20,   105,   537,
      19,    19,   422,   422,   369,    64,    69,    82,   118,   258,
     315,   320,   345,   360,   422,    41,    73,    76,    80,    81,
      83,    84,    85,    90,   124,   129,   370,   423,   440,   422,
      46,    96,    99,   101,   139,   150,   186,   201,   202,   204,
     205,   207,   208,   209,   211,   214,   215,   217,   231,   232,
     236,   238,   239,   241,   246,   250,   251,   253,   254,   256,
     257,   370,   423,   422,   259,   264,   265,   266,   302,   370,
     423,   548,   549,   550,   422,   316,   317,   370,   423,   422,
     422,    61,    83,    99,   122,   123,   284,   346,   347,   348,
     355,   370,   423,   447,   449,   450,   422,    60,   139,   250,
     370,   423,   633,   636,    64,    65,    66,    68,    69,   370,
     407,   410,   423,    66,   107,   370,   409,   423,    35,    40,
     369,   441,   404,     3,     3,   404,    61,   405,     3,     3,
      73,   467,   491,   491,     3,    35,    40,   369,   444,    19,
      20,    40,   492,     3,   138,   463,     3,     3,   460,   466,
      19,    83,   146,   301,   313,   314,   456,   456,    18,    19,
     381,   383,   383,     3,     3,     3,     3,     3,     3,     3,
      15,    19,    28,   366,   372,   527,   529,   535,    29,   366,
     199,    27,   199,    15,   372,   530,   537,   366,   366,   366,
     366,   366,   366,   178,   179,   180,   181,   517,   537,    15,
      16,    17,    19,   366,   379,   510,   511,   515,   518,   519,
     521,   523,   524,   525,     5,    71,    72,    74,    75,   100,
     133,   182,   183,   185,   186,   187,   188,   189,   222,   223,
     224,   225,   226,   227,   228,   229,   230,   248,   249,   260,
     261,   262,   263,   358,   359,   536,   643,     3,     8,     9,
      10,    11,    12,    22,    23,    24,    25,    26,    27,    28,
      29,    32,    41,    42,    43,    44,    45,    46,    47,    48,
      49,   392,   393,    15,   481,     3,    22,    57,   389,    40,
     369,   391,   441,   366,   379,    20,    53,   365,   125,   416,
      15,    17,    18,   100,   412,   494,    19,   414,   365,   444,
     506,   100,   369,   369,   419,   369,   441,    19,   427,    77,
     379,    34,    35,    36,    37,   379,   380,   439,    40,    86,
      87,    91,    97,   200,   424,   502,    91,   424,    91,    20,
     444,   365,   365,   369,   219,   220,   221,    20,   380,    91,
     139,   235,   121,   203,   381,   381,    67,   206,    67,   365,
     379,   204,   212,   223,   224,   216,   218,   233,   234,   233,
     237,   380,   240,   242,   247,    73,   216,    82,   252,   216,
     255,   253,   380,   365,   369,   412,   380,    76,   379,   380,
     365,   369,   369,    73,   318,   319,   365,   369,   369,    67,
     629,   630,    20,   379,   369,    87,   353,   354,   624,   379,
     379,    67,   202,   356,   357,   365,   365,   369,   369,   292,
     383,    73,   365,   157,   210,   243,   252,   361,   362,   363,
     364,   365,    73,   380,    67,   380,    70,   365,   365,   365,
      67,    20,   387,   365,   365,    70,    88,    89,   103,   104,
     106,   442,   443,     3,   405,     3,   379,     3,    19,     3,
       3,     3,    88,   130,   445,   446,     3,   492,     3,     3,
       3,    73,   110,   127,   203,   464,     3,    40,    73,    78,
      85,    86,    98,   107,   108,   109,   110,   112,   383,   461,
     502,     3,    19,    73,    78,    79,    86,   114,   151,   456,
     456,   585,    40,   456,    40,   456,     3,     3,    29,   368,
     385,   115,   115,   529,   529,   537,   529,   529,    14,    15,
     537,   541,   542,    26,   199,    27,   530,   530,    29,   537,
     537,   537,   537,   537,    19,    15,   371,   367,   371,    28,
     513,   514,   517,   537,     7,   371,   374,    26,    27,   369,
     371,   374,   537,   537,   537,   537,   537,   537,   537,   537,
     537,   537,   537,   537,   537,   161,   184,   190,   195,   196,
     370,   371,     3,   537,    20,   392,   365,   537,   379,    54,
      55,   434,   435,   365,   159,   160,   161,   162,   163,   164,
     165,   167,   168,   169,   170,   171,   496,   497,   498,   500,
     504,   119,   120,   121,   122,   365,   415,   365,   366,   503,
      19,   114,   370,   412,   429,   432,   433,    19,   500,   501,
      35,   379,   426,    98,   537,   426,   426,    67,    67,    46,
     365,   365,   379,   245,   380,   381,   379,   203,    30,   382,
     379,    67,   379,   365,    67,    97,   213,   379,   379,   380,
      67,   365,    77,   365,   380,   365,   380,   213,   243,   244,
     380,   427,   380,   365,   365,   380,   380,   380,   365,   380,
      91,   551,    19,   365,   365,   592,   379,   433,   365,   365,
     448,   449,   365,   365,   365,   379,   365,   365,   365,    77,
     113,   156,   451,   380,   427,    20,   381,   381,   210,   634,
     635,   379,   379,   380,   379,   381,   383,   384,   370,   371,
       3,   370,   371,     3,    19,    15,   383,    19,    19,   501,
     384,    19,    20,   576,   576,     3,    19,    76,   213,   259,
     274,   292,   307,   308,   456,   576,   456,   576,   379,   381,
      15,    15,   367,   371,   367,    27,   371,   371,   371,   367,
     371,   367,   371,   537,   537,     7,   371,   371,   367,    18,
     511,   519,    15,    18,   524,   366,   393,   365,   370,    20,
     433,   365,    19,   166,   365,   369,   381,   379,   367,   497,
     499,   504,   383,    27,   431,   371,    92,   425,   380,   379,
     379,   380,   365,   380,   365,   365,   365,   379,    19,   203,
     365,   379,   365,   379,   365,   365,   365,   365,   365,   379,
     412,   365,   365,   365,   365,   365,   365,   365,   365,   365,
     365,   365,   379,    83,   138,   214,   265,   289,   291,   298,
     300,   304,   305,   370,   552,   559,   562,   365,    83,   162,
     339,   340,   343,   370,   423,   589,   365,   369,   628,   370,
     365,   365,   379,   100,   102,   100,   102,   370,   365,   365,
     382,   381,   303,   634,   443,   446,     3,     3,   412,   412,
      15,   412,   576,     3,   576,     3,   203,   203,   541,    27,
     537,   537,   537,   537,   537,   371,   367,   513,   537,   514,
     516,   537,   371,   537,   498,    19,    46,    80,   152,   153,
     154,   155,   156,   157,   158,   172,   175,   507,   508,   533,
     534,   538,   543,   365,   367,   115,    20,   384,   430,   432,
      93,    94,    95,    96,   365,   371,   365,   365,   365,   379,
     365,   365,   365,   365,   571,   575,   380,   267,   268,   304,
     267,   380,   553,   292,   383,   555,   556,   554,   306,   380,
     365,   309,   572,   594,   601,   383,   602,   607,   590,   591,
     383,   365,   627,   448,   365,    20,   386,   386,   386,   386,
     382,   379,     3,     3,    15,    15,   367,   367,   367,   367,
     371,   537,   367,   371,    15,   367,    22,   366,    22,   366,
     537,   537,   537,   370,   543,   536,   643,   365,   537,   539,
     540,   499,    15,   384,   379,   365,   433,   379,   379,   380,
     379,   369,   412,   369,   369,   379,   379,   369,   433,   369,
     606,   369,   381,   608,   613,    20,   369,   614,   619,   216,
     254,   312,   317,   370,   626,   451,   365,   365,   365,   365,
     467,   467,   537,   367,     7,    28,   516,   370,   537,   542,
     537,   533,   365,   173,   369,    22,    22,    32,   371,   365,
     203,   365,   572,   564,   557,   564,   560,   369,   600,   605,
     604,   609,   615,   379,   255,   134,   135,   272,   436,   275,
     349,   350,   351,   352,   625,   365,   451,   451,   451,   451,
       3,     3,   367,   366,   367,     7,   367,   365,   367,   365,
     643,   369,   509,   543,   526,   537,   537,    86,   141,   142,
     194,   199,   540,    15,   369,   574,   370,   383,   565,   566,
     138,   267,   290,   370,   558,   370,   220,   269,   270,   271,
     273,   284,   370,   447,   561,   599,   598,   332,   333,   336,
     337,   338,   370,   603,   612,   618,   312,   380,   379,   379,
     379,   513,   516,   367,   507,   174,     6,    15,    16,    17,
     366,   370,   510,   512,   515,   518,   520,   522,   365,   365,
     366,   366,   366,   366,   365,   365,   573,   290,   299,   567,
     380,   379,   380,   365,   379,   379,   379,   218,   109,   379,
      87,   283,   286,   365,   115,   162,   214,   292,   321,   324,
     325,   328,   329,   331,   339,   340,   370,   595,   335,   335,
     380,   380,   380,   365,   335,   341,   370,   610,   335,   342,
     370,   616,   293,   371,   367,   365,   370,   509,   507,   537,
       7,   368,   371,   537,   537,   537,   537,    60,   146,   220,
     254,   265,   267,   269,   270,   271,   272,   273,   274,   280,
     284,   285,   288,   294,   302,   310,   312,   370,   447,   563,
     379,   365,   379,   379,   322,   607,   335,   327,   218,   322,
     380,   326,    67,   330,   212,   201,   596,   201,   597,   365,
     379,   379,   334,   379,   620,   608,   611,   365,   620,   614,
     617,   365,   513,   367,   366,   512,   507,   520,   367,   367,
     367,   367,   292,   369,   379,   255,   380,   379,   379,   379,
     218,   379,   109,   379,   275,   276,   277,   278,   279,   280,
     281,   282,   311,    87,   283,   286,   277,   379,   295,   303,
     275,   272,   436,   365,   323,   379,   379,   379,   323,   380,
     379,   379,    91,   380,   613,   380,   619,   344,   621,   621,
     379,   367,   537,   365,   365,   365,   365,   380,   568,   312,
     380,   379,   379,   380,   380,   296,   297,   379,   379,   380,
     379,   379,   621,   379,   379,   380,    18,   370,   570,   293,
     287,   569,   365
};

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		(-2)
#define YYEOF		0

#define YYACCEPT	goto yyacceptlab
#define YYABORT		goto yyabortlab
#define YYERROR		goto yyerrorlab


/* Like YYERROR except do call yyerror.  This remains here temporarily
   to ease the transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  However,
   YYFAIL appears to be in use.  Nevertheless, it is formally deprecated
   in Bison 2.4.2's NEWS entry, where a plan to phase it out is
   discussed.  */

#define YYFAIL		goto yyerrlab
#if defined YYFAIL
  /* This is here to suppress warnings from the GCC cpp's
     -Wunused-macros.  Normally we don't worry about that warning, but
     some users do, and we want to make it easy for users to remove
     YYFAIL uses, which will produce warnings from Bison 2.5.  */
#endif

#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                  \
do                                                              \
  if (yychar == YYEMPTY)                                        \
    {                                                           \
      yychar = (Token);                                         \
      yylval = (Value);                                         \
      YYPOPSTACK (yylen);                                       \
      yystate = *yyssp;                                         \
      goto yybackup;                                            \
    }                                                           \
  else                                                          \
    {                                                           \
      yyerror (YY_("syntax error: cannot back up")); \
      YYERROR;							\
    }								\
while (YYID (0))

/* Error token number */
#define YYTERROR	1
#define YYERRCODE	256


/* This macro is provided for backward compatibility. */
#ifndef YY_LOCATION_PRINT
# define YY_LOCATION_PRINT(File, Loc) ((void) 0)
#endif


/* YYLEX -- calling `yylex' with the right arguments.  */
#ifdef YYLEX_PARAM
# define YYLEX yylex (YYLEX_PARAM)
#else
# define YYLEX yylex ()
#endif

/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)			\
do {						\
  if (yydebug)					\
    YYFPRINTF Args;				\
} while (YYID (0))

# define YY_SYMBOL_PRINT(Title, Type, Value, Location)			  \
do {									  \
  if (yydebug)								  \
    {									  \
      YYFPRINTF (stderr, "%s ", Title);					  \
      yy_symbol_print (stderr,						  \
		  Type, Value); \
      YYFPRINTF (stderr, "\n");						  \
    }									  \
} while (YYID (0))


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

/*ARGSUSED*/
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_symbol_value_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
#else
static void
yy_symbol_value_print (yyoutput, yytype, yyvaluep)
    FILE *yyoutput;
    int yytype;
    YYSTYPE const * const yyvaluep;
#endif
{
  FILE *yyo = yyoutput;
  YYUSE (yyo);
  if (!yyvaluep)
    return;
# ifdef YYPRINT
  if (yytype < YYNTOKENS)
    YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# else
  YYUSE (yyoutput);
# endif
  switch (yytype)
    {
      default:
        break;
    }
}


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_symbol_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
#else
static void
yy_symbol_print (yyoutput, yytype, yyvaluep)
    FILE *yyoutput;
    int yytype;
    YYSTYPE const * const yyvaluep;
#endif
{
  if (yytype < YYNTOKENS)
    YYFPRINTF (yyoutput, "token %s (", yytname[yytype]);
  else
    YYFPRINTF (yyoutput, "nterm %s (", yytname[yytype]);

  yy_symbol_value_print (yyoutput, yytype, yyvaluep);
  YYFPRINTF (yyoutput, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_stack_print (yytype_int16 *yybottom, yytype_int16 *yytop)
#else
static void
yy_stack_print (yybottom, yytop)
    yytype_int16 *yybottom;
    yytype_int16 *yytop;
#endif
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)				\
do {								\
  if (yydebug)							\
    yy_stack_print ((Bottom), (Top));				\
} while (YYID (0))


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_reduce_print (YYSTYPE *yyvsp, int yyrule)
#else
static void
yy_reduce_print (yyvsp, yyrule)
    YYSTYPE *yyvsp;
    int yyrule;
#endif
{
  int yynrhs = yyr2[yyrule];
  int yyi;
  unsigned long int yylno = yyrline[yyrule];
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %lu):\n",
	     yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr, yyrhs[yyprhs[yyrule] + yyi],
		       &(yyvsp[(yyi + 1) - (yynrhs)])
		       		       );
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)		\
do {					\
  if (yydebug)				\
    yy_reduce_print (yyvsp, Rule); \
} while (YYID (0))

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef	YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif


#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined __GLIBC__ && defined _STRING_H
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static YYSIZE_T
yystrlen (const char *yystr)
#else
static YYSIZE_T
yystrlen (yystr)
    const char *yystr;
#endif
{
  YYSIZE_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static char *
yystpcpy (char *yydest, const char *yysrc)
#else
static char *
yystpcpy (yydest, yysrc)
    char *yydest;
    const char *yysrc;
#endif
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

# ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYSIZE_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYSIZE_T yyn = 0;
      char const *yyp = yystr;

      for (;;)
	switch (*++yyp)
	  {
	  case '\'':
	  case ',':
	    goto do_not_strip_quotes;

	  case '\\':
	    if (*++yyp != '\\')
	      goto do_not_strip_quotes;
	    /* Fall through.  */
	  default:
	    if (yyres)
	      yyres[yyn] = *yyp;
	    yyn++;
	    break;

	  case '"':
	    if (yyres)
	      yyres[yyn] = '\0';
	    return yyn;
	  }
    do_not_strip_quotes: ;
    }

  if (! yyres)
    return yystrlen (yystr);

  return yystpcpy (yyres, yystr) - yyres;
}
# endif

/* Copy into *YYMSG, which is of size *YYMSG_ALLOC, an error message
   about the unexpected token YYTOKEN for the state stack whose top is
   YYSSP.

   Return 0 if *YYMSG was successfully written.  Return 1 if *YYMSG is
   not large enough to hold the message.  In that case, also set
   *YYMSG_ALLOC to the required number of bytes.  Return 2 if the
   required number of bytes is too large to store.  */
static int
yysyntax_error (YYSIZE_T *yymsg_alloc, char **yymsg,
                yytype_int16 *yyssp, int yytoken)
{
  YYSIZE_T yysize0 = yytnamerr (YY_NULL, yytname[yytoken]);
  YYSIZE_T yysize = yysize0;
  enum { YYERROR_VERBOSE_ARGS_MAXIMUM = 5 };
  /* Internationalized format string. */
  const char *yyformat = YY_NULL;
  /* Arguments of yyformat. */
  char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];
  /* Number of reported tokens (one for the "unexpected", one per
     "expected"). */
  int yycount = 0;

  /* There are many possibilities here to consider:
     - Assume YYFAIL is not used.  It's too flawed to consider.  See
       <http://lists.gnu.org/archive/html/bison-patches/2009-12/msg00024.html>
       for details.  YYERROR is fine as it does not invoke this
       function.
     - If this state is a consistent state with a default action, then
       the only way this function was invoked is if the default action
       is an error action.  In that case, don't check for expected
       tokens because there are none.
     - The only way there can be no lookahead present (in yychar) is if
       this state is a consistent state with a default action.  Thus,
       detecting the absence of a lookahead is sufficient to determine
       that there is no unexpected or expected token to report.  In that
       case, just report a simple "syntax error".
     - Don't assume there isn't a lookahead just because this state is a
       consistent state with a default action.  There might have been a
       previous inconsistent state, consistent state with a non-default
       action, or user semantic action that manipulated yychar.
     - Of course, the expected token list depends on states to have
       correct lookahead information, and it depends on the parser not
       to perform extra reductions after fetching a lookahead from the
       scanner and before detecting a syntax error.  Thus, state merging
       (from LALR or IELR) and default reductions corrupt the expected
       token list.  However, the list is correct for canonical LR with
       one exception: it will still contain any token that will not be
       accepted due to an error action in a later state.
  */
  if (yytoken != YYEMPTY)
    {
      int yyn = yypact[*yyssp];
      yyarg[yycount++] = yytname[yytoken];
      if (!yypact_value_is_default (yyn))
        {
          /* Start YYX at -YYN if negative to avoid negative indexes in
             YYCHECK.  In other words, skip the first -YYN actions for
             this state because they are default actions.  */
          int yyxbegin = yyn < 0 ? -yyn : 0;
          /* Stay within bounds of both yycheck and yytname.  */
          int yychecklim = YYLAST - yyn + 1;
          int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
          int yyx;

          for (yyx = yyxbegin; yyx < yyxend; ++yyx)
            if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR
                && !yytable_value_is_error (yytable[yyx + yyn]))
              {
                if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
                  {
                    yycount = 1;
                    yysize = yysize0;
                    break;
                  }
                yyarg[yycount++] = yytname[yyx];
                {
                  YYSIZE_T yysize1 = yysize + yytnamerr (YY_NULL, yytname[yyx]);
                  if (! (yysize <= yysize1
                         && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
                    return 2;
                  yysize = yysize1;
                }
              }
        }
    }

  switch (yycount)
    {
# define YYCASE_(N, S)                      \
      case N:                               \
        yyformat = S;                       \
      break
      YYCASE_(0, YY_("syntax error"));
      YYCASE_(1, YY_("syntax error, unexpected %s"));
      YYCASE_(2, YY_("syntax error, unexpected %s, expecting %s"));
      YYCASE_(3, YY_("syntax error, unexpected %s, expecting %s or %s"));
      YYCASE_(4, YY_("syntax error, unexpected %s, expecting %s or %s or %s"));
      YYCASE_(5, YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s"));
# undef YYCASE_
    }

  {
    YYSIZE_T yysize1 = yysize + yystrlen (yyformat);
    if (! (yysize <= yysize1 && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
      return 2;
    yysize = yysize1;
  }

  if (*yymsg_alloc < yysize)
    {
      *yymsg_alloc = 2 * yysize;
      if (! (yysize <= *yymsg_alloc
             && *yymsg_alloc <= YYSTACK_ALLOC_MAXIMUM))
        *yymsg_alloc = YYSTACK_ALLOC_MAXIMUM;
      return 1;
    }

  /* Avoid sprintf, as that infringes on the user's name space.
     Don't have undefined behavior even if the translation
     produced a string with the wrong number of "%s"s.  */
  {
    char *yyp = *yymsg;
    int yyi = 0;
    while ((*yyp = *yyformat) != '\0')
      if (*yyp == '%' && yyformat[1] == 's' && yyi < yycount)
        {
          yyp += yytnamerr (yyp, yyarg[yyi++]);
          yyformat += 2;
        }
      else
        {
          yyp++;
          yyformat++;
        }
  }
  return 0;
}
#endif /* YYERROR_VERBOSE */

/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

/*ARGSUSED*/
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yydestruct (const char *yymsg, int yytype, YYSTYPE *yyvaluep)
#else
static void
yydestruct (yymsg, yytype, yyvaluep)
    const char *yymsg;
    int yytype;
    YYSTYPE *yyvaluep;
#endif
{
  YYUSE (yyvaluep);

  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

  switch (yytype)
    {

      default:
        break;
    }
}




/* The lookahead symbol.  */
int yychar;


#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval YY_INITIAL_VALUE(yyval_default);

/* Number of syntax errors so far.  */
int yynerrs;


/*----------.
| yyparse.  |
`----------*/

#ifdef YYPARSE_PARAM
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
int
yyparse (void *YYPARSE_PARAM)
#else
int
yyparse (YYPARSE_PARAM)
    void *YYPARSE_PARAM;
#endif
#else /* ! YYPARSE_PARAM */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
int
yyparse (void)
#else
int
yyparse ()

#endif
#endif
{
    int yystate;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus;

    /* The stacks and their tools:
       `yyss': related to states.
       `yyvs': related to semantic values.

       Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* The state stack.  */
    yytype_int16 yyssa[YYINITDEPTH];
    yytype_int16 *yyss;
    yytype_int16 *yyssp;

    /* The semantic value stack.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs;
    YYSTYPE *yyvsp;

    YYSIZE_T yystacksize;

  int yyn;
  int yyresult;
  /* Lookahead token as an internal (translated) token number.  */
  int yytoken = 0;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;

#if YYERROR_VERBOSE
  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYSIZE_T yymsg_alloc = sizeof yymsgbuf;
#endif

#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  yyssp = yyss = yyssa;
  yyvsp = yyvs = yyvsa;
  yystacksize = YYINITDEPTH;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY; /* Cause a token to be read.  */
  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
	/* Give user a chance to reallocate the stack.  Use copies of
	   these so that the &'s don't force the real ones into
	   memory.  */
	YYSTYPE *yyvs1 = yyvs;
	yytype_int16 *yyss1 = yyss;

	/* Each stack pointer address is followed by the size of the
	   data in use in that stack, in bytes.  This used to be a
	   conditional around just the two extra args, but that might
	   be undefined if yyoverflow is a macro.  */
	yyoverflow (YY_("memory exhausted"),
		    &yyss1, yysize * sizeof (*yyssp),
		    &yyvs1, yysize * sizeof (*yyvsp),
		    &yystacksize);

	yyss = yyss1;
	yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyexhaustedlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
	goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
	yystacksize = YYMAXDEPTH;

      {
	yytype_int16 *yyss1 = yyss;
	union yyalloc *yyptr =
	  (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
	if (! yyptr)
	  goto yyexhaustedlab;
	YYSTACK_RELOCATE (yyss_alloc, yyss);
	YYSTACK_RELOCATE (yyvs_alloc, yyvs);
#  undef YYSTACK_RELOCATE
	if (yyss1 != yyssa)
	  YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;

      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
		  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
	YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = YYLEX;
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);

  /* Discard the shifted token.  */
  yychar = YYEMPTY;

  yystate = yyn;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END

  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     `$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 2:
/* Line 1792 of yacc.c  */
#line 684 "cf-parse.y"
    { return 0; }
    break;

  case 3:
/* Line 1792 of yacc.c  */
#line 685 "cf-parse.y"
    { return 0; }
    break;

  case 6:
/* Line 1792 of yacc.c  */
#line 698 "cf-parse.y"
    {
     struct f_val *val = cfg_alloc(sizeof(struct f_val));
     *val = f_eval((yyvsp[(4) - (5)].x), cfg_mem);
     if (val->type == T_RETURN) cf_error("Runtime error");
     cf_define_symbol((yyvsp[(2) - (5)].s), SYM_CONSTANT | val->type, val);
   }
    break;

  case 8:
/* Line 1792 of yacc.c  */
#line 708 "cf-parse.y"
    { (yyval.i) = f_eval_int((yyvsp[(2) - (3)].x)); }
    break;

  case 9:
/* Line 1792 of yacc.c  */
#line 709 "cf-parse.y"
    {
     if ((yyvsp[(1) - (1)].s)->class != (SYM_CONSTANT | T_INT)) cf_error("Number expected");
     (yyval.i) = SYM_VAL((yyvsp[(1) - (1)].s)).i; }
    break;

  case 10:
/* Line 1792 of yacc.c  */
#line 719 "cf-parse.y"
    {(yyval.i) = !!(yyvsp[(1) - (1)].i); }
    break;

  case 11:
/* Line 1792 of yacc.c  */
#line 720 "cf-parse.y"
    { (yyval.i) = 1; }
    break;

  case 12:
/* Line 1792 of yacc.c  */
#line 721 "cf-parse.y"
    { (yyval.i) = 1; }
    break;

  case 13:
/* Line 1792 of yacc.c  */
#line 722 "cf-parse.y"
    { (yyval.i) = 0; }
    break;

  case 14:
/* Line 1792 of yacc.c  */
#line 723 "cf-parse.y"
    { (yyval.i) = 0; }
    break;

  case 15:
/* Line 1792 of yacc.c  */
#line 724 "cf-parse.y"
    { (yyval.i) = 1; }
    break;

  case 17:
/* Line 1792 of yacc.c  */
#line 731 "cf-parse.y"
    {
     if ((yyvsp[(1) - (1)].s)->class != (SYM_CONSTANT | T_IP)) cf_error("IP address expected");
     (yyval.a) = SYM_VAL((yyvsp[(1) - (1)].s)).px.ip;
   }
    break;

  case 18:
/* Line 1792 of yacc.c  */
#line 738 "cf-parse.y"
    { (yyval.iface) = NULL; }
    break;

  case 19:
/* Line 1792 of yacc.c  */
#line 739 "cf-parse.y"
    { (yyval.iface) = if_get_by_name((yyvsp[(2) - (2)].s)->name); }
    break;

  case 20:
/* Line 1792 of yacc.c  */
#line 743 "cf-parse.y"
    {
     if (!ip_is_prefix((yyvsp[(1) - (2)].a), (yyvsp[(2) - (2)].i))) cf_error("Invalid prefix");
     (yyval.px).addr = (yyvsp[(1) - (2)].a); (yyval.px).len = (yyvsp[(2) - (2)].i);
   }
    break;

  case 22:
/* Line 1792 of yacc.c  */
#line 751 "cf-parse.y"
    { (yyval.px).addr = (yyvsp[(1) - (1)].a); (yyval.px).len = BITS_PER_IP_ADDRESS; }
    break;

  case 23:
/* Line 1792 of yacc.c  */
#line 755 "cf-parse.y"
    {
     if ((yyvsp[(2) - (2)].i) < 0 || (yyvsp[(2) - (2)].i) > BITS_PER_IP_ADDRESS) cf_error("Invalid prefix length %d", (yyvsp[(2) - (2)].i));
     (yyval.i) = (yyvsp[(2) - (2)].i);
   }
    break;

  case 24:
/* Line 1792 of yacc.c  */
#line 759 "cf-parse.y"
    {
     (yyval.i) = ipa_mklen((yyvsp[(2) - (2)].a));
     if ((yyval.i) < 0) cf_error("Invalid netmask %I", (yyvsp[(2) - (2)].a));
   }
    break;

  case 25:
/* Line 1792 of yacc.c  */
#line 766 "cf-parse.y"
    {
     (yyval.time) = tm_parse_datetime((yyvsp[(1) - (1)].t));
     if (!(yyval.time))
       cf_error("Invalid date and time");
   }
    break;

  case 26:
/* Line 1792 of yacc.c  */
#line 774 "cf-parse.y"
    { (yyval.t) = (yyvsp[(1) - (1)].t); }
    break;

  case 27:
/* Line 1792 of yacc.c  */
#line 775 "cf-parse.y"
    { (yyval.t) = NULL; }
    break;

  case 28:
/* Line 1792 of yacc.c  */
#line 781 "cf-parse.y"
    {
    struct log_config *c = cfg_allocz(sizeof(struct log_config));
    c->fh = (yyvsp[(2) - (4)].g);
    c->mask = (yyvsp[(3) - (4)].i);
    add_tail(&new_config->logfiles, &c->n);
  }
    break;

  case 29:
/* Line 1792 of yacc.c  */
#line 790 "cf-parse.y"
    { (yyval.t) = (yyvsp[(2) - (2)].t); }
    break;

  case 30:
/* Line 1792 of yacc.c  */
#line 791 "cf-parse.y"
    { (yyval.t) = bird_name; }
    break;

  case 31:
/* Line 1792 of yacc.c  */
#line 795 "cf-parse.y"
    {
     FILE *f = tracked_fopen(new_config->pool, (yyvsp[(1) - (1)].t), "a");
     if (!f) cf_error("Unable to open log file `%s': %m", (yyvsp[(1) - (1)].t));
     (yyval.g) = f;
   }
    break;

  case 32:
/* Line 1792 of yacc.c  */
#line 800 "cf-parse.y"
    { (yyval.g) = NULL; new_config->syslog_name = (yyvsp[(2) - (2)].t); }
    break;

  case 33:
/* Line 1792 of yacc.c  */
#line 801 "cf-parse.y"
    { (yyval.g) = stderr; }
    break;

  case 34:
/* Line 1792 of yacc.c  */
#line 805 "cf-parse.y"
    { (yyval.i) = ~0; }
    break;

  case 35:
/* Line 1792 of yacc.c  */
#line 806 "cf-parse.y"
    { (yyval.i) = (yyvsp[(2) - (3)].i); }
    break;

  case 36:
/* Line 1792 of yacc.c  */
#line 810 "cf-parse.y"
    { (yyval.i) = 1 << (yyvsp[(1) - (1)].i); }
    break;

  case 37:
/* Line 1792 of yacc.c  */
#line 811 "cf-parse.y"
    { (yyval.i) = (yyvsp[(1) - (3)].i) | (1 << (yyvsp[(3) - (3)].i)); }
    break;

  case 38:
/* Line 1792 of yacc.c  */
#line 815 "cf-parse.y"
    { (yyval.i) = L_DEBUG[0]; }
    break;

  case 39:
/* Line 1792 of yacc.c  */
#line 816 "cf-parse.y"
    { (yyval.i) = L_TRACE[0]; }
    break;

  case 40:
/* Line 1792 of yacc.c  */
#line 817 "cf-parse.y"
    { (yyval.i) = L_INFO[0]; }
    break;

  case 41:
/* Line 1792 of yacc.c  */
#line 818 "cf-parse.y"
    { (yyval.i) = L_REMOTE[0]; }
    break;

  case 42:
/* Line 1792 of yacc.c  */
#line 819 "cf-parse.y"
    { (yyval.i) = L_WARN[0]; }
    break;

  case 43:
/* Line 1792 of yacc.c  */
#line 820 "cf-parse.y"
    { (yyval.i) = L_ERR[0]; }
    break;

  case 44:
/* Line 1792 of yacc.c  */
#line 821 "cf-parse.y"
    { (yyval.i) = L_AUTH[0]; }
    break;

  case 45:
/* Line 1792 of yacc.c  */
#line 822 "cf-parse.y"
    { (yyval.i) = L_FATAL[0]; }
    break;

  case 46:
/* Line 1792 of yacc.c  */
#line 823 "cf-parse.y"
    { (yyval.i) = L_BUG[0]; }
    break;

  case 47:
/* Line 1792 of yacc.c  */
#line 829 "cf-parse.y"
    { new_config->proto_default_mrtdump = (yyvsp[(3) - (4)].i); }
    break;

  case 48:
/* Line 1792 of yacc.c  */
#line 830 "cf-parse.y"
    {
     FILE *f = tracked_fopen(new_config->pool, (yyvsp[(2) - (3)].t), "a");
     if (!f) cf_error("Unable to open MRTDump file '%s': %m", (yyvsp[(2) - (3)].t));
     new_config->mrtdump_file = fileno(f);
   }
    break;

  case 49:
/* Line 1792 of yacc.c  */
#line 839 "cf-parse.y"
    { (yyval.tf) = &new_config->tf_route; }
    break;

  case 50:
/* Line 1792 of yacc.c  */
#line 840 "cf-parse.y"
    { (yyval.tf) = &new_config->tf_proto; }
    break;

  case 51:
/* Line 1792 of yacc.c  */
#line 841 "cf-parse.y"
    { (yyval.tf) = &new_config->tf_base; }
    break;

  case 52:
/* Line 1792 of yacc.c  */
#line 842 "cf-parse.y"
    { (yyval.tf) = &new_config->tf_log; }
    break;

  case 53:
/* Line 1792 of yacc.c  */
#line 845 "cf-parse.y"
    { *(yyvsp[(1) - (2)].tf) = (struct timeformat){(yyvsp[(2) - (2)].t), NULL, 0}; }
    break;

  case 54:
/* Line 1792 of yacc.c  */
#line 846 "cf-parse.y"
    { *(yyvsp[(1) - (4)].tf) = (struct timeformat){(yyvsp[(2) - (4)].t), (yyvsp[(4) - (4)].t), (yyvsp[(3) - (4)].i)}; }
    break;

  case 55:
/* Line 1792 of yacc.c  */
#line 847 "cf-parse.y"
    { *(yyvsp[(1) - (3)].tf) = (struct timeformat){"%T", "%F", 20*3600}; }
    break;

  case 56:
/* Line 1792 of yacc.c  */
#line 848 "cf-parse.y"
    { *(yyvsp[(1) - (3)].tf) = (struct timeformat){"%F %T", NULL, 0}; }
    break;

  case 58:
/* Line 1792 of yacc.c  */
#line 860 "cf-parse.y"
    { cmd_reconfig((yyvsp[(2) - (4)].t), RECONFIG_HARD, (yyvsp[(3) - (4)].i)); }
    break;

  case 59:
/* Line 1792 of yacc.c  */
#line 863 "cf-parse.y"
    { cmd_reconfig((yyvsp[(3) - (5)].t), RECONFIG_SOFT, (yyvsp[(4) - (5)].i)); }
    break;

  case 60:
/* Line 1792 of yacc.c  */
#line 870 "cf-parse.y"
    { cmd_reconfig_confirm(); }
    break;

  case 61:
/* Line 1792 of yacc.c  */
#line 873 "cf-parse.y"
    { cmd_reconfig_undo(); }
    break;

  case 62:
/* Line 1792 of yacc.c  */
#line 876 "cf-parse.y"
    { cmd_check_config((yyvsp[(3) - (4)].t)); }
    break;

  case 63:
/* Line 1792 of yacc.c  */
#line 879 "cf-parse.y"
    { cmd_shutdown(); }
    break;

  case 64:
/* Line 1792 of yacc.c  */
#line 882 "cf-parse.y"
    { (yyval.t) = NULL; }
    break;

  case 66:
/* Line 1792 of yacc.c  */
#line 887 "cf-parse.y"
    { (yyval.i) = 0; }
    break;

  case 67:
/* Line 1792 of yacc.c  */
#line 888 "cf-parse.y"
    { (yyval.i) = UNIX_DEFAULT_CONFIGURE_TIMEOUT; }
    break;

  case 68:
/* Line 1792 of yacc.c  */
#line 889 "cf-parse.y"
    { (yyval.i) = (yyvsp[(2) - (2)].i); }
    break;

  case 69:
/* Line 1792 of yacc.c  */
#line 897 "cf-parse.y"
    { this_proto = krt_init_config((yyvsp[(1) - (2)].i)); }
    break;

  case 70:
/* Line 1792 of yacc.c  */
#line 902 "cf-parse.y"
    { THIS_KRT->persist = (yyvsp[(2) - (2)].i); }
    break;

  case 71:
/* Line 1792 of yacc.c  */
#line 903 "cf-parse.y"
    {
      /* Scan time of 0 means scan on startup only */
      THIS_KRT->scan_time = (yyvsp[(3) - (3)].i);
   }
    break;

  case 72:
/* Line 1792 of yacc.c  */
#line 907 "cf-parse.y"
    {
      THIS_KRT->learn = (yyvsp[(2) - (2)].i);
#ifndef KRT_ALLOW_LEARN
      if ((yyvsp[(2) - (2)].i))
	cf_error("Learning of kernel routes not supported in this configuration");
#endif
   }
    break;

  case 73:
/* Line 1792 of yacc.c  */
#line 914 "cf-parse.y"
    { THIS_KRT->devroutes = (yyvsp[(3) - (3)].i); }
    break;

  case 74:
/* Line 1792 of yacc.c  */
#line 920 "cf-parse.y"
    { this_proto = kif_init_config((yyvsp[(1) - (2)].i)); }
    break;

  case 75:
/* Line 1792 of yacc.c  */
#line 925 "cf-parse.y"
    {
      /* Scan time of 0 means scan on startup only */
      THIS_KIF->scan_time = (yyvsp[(3) - (3)].i);
   }
    break;

  case 76:
/* Line 1792 of yacc.c  */
#line 929 "cf-parse.y"
    {
     struct kif_primary_item *kpi = cfg_alloc(sizeof (struct kif_primary_item));
     kpi->pattern = (yyvsp[(2) - (3)].t);
     kpi->prefix = (yyvsp[(3) - (3)].px).addr;
     kpi->pxlen = (yyvsp[(3) - (3)].px).len;
     add_tail(&THIS_KIF->primary, &kpi->n);
   }
    break;

  case 77:
/* Line 1792 of yacc.c  */
#line 943 "cf-parse.y"
    {
	if ((yyvsp[(3) - (3)].i) <= 0 || (yyvsp[(3) - (3)].i) >= NL_NUM_TABLES)
	  cf_error("Kernel routing table number out of range");
	THIS_KRT->sys.table_id = (yyvsp[(3) - (3)].i);
   }
    break;

  case 78:
/* Line 1792 of yacc.c  */
#line 957 "cf-parse.y"
    { new_config->router_id = (yyvsp[(3) - (4)].i32); }
    break;

  case 79:
/* Line 1792 of yacc.c  */
#line 958 "cf-parse.y"
    { new_config->router_id_from = this_ipatt; }
    break;

  case 80:
/* Line 1792 of yacc.c  */
#line 962 "cf-parse.y"
    { (yyval.i32) = (yyvsp[(1) - (1)].i); }
    break;

  case 82:
/* Line 1792 of yacc.c  */
#line 964 "cf-parse.y"
    {
#ifndef IPV6
     (yyval.i32) = ipa_to_u32((yyvsp[(1) - (1)].a));
#else
     cf_error("Router IDs must be entered as hexadecimal numbers or IPv4 addresses in IPv6 version");
#endif
   }
    break;

  case 86:
/* Line 1792 of yacc.c  */
#line 983 "cf-parse.y"
    { new_config->listen_bgp_addr = (yyvsp[(2) - (2)].a); }
    break;

  case 87:
/* Line 1792 of yacc.c  */
#line 984 "cf-parse.y"
    { new_config->listen_bgp_port = (yyvsp[(2) - (2)].i); }
    break;

  case 88:
/* Line 1792 of yacc.c  */
#line 985 "cf-parse.y"
    { new_config->listen_bgp_flags = 0; }
    break;

  case 89:
/* Line 1792 of yacc.c  */
#line 986 "cf-parse.y"
    { new_config->listen_bgp_flags = 1; }
    break;

  case 90:
/* Line 1792 of yacc.c  */
#line 993 "cf-parse.y"
    { (yyval.i) = 0; }
    break;

  case 91:
/* Line 1792 of yacc.c  */
#line 994 "cf-parse.y"
    { (yyval.i) = 1; }
    break;

  case 92:
/* Line 1792 of yacc.c  */
#line 998 "cf-parse.y"
    {
   struct rtable_config *cf;
   cf = rt_new_table((yyvsp[(2) - (3)].s));
   cf->sorted = (yyvsp[(3) - (3)].i);
   }
    break;

  case 93:
/* Line 1792 of yacc.c  */
#line 1006 "cf-parse.y"
    {
  this_roa_table = roa_new_table_config((yyvsp[(3) - (3)].s));
}
    break;

  case 95:
/* Line 1792 of yacc.c  */
#line 1012 "cf-parse.y"
    {
     roa_add_item_config(this_roa_table, (yyvsp[(3) - (8)].px).addr, (yyvsp[(3) - (8)].px).len, (yyvsp[(5) - (8)].i), (yyvsp[(7) - (8)].i));
   }
    break;

  case 98:
/* Line 1792 of yacc.c  */
#line 1026 "cf-parse.y"
    { (yyval.i) = SYM_PROTO; }
    break;

  case 99:
/* Line 1792 of yacc.c  */
#line 1027 "cf-parse.y"
    { (yyval.i) = SYM_TEMPLATE; }
    break;

  case 100:
/* Line 1792 of yacc.c  */
#line 1031 "cf-parse.y"
    {
     struct symbol *s = cf_default_name(this_proto->protocol->template, &this_proto->protocol->name_counter);
     s->class = this_proto->class;
     s->def = this_proto;
     this_proto->name = s->name;
     }
    break;

  case 101:
/* Line 1792 of yacc.c  */
#line 1037 "cf-parse.y"
    {
     cf_define_symbol((yyvsp[(1) - (1)].s), this_proto->class, this_proto);
     this_proto->name = (yyvsp[(1) - (1)].s)->name;
   }
    break;

  case 102:
/* Line 1792 of yacc.c  */
#line 1041 "cf-parse.y"
    {
     if (((yyvsp[(3) - (3)].s)->class != SYM_TEMPLATE) && ((yyvsp[(3) - (3)].s)->class != SYM_PROTO)) cf_error("Template or protocol name expected");

     cf_define_symbol((yyvsp[(1) - (3)].s), this_proto->class, this_proto);
     this_proto->name = (yyvsp[(1) - (3)].s)->name;

     proto_copy_config(this_proto, (yyvsp[(3) - (3)].s)->def);
   }
    break;

  case 104:
/* Line 1792 of yacc.c  */
#line 1053 "cf-parse.y"
    {
     if ((yyvsp[(2) - (2)].i) < 0 || (yyvsp[(2) - (2)].i) > 0xFFFF) cf_error("Invalid preference");
     this_proto->preference = (yyvsp[(2) - (2)].i);
   }
    break;

  case 105:
/* Line 1792 of yacc.c  */
#line 1057 "cf-parse.y"
    { this_proto->disabled = (yyvsp[(2) - (2)].i); }
    break;

  case 106:
/* Line 1792 of yacc.c  */
#line 1058 "cf-parse.y"
    { this_proto->debug = (yyvsp[(2) - (2)].i); }
    break;

  case 107:
/* Line 1792 of yacc.c  */
#line 1059 "cf-parse.y"
    { this_proto->mrtdump = (yyvsp[(2) - (2)].i); }
    break;

  case 108:
/* Line 1792 of yacc.c  */
#line 1060 "cf-parse.y"
    { this_proto->in_filter = (yyvsp[(2) - (2)].f); }
    break;

  case 109:
/* Line 1792 of yacc.c  */
#line 1061 "cf-parse.y"
    { this_proto->out_filter = (yyvsp[(2) - (2)].f); }
    break;

  case 110:
/* Line 1792 of yacc.c  */
#line 1062 "cf-parse.y"
    { this_proto->rx_limit = (yyvsp[(3) - (3)].g); }
    break;

  case 111:
/* Line 1792 of yacc.c  */
#line 1063 "cf-parse.y"
    { this_proto->in_limit = (yyvsp[(3) - (3)].g); }
    break;

  case 112:
/* Line 1792 of yacc.c  */
#line 1064 "cf-parse.y"
    { this_proto->out_limit = (yyvsp[(3) - (3)].g); }
    break;

  case 113:
/* Line 1792 of yacc.c  */
#line 1065 "cf-parse.y"
    { this_proto->in_keep_filtered = (yyvsp[(4) - (4)].i); }
    break;

  case 114:
/* Line 1792 of yacc.c  */
#line 1066 "cf-parse.y"
    { this_proto->table = (yyvsp[(2) - (2)].r); }
    break;

  case 115:
/* Line 1792 of yacc.c  */
#line 1067 "cf-parse.y"
    { this_proto->router_id = (yyvsp[(3) - (3)].i32); }
    break;

  case 116:
/* Line 1792 of yacc.c  */
#line 1068 "cf-parse.y"
    { this_proto->dsc = (yyvsp[(2) - (2)].t); }
    break;

  case 117:
/* Line 1792 of yacc.c  */
#line 1072 "cf-parse.y"
    { (yyval.f) = (yyvsp[(2) - (2)].f); }
    break;

  case 119:
/* Line 1792 of yacc.c  */
#line 1074 "cf-parse.y"
    { (yyval.f) = FILTER_ACCEPT; }
    break;

  case 120:
/* Line 1792 of yacc.c  */
#line 1075 "cf-parse.y"
    { (yyval.f) = FILTER_REJECT; }
    break;

  case 121:
/* Line 1792 of yacc.c  */
#line 1079 "cf-parse.y"
    { (yyval.i) = PLA_DISABLE; }
    break;

  case 122:
/* Line 1792 of yacc.c  */
#line 1080 "cf-parse.y"
    { (yyval.i) = PLA_WARN; }
    break;

  case 123:
/* Line 1792 of yacc.c  */
#line 1081 "cf-parse.y"
    { (yyval.i) = PLA_BLOCK; }
    break;

  case 124:
/* Line 1792 of yacc.c  */
#line 1082 "cf-parse.y"
    { (yyval.i) = PLA_RESTART; }
    break;

  case 125:
/* Line 1792 of yacc.c  */
#line 1083 "cf-parse.y"
    { (yyval.i) = PLA_DISABLE; }
    break;

  case 126:
/* Line 1792 of yacc.c  */
#line 1087 "cf-parse.y"
    {
     struct proto_limit *l = cfg_allocz(sizeof(struct proto_limit));
     l->limit = (yyvsp[(1) - (2)].i);
     l->action = (yyvsp[(2) - (2)].i);
     (yyval.g) = l;
   }
    break;

  case 127:
/* Line 1792 of yacc.c  */
#line 1093 "cf-parse.y"
    { (yyval.g) = NULL; }
    break;

  case 128:
/* Line 1792 of yacc.c  */
#line 1097 "cf-parse.y"
    {
     if ((yyvsp[(1) - (1)].s)->class != SYM_TABLE) cf_error("Table name expected");
     (yyval.r) = (yyvsp[(1) - (1)].s)->def;
   }
    break;

  case 129:
/* Line 1792 of yacc.c  */
#line 1105 "cf-parse.y"
    { new_config->proto_default_debug = (yyvsp[(3) - (3)].i); }
    break;

  case 130:
/* Line 1792 of yacc.c  */
#line 1106 "cf-parse.y"
    { new_config->cli_debug = (yyvsp[(3) - (3)].i); }
    break;

  case 131:
/* Line 1792 of yacc.c  */
#line 1114 "cf-parse.y"
    {
     struct iface_patt_node *ipn = cfg_allocz(sizeof(struct iface_patt_node));
     add_tail(&this_ipatt->ipn_list, NODE ipn);
     this_ipn = ipn;
   }
    break;

  case 132:
/* Line 1792 of yacc.c  */
#line 1122 "cf-parse.y"
    { this_ipn->pattern = (yyvsp[(1) - (1)].t); this_ipn->prefix = IPA_NONE; this_ipn->pxlen = 0; }
    break;

  case 133:
/* Line 1792 of yacc.c  */
#line 1123 "cf-parse.y"
    { this_ipn->pattern = NULL; this_ipn->prefix = (yyvsp[(1) - (1)].px).addr; this_ipn->pxlen = (yyvsp[(1) - (1)].px).len; }
    break;

  case 134:
/* Line 1792 of yacc.c  */
#line 1124 "cf-parse.y"
    { this_ipn->pattern = (yyvsp[(1) - (2)].t); this_ipn->prefix = (yyvsp[(2) - (2)].px).addr; this_ipn->pxlen = (yyvsp[(2) - (2)].px).len; }
    break;

  case 135:
/* Line 1792 of yacc.c  */
#line 1128 "cf-parse.y"
    { this_ipn->positive = 1; }
    break;

  case 136:
/* Line 1792 of yacc.c  */
#line 1129 "cf-parse.y"
    { this_ipn->positive = 0; }
    break;

  case 140:
/* Line 1792 of yacc.c  */
#line 1142 "cf-parse.y"
    {
   /* Generic this_ipatt init */
   this_ipatt = cfg_allocz(sizeof(struct iface_patt));
   init_list(&this_ipatt->ipn_list);
 }
    break;

  case 142:
/* Line 1792 of yacc.c  */
#line 1154 "cf-parse.y"
    { (yyval.i) = (yyvsp[(2) - (2)].i) & 0xfc;        if (((yyvsp[(2) - (2)].i) < 0) || ((yyvsp[(2) - (2)].i) > 255)) cf_error("TX class must be in range 0-255"); }
    break;

  case 143:
/* Line 1792 of yacc.c  */
#line 1155 "cf-parse.y"
    { (yyval.i) = ((yyvsp[(2) - (2)].i) & 0x3f) << 2; if (((yyvsp[(2) - (2)].i) < 0) || ((yyvsp[(2) - (2)].i) > 63))  cf_error("TX DSCP must be in range 0-63"); }
    break;

  case 144:
/* Line 1792 of yacc.c  */
#line 1161 "cf-parse.y"
    {
     this_proto = proto_config_new(&proto_device, sizeof(struct rt_dev_config), (yyvsp[(1) - (2)].i));
     init_list(&DIRECT_CFG->iface_list);
   }
    break;

  case 148:
/* Line 1792 of yacc.c  */
#line 1174 "cf-parse.y"
    {
     this_ipatt = cfg_allocz(sizeof(struct iface_patt));
     add_tail(&DIRECT_CFG->iface_list, NODE this_ipatt);
     init_list(&this_ipatt->ipn_list);
   }
    break;

  case 150:
/* Line 1792 of yacc.c  */
#line 1188 "cf-parse.y"
    { (yyval.i) = ~0; }
    break;

  case 151:
/* Line 1792 of yacc.c  */
#line 1189 "cf-parse.y"
    { (yyval.i) = 0; }
    break;

  case 152:
/* Line 1792 of yacc.c  */
#line 1190 "cf-parse.y"
    { (yyval.i) = (yyvsp[(2) - (3)].i); }
    break;

  case 154:
/* Line 1792 of yacc.c  */
#line 1195 "cf-parse.y"
    { (yyval.i) = (yyvsp[(1) - (3)].i) | (yyvsp[(3) - (3)].i); }
    break;

  case 155:
/* Line 1792 of yacc.c  */
#line 1199 "cf-parse.y"
    { (yyval.i) = D_STATES; }
    break;

  case 156:
/* Line 1792 of yacc.c  */
#line 1200 "cf-parse.y"
    { (yyval.i) = D_ROUTES; }
    break;

  case 157:
/* Line 1792 of yacc.c  */
#line 1201 "cf-parse.y"
    { (yyval.i) = D_FILTERS; }
    break;

  case 158:
/* Line 1792 of yacc.c  */
#line 1202 "cf-parse.y"
    { (yyval.i) = D_IFACES; }
    break;

  case 159:
/* Line 1792 of yacc.c  */
#line 1203 "cf-parse.y"
    { (yyval.i) = D_EVENTS; }
    break;

  case 160:
/* Line 1792 of yacc.c  */
#line 1204 "cf-parse.y"
    { (yyval.i) = D_PACKETS; }
    break;

  case 161:
/* Line 1792 of yacc.c  */
#line 1210 "cf-parse.y"
    { (yyval.i) = ~0; }
    break;

  case 162:
/* Line 1792 of yacc.c  */
#line 1211 "cf-parse.y"
    { (yyval.i) = 0; }
    break;

  case 163:
/* Line 1792 of yacc.c  */
#line 1212 "cf-parse.y"
    { (yyval.i) = (yyvsp[(2) - (3)].i); }
    break;

  case 165:
/* Line 1792 of yacc.c  */
#line 1217 "cf-parse.y"
    { (yyval.i) = (yyvsp[(1) - (3)].i) | (yyvsp[(3) - (3)].i); }
    break;

  case 166:
/* Line 1792 of yacc.c  */
#line 1221 "cf-parse.y"
    { (yyval.i) = MD_STATES; }
    break;

  case 167:
/* Line 1792 of yacc.c  */
#line 1222 "cf-parse.y"
    { (yyval.i) = MD_MESSAGES; }
    break;

  case 174:
/* Line 1792 of yacc.c  */
#line 1243 "cf-parse.y"
    {
     if (!this_p_list) {
     	this_p_list = cfg_alloc(sizeof(list));
     	init_list(this_p_list);
        password_id = 1;
     }
     this_p_item = cfg_alloc(sizeof (struct password_item));
     this_p_item->password = (yyvsp[(2) - (2)].t);
     this_p_item->genfrom = 0;
     this_p_item->gento = TIME_INFINITY;
     this_p_item->accfrom = 0;
     this_p_item->accto = TIME_INFINITY;
     this_p_item->id = password_id++;
     add_tail(this_p_list, &this_p_item->n);
   }
    break;

  case 175:
/* Line 1792 of yacc.c  */
#line 1261 "cf-parse.y"
    { }
    break;

  case 176:
/* Line 1792 of yacc.c  */
#line 1262 "cf-parse.y"
    { this_p_item->genfrom = (yyvsp[(3) - (5)].time); }
    break;

  case 177:
/* Line 1792 of yacc.c  */
#line 1263 "cf-parse.y"
    { this_p_item->gento = (yyvsp[(3) - (5)].time); }
    break;

  case 178:
/* Line 1792 of yacc.c  */
#line 1264 "cf-parse.y"
    { this_p_item->accfrom = (yyvsp[(3) - (5)].time); }
    break;

  case 179:
/* Line 1792 of yacc.c  */
#line 1265 "cf-parse.y"
    { this_p_item->accto = (yyvsp[(3) - (5)].time); }
    break;

  case 180:
/* Line 1792 of yacc.c  */
#line 1266 "cf-parse.y"
    { this_p_item->id = (yyvsp[(2) - (4)].i); if ((yyvsp[(2) - (4)].i) <= 0) cf_error("Password ID has to be greated than zero."); }
    break;

  case 181:
/* Line 1792 of yacc.c  */
#line 1275 "cf-parse.y"
    { cmd_show_status(); }
    break;

  case 182:
/* Line 1792 of yacc.c  */
#line 1278 "cf-parse.y"
    { cmd_show_memory(); }
    break;

  case 183:
/* Line 1792 of yacc.c  */
#line 1281 "cf-parse.y"
    { proto_apply_cmd((yyvsp[(3) - (4)].ps), proto_cmd_show, 0, 0); }
    break;

  case 184:
/* Line 1792 of yacc.c  */
#line 1284 "cf-parse.y"
    { proto_apply_cmd((yyvsp[(4) - (5)].ps), proto_cmd_show, 0, 1); }
    break;

  case 186:
/* Line 1792 of yacc.c  */
#line 1288 "cf-parse.y"
    { (yyval.s) = NULL; }
    break;

  case 187:
/* Line 1792 of yacc.c  */
#line 1292 "cf-parse.y"
    { if_show(); }
    break;

  case 188:
/* Line 1792 of yacc.c  */
#line 1295 "cf-parse.y"
    { if_show_summary(); }
    break;

  case 189:
/* Line 1792 of yacc.c  */
#line 1299 "cf-parse.y"
    { rt_show((yyvsp[(3) - (4)].ra)); }
    break;

  case 190:
/* Line 1792 of yacc.c  */
#line 1302 "cf-parse.y"
    {
     (yyval.ra) = cfg_allocz(sizeof(struct rt_show_data));
     (yyval.ra)->pxlen = 256;
     (yyval.ra)->filter = FILTER_ACCEPT;
   }
    break;

  case 191:
/* Line 1792 of yacc.c  */
#line 1307 "cf-parse.y"
    {
     (yyval.ra) = (yyvsp[(1) - (2)].ra);
     if ((yyval.ra)->pxlen != 256) cf_error("Only one prefix expected");
     (yyval.ra)->prefix = (yyvsp[(2) - (2)].px).addr;
     (yyval.ra)->pxlen = (yyvsp[(2) - (2)].px).len;
   }
    break;

  case 192:
/* Line 1792 of yacc.c  */
#line 1313 "cf-parse.y"
    {
     (yyval.ra) = (yyvsp[(1) - (3)].ra);
     if ((yyval.ra)->pxlen != 256) cf_error("Only one prefix expected");
     (yyval.ra)->prefix = (yyvsp[(3) - (3)].px).addr;
     (yyval.ra)->pxlen = (yyvsp[(3) - (3)].px).len;
     (yyval.ra)->show_for = 1;
   }
    break;

  case 193:
/* Line 1792 of yacc.c  */
#line 1320 "cf-parse.y"
    {
     (yyval.ra) = (yyvsp[(1) - (3)].ra);
     if ((yyvsp[(3) - (3)].s)->class != SYM_TABLE) cf_error("%s is not a table", (yyvsp[(3) - (3)].s)->name);
     (yyval.ra)->table = ((struct rtable_config *)(yyvsp[(3) - (3)].s)->def)->table;
   }
    break;

  case 194:
/* Line 1792 of yacc.c  */
#line 1325 "cf-parse.y"
    {
     (yyval.ra) = (yyvsp[(1) - (3)].ra);
     if ((yyval.ra)->filter != FILTER_ACCEPT) cf_error("Filter specified twice");
     (yyval.ra)->filter = (yyvsp[(3) - (3)].f);
   }
    break;

  case 195:
/* Line 1792 of yacc.c  */
#line 1330 "cf-parse.y"
    {
     (yyval.ra) = (yyvsp[(1) - (2)].ra);
     if ((yyval.ra)->filter != FILTER_ACCEPT) cf_error("Filter specified twice");
     (yyval.ra)->filter = (yyvsp[(2) - (2)].f);
   }
    break;

  case 196:
/* Line 1792 of yacc.c  */
#line 1335 "cf-parse.y"
    {
     (yyval.ra) = (yyvsp[(1) - (2)].ra);
     (yyval.ra)->verbose = 1;
   }
    break;

  case 197:
/* Line 1792 of yacc.c  */
#line 1339 "cf-parse.y"
    {
     (yyval.ra) = (yyvsp[(1) - (2)].ra);
     (yyval.ra)->primary_only = 1;
   }
    break;

  case 198:
/* Line 1792 of yacc.c  */
#line 1343 "cf-parse.y"
    {
     (yyval.ra) = (yyvsp[(1) - (2)].ra);
     (yyval.ra)->filtered = 1;
   }
    break;

  case 199:
/* Line 1792 of yacc.c  */
#line 1347 "cf-parse.y"
    {
     struct proto_config *c = (struct proto_config *) (yyvsp[(3) - (3)].s)->def;
     (yyval.ra) = (yyvsp[(1) - (3)].ra);
     if ((yyval.ra)->export_mode) cf_error("Protocol specified twice");
     if ((yyvsp[(3) - (3)].s)->class != SYM_PROTO || !c->proto) cf_error("%s is not a protocol", (yyvsp[(3) - (3)].s)->name);
     (yyval.ra)->export_mode = (yyvsp[(2) - (3)].i);
     (yyval.ra)->primary_only = 1;
     (yyval.ra)->export_protocol = c->proto;
     (yyval.ra)->running_on_config = c->proto->cf->global;
   }
    break;

  case 200:
/* Line 1792 of yacc.c  */
#line 1357 "cf-parse.y"
    {
     struct proto_config *c = (struct proto_config *) (yyvsp[(3) - (3)].s)->def;
     (yyval.ra) = (yyvsp[(1) - (3)].ra);
     if ((yyval.ra)->show_protocol) cf_error("Protocol specified twice");
     if ((yyvsp[(3) - (3)].s)->class != SYM_PROTO || !c->proto) cf_error("%s is not a protocol", (yyvsp[(3) - (3)].s)->name);
     (yyval.ra)->show_protocol = c->proto;
     (yyval.ra)->running_on_config = c->proto->cf->global;
   }
    break;

  case 201:
/* Line 1792 of yacc.c  */
#line 1365 "cf-parse.y"
    {
     (yyval.ra) = (yyvsp[(1) - (2)].ra);
     (yyval.ra)->stats = 1;
   }
    break;

  case 202:
/* Line 1792 of yacc.c  */
#line 1369 "cf-parse.y"
    {
     (yyval.ra) = (yyvsp[(1) - (2)].ra);
     (yyval.ra)->stats = 2;
   }
    break;

  case 203:
/* Line 1792 of yacc.c  */
#line 1376 "cf-parse.y"
    { (yyval.i) = 1; }
    break;

  case 204:
/* Line 1792 of yacc.c  */
#line 1377 "cf-parse.y"
    { (yyval.i) = 2; }
    break;

  case 205:
/* Line 1792 of yacc.c  */
#line 1383 "cf-parse.y"
    { roa_show((yyvsp[(3) - (4)].ro)); }
    break;

  case 206:
/* Line 1792 of yacc.c  */
#line 1386 "cf-parse.y"
    {
     (yyval.ro) = cfg_allocz(sizeof(struct roa_show_data));
     (yyval.ro)->mode = ROA_SHOW_ALL;
     (yyval.ro)->table = roa_table_default;
     if (roa_table_default == NULL)
       cf_error("No ROA table defined");
   }
    break;

  case 207:
/* Line 1792 of yacc.c  */
#line 1393 "cf-parse.y"
    {
     (yyval.ro) = (yyvsp[(1) - (3)].ro);
     if ((yyval.ro)->mode != ROA_SHOW_ALL) cf_error("Only one prefix expected");
     (yyval.ro)->prefix = (yyvsp[(3) - (3)].px).addr;
     (yyval.ro)->pxlen = (yyvsp[(3) - (3)].px).len;
     (yyval.ro)->mode = (yyvsp[(2) - (3)].i);
   }
    break;

  case 208:
/* Line 1792 of yacc.c  */
#line 1400 "cf-parse.y"
    {
     (yyval.ro) = (yyvsp[(1) - (3)].ro);
     (yyval.ro)->asn = (yyvsp[(3) - (3)].i);
   }
    break;

  case 209:
/* Line 1792 of yacc.c  */
#line 1404 "cf-parse.y"
    {
     (yyval.ro) = (yyvsp[(1) - (3)].ro);
     if ((yyvsp[(3) - (3)].s)->class != SYM_ROA) cf_error("%s is not a ROA table", (yyvsp[(3) - (3)].s)->name);
     (yyval.ro)->table = ((struct roa_table_config *)(yyvsp[(3) - (3)].s)->def)->table;
   }
    break;

  case 210:
/* Line 1792 of yacc.c  */
#line 1412 "cf-parse.y"
    { (yyval.i) = ROA_SHOW_PX; }
    break;

  case 211:
/* Line 1792 of yacc.c  */
#line 1413 "cf-parse.y"
    { (yyval.i) = ROA_SHOW_IN; }
    break;

  case 212:
/* Line 1792 of yacc.c  */
#line 1414 "cf-parse.y"
    { (yyval.i) = ROA_SHOW_FOR; }
    break;

  case 213:
/* Line 1792 of yacc.c  */
#line 1420 "cf-parse.y"
    { cmd_show_symbols((yyvsp[(3) - (4)].sd)); }
    break;

  case 214:
/* Line 1792 of yacc.c  */
#line 1423 "cf-parse.y"
    {
     (yyval.sd) = cfg_allocz(sizeof(struct sym_show_data));
   }
    break;

  case 215:
/* Line 1792 of yacc.c  */
#line 1426 "cf-parse.y"
    { (yyval.sd) = (yyvsp[(1) - (2)].sd); (yyval.sd)->type = SYM_TABLE; }
    break;

  case 216:
/* Line 1792 of yacc.c  */
#line 1427 "cf-parse.y"
    { (yyval.sd) = (yyvsp[(1) - (2)].sd); (yyval.sd)->type = SYM_FUNCTION; }
    break;

  case 217:
/* Line 1792 of yacc.c  */
#line 1428 "cf-parse.y"
    { (yyval.sd) = (yyvsp[(1) - (2)].sd); (yyval.sd)->type = SYM_FILTER; }
    break;

  case 218:
/* Line 1792 of yacc.c  */
#line 1429 "cf-parse.y"
    { (yyval.sd) = (yyvsp[(1) - (2)].sd); (yyval.sd)->type = SYM_PROTO; }
    break;

  case 219:
/* Line 1792 of yacc.c  */
#line 1430 "cf-parse.y"
    { (yyval.sd) = (yyvsp[(1) - (2)].sd); (yyval.sd)->type = SYM_TEMPLATE; }
    break;

  case 220:
/* Line 1792 of yacc.c  */
#line 1431 "cf-parse.y"
    { (yyval.sd) = (yyvsp[(1) - (2)].sd); (yyval.sd)->type = SYM_ROA; }
    break;

  case 221:
/* Line 1792 of yacc.c  */
#line 1432 "cf-parse.y"
    { (yyval.sd) = (yyvsp[(1) - (2)].sd); (yyval.sd)->sym = (yyvsp[(2) - (2)].s); }
    break;

  case 222:
/* Line 1792 of yacc.c  */
#line 1437 "cf-parse.y"
    { 
     if (roa_table_default == NULL)
       cf_error("No ROA table defined");
     (yyval.rot) = roa_table_default;
   }
    break;

  case 223:
/* Line 1792 of yacc.c  */
#line 1442 "cf-parse.y"
    {
     if ((yyvsp[(2) - (2)].s)->class != SYM_ROA)
       cf_error("%s is not a ROA table", (yyvsp[(2) - (2)].s)->name);
     (yyval.rot) = ((struct roa_table_config *)(yyvsp[(2) - (2)].s)->def)->table;
   }
    break;

  case 224:
/* Line 1792 of yacc.c  */
#line 1451 "cf-parse.y"
    {
  if (! cli_access_restricted())
    { roa_add_item((yyvsp[(8) - (9)].rot), (yyvsp[(3) - (9)].px).addr, (yyvsp[(3) - (9)].px).len, (yyvsp[(5) - (9)].i), (yyvsp[(7) - (9)].i), ROA_SRC_DYNAMIC); cli_msg(0, ""); }
}
    break;

  case 225:
/* Line 1792 of yacc.c  */
#line 1458 "cf-parse.y"
    {
  if (! cli_access_restricted())
    { roa_delete_item((yyvsp[(8) - (9)].rot), (yyvsp[(3) - (9)].px).addr, (yyvsp[(3) - (9)].px).len, (yyvsp[(5) - (9)].i), (yyvsp[(7) - (9)].i), ROA_SRC_DYNAMIC); cli_msg(0, ""); }
}
    break;

  case 226:
/* Line 1792 of yacc.c  */
#line 1465 "cf-parse.y"
    {
  if (! cli_access_restricted())
    { roa_flush((yyvsp[(3) - (4)].rot), ROA_SRC_DYNAMIC); cli_msg(0, ""); }
}
    break;

  case 227:
/* Line 1792 of yacc.c  */
#line 1473 "cf-parse.y"
    { rdump(&root_pool); cli_msg(0, ""); }
    break;

  case 228:
/* Line 1792 of yacc.c  */
#line 1475 "cf-parse.y"
    { sk_dump_all(); cli_msg(0, ""); }
    break;

  case 229:
/* Line 1792 of yacc.c  */
#line 1477 "cf-parse.y"
    { if_dump_all(); cli_msg(0, ""); }
    break;

  case 230:
/* Line 1792 of yacc.c  */
#line 1479 "cf-parse.y"
    { neigh_dump_all(); cli_msg(0, ""); }
    break;

  case 231:
/* Line 1792 of yacc.c  */
#line 1481 "cf-parse.y"
    { rta_dump_all(); cli_msg(0, ""); }
    break;

  case 232:
/* Line 1792 of yacc.c  */
#line 1483 "cf-parse.y"
    { rt_dump_all(); cli_msg(0, ""); }
    break;

  case 233:
/* Line 1792 of yacc.c  */
#line 1485 "cf-parse.y"
    { protos_dump_all(); cli_msg(0, ""); }
    break;

  case 234:
/* Line 1792 of yacc.c  */
#line 1488 "cf-parse.y"
    { cmd_eval((yyvsp[(2) - (3)].x)); }
    break;

  case 235:
/* Line 1792 of yacc.c  */
#line 1491 "cf-parse.y"
    {
  cli_set_log_echo(this_cli, (yyvsp[(2) - (4)].i), (yyvsp[(3) - (4)].i));
  cli_msg(0, "");
}
    break;

  case 236:
/* Line 1792 of yacc.c  */
#line 1497 "cf-parse.y"
    { (yyval.i) = ~0; }
    break;

  case 237:
/* Line 1792 of yacc.c  */
#line 1498 "cf-parse.y"
    { (yyval.i) = 0; }
    break;

  case 238:
/* Line 1792 of yacc.c  */
#line 1499 "cf-parse.y"
    { (yyval.i) = (yyvsp[(2) - (3)].i); }
    break;

  case 239:
/* Line 1792 of yacc.c  */
#line 1503 "cf-parse.y"
    { (yyval.i) = 4096; }
    break;

  case 240:
/* Line 1792 of yacc.c  */
#line 1504 "cf-parse.y"
    {
     if ((yyvsp[(1) - (1)].i) < 256 || (yyvsp[(1) - (1)].i) > 65536) cf_error("Invalid log buffer size");
     (yyval.i) = (yyvsp[(1) - (1)].i);
   }
    break;

  case 241:
/* Line 1792 of yacc.c  */
#line 1511 "cf-parse.y"
    { proto_apply_cmd((yyvsp[(2) - (3)].ps), proto_cmd_disable, 1, 0); }
    break;

  case 242:
/* Line 1792 of yacc.c  */
#line 1513 "cf-parse.y"
    { proto_apply_cmd((yyvsp[(2) - (3)].ps), proto_cmd_enable, 1, 0); }
    break;

  case 243:
/* Line 1792 of yacc.c  */
#line 1515 "cf-parse.y"
    { proto_apply_cmd((yyvsp[(2) - (3)].ps), proto_cmd_restart, 1, 0); }
    break;

  case 244:
/* Line 1792 of yacc.c  */
#line 1517 "cf-parse.y"
    { proto_apply_cmd((yyvsp[(2) - (3)].ps), proto_cmd_reload, 1, CMD_RELOAD); }
    break;

  case 245:
/* Line 1792 of yacc.c  */
#line 1519 "cf-parse.y"
    { proto_apply_cmd((yyvsp[(3) - (4)].ps), proto_cmd_reload, 1, CMD_RELOAD_IN); }
    break;

  case 246:
/* Line 1792 of yacc.c  */
#line 1521 "cf-parse.y"
    { proto_apply_cmd((yyvsp[(3) - (4)].ps), proto_cmd_reload, 1, CMD_RELOAD_OUT); }
    break;

  case 247:
/* Line 1792 of yacc.c  */
#line 1525 "cf-parse.y"
    { proto_apply_cmd((yyvsp[(2) - (4)].ps), proto_cmd_debug, 1, (yyvsp[(3) - (4)].i)); }
    break;

  case 248:
/* Line 1792 of yacc.c  */
#line 1529 "cf-parse.y"
    { proto_apply_cmd((yyvsp[(2) - (4)].ps), proto_cmd_mrtdump, 1, (yyvsp[(3) - (4)].i)); }
    break;

  case 249:
/* Line 1792 of yacc.c  */
#line 1532 "cf-parse.y"
    { this_cli->restricted = 1; cli_msg(16, "Access restricted"); }
    break;

  case 250:
/* Line 1792 of yacc.c  */
#line 1535 "cf-parse.y"
    { (yyval.ps).ptr = (yyvsp[(1) - (1)].s); (yyval.ps).patt = 0; }
    break;

  case 251:
/* Line 1792 of yacc.c  */
#line 1536 "cf-parse.y"
    { (yyval.ps).ptr = NULL; (yyval.ps).patt = 1; }
    break;

  case 252:
/* Line 1792 of yacc.c  */
#line 1537 "cf-parse.y"
    { (yyval.ps).ptr = (yyvsp[(1) - (1)].t); (yyval.ps).patt = 1; }
    break;

  case 253:
/* Line 1792 of yacc.c  */
#line 1541 "cf-parse.y"
    { (yyval.ps).ptr = (yyvsp[(1) - (1)].s); (yyval.ps).patt = 0; }
    break;

  case 254:
/* Line 1792 of yacc.c  */
#line 1542 "cf-parse.y"
    { (yyval.ps).ptr = NULL; (yyval.ps).patt = 1; }
    break;

  case 255:
/* Line 1792 of yacc.c  */
#line 1543 "cf-parse.y"
    { (yyval.ps).ptr = (yyvsp[(1) - (1)].t); (yyval.ps).patt = 1; }
    break;

  case 256:
/* Line 1792 of yacc.c  */
#line 1551 "cf-parse.y"
    { (yyvsp[(2) - (2)].s) = cf_define_symbol((yyvsp[(2) - (2)].s), SYM_FILTER, NULL); cf_push_scope( (yyvsp[(2) - (2)].s) ); }
    break;

  case 257:
/* Line 1792 of yacc.c  */
#line 1552 "cf-parse.y"
    {
     (yyvsp[(2) - (4)].s)->def = (yyvsp[(4) - (4)].f);
     (yyvsp[(4) - (4)].f)->name = (yyvsp[(2) - (4)].s)->name;
     DBG( "We have new filter defined (%s)\n", (yyvsp[(2) - (4)].s)->name );
     cf_pop_scope();
   }
    break;

  case 258:
/* Line 1792 of yacc.c  */
#line 1561 "cf-parse.y"
    { f_eval_int((yyvsp[(2) - (2)].x)); }
    break;

  case 259:
/* Line 1792 of yacc.c  */
#line 1565 "cf-parse.y"
    { (yyval.i) = T_INT; }
    break;

  case 260:
/* Line 1792 of yacc.c  */
#line 1566 "cf-parse.y"
    { (yyval.i) = T_BOOL; }
    break;

  case 261:
/* Line 1792 of yacc.c  */
#line 1567 "cf-parse.y"
    { (yyval.i) = T_IP; }
    break;

  case 262:
/* Line 1792 of yacc.c  */
#line 1568 "cf-parse.y"
    { (yyval.i) = T_PREFIX; }
    break;

  case 263:
/* Line 1792 of yacc.c  */
#line 1569 "cf-parse.y"
    { (yyval.i) = T_PAIR; }
    break;

  case 264:
/* Line 1792 of yacc.c  */
#line 1570 "cf-parse.y"
    { (yyval.i) = T_QUAD; }
    break;

  case 265:
/* Line 1792 of yacc.c  */
#line 1571 "cf-parse.y"
    { (yyval.i) = T_EC; }
    break;

  case 266:
/* Line 1792 of yacc.c  */
#line 1572 "cf-parse.y"
    { (yyval.i) = T_STRING; }
    break;

  case 267:
/* Line 1792 of yacc.c  */
#line 1573 "cf-parse.y"
    { (yyval.i) = T_PATH_MASK; }
    break;

  case 268:
/* Line 1792 of yacc.c  */
#line 1574 "cf-parse.y"
    { (yyval.i) = T_PATH; }
    break;

  case 269:
/* Line 1792 of yacc.c  */
#line 1575 "cf-parse.y"
    { (yyval.i) = T_CLIST; }
    break;

  case 270:
/* Line 1792 of yacc.c  */
#line 1576 "cf-parse.y"
    { (yyval.i) = T_ECLIST; }
    break;

  case 271:
/* Line 1792 of yacc.c  */
#line 1577 "cf-parse.y"
    { 
	switch ((yyvsp[(1) - (2)].i)) {
	  case T_INT:
	  case T_PAIR:
	  case T_QUAD:
	  case T_EC:
	  case T_IP:
	       (yyval.i) = T_SET;
	       break;

	  case T_PREFIX:
	       (yyval.i) = T_PREFIX_SET;
	    break;

	  default:
		cf_error( "You can't create sets of this type." );
	}
   }
    break;

  case 272:
/* Line 1792 of yacc.c  */
#line 1598 "cf-parse.y"
    {
     struct f_val * val = cfg_alloc(sizeof(struct f_val));
     val->type = T_VOID;
     (yyvsp[(2) - (2)].s) = cf_define_symbol((yyvsp[(2) - (2)].s), SYM_VARIABLE | (yyvsp[(1) - (2)].i), val);
     DBG( "New variable %s type %x\n", (yyvsp[(2) - (2)].s)->name, (yyvsp[(1) - (2)].i) );
     (yyvsp[(2) - (2)].s)->aux2 = NULL;
     (yyval.s)=(yyvsp[(2) - (2)].s);
   }
    break;

  case 273:
/* Line 1792 of yacc.c  */
#line 1609 "cf-parse.y"
    { (yyval.s) = NULL; }
    break;

  case 274:
/* Line 1792 of yacc.c  */
#line 1610 "cf-parse.y"
    {
     (yyval.s) = (yyvsp[(1) - (3)].s);
     (yyval.s)->aux2 = (yyvsp[(3) - (3)].s);
   }
    break;

  case 275:
/* Line 1792 of yacc.c  */
#line 1617 "cf-parse.y"
    { (yyval.s) = (yyvsp[(1) - (1)].s); }
    break;

  case 276:
/* Line 1792 of yacc.c  */
#line 1618 "cf-parse.y"
    {
     (yyval.s) = (yyvsp[(1) - (3)].s);
     (yyval.s)->aux2 = (yyvsp[(3) - (3)].s);
   }
    break;

  case 277:
/* Line 1792 of yacc.c  */
#line 1625 "cf-parse.y"
    {
     struct filter *f = cfg_alloc(sizeof(struct filter));
     f->name = NULL;
     f->root = (yyvsp[(1) - (1)].x);
     (yyval.f) = f;
   }
    break;

  case 278:
/* Line 1792 of yacc.c  */
#line 1634 "cf-parse.y"
    {
     if ((yyvsp[(1) - (1)].s)->class != SYM_FILTER) cf_error("No such filter.");
     (yyval.f) = (yyvsp[(1) - (1)].s)->def;
   }
    break;

  case 280:
/* Line 1792 of yacc.c  */
#line 1642 "cf-parse.y"
    {
     /* Construct 'IF term THEN ACCEPT; REJECT;' */
     struct filter *f = cfg_alloc(sizeof(struct filter));
     struct f_inst *i, *acc, *rej;
     acc = f_new_inst();		/* ACCEPT */
     acc->code = P('p',',');
     acc->a1.p = NULL;
     acc->a2.i = F_ACCEPT;
     rej = f_new_inst();		/* REJECT */
     rej->code = P('p',',');
     rej->a1.p = NULL;
     rej->a2.i = F_REJECT;
     i = f_new_inst();			/* IF */
     i->code = '?';
     i->a1.p = (yyvsp[(2) - (2)].x);
     i->a2.p = acc;
     i->next = rej;
     f->name = NULL;
     f->root = i;
     (yyval.f) = f;
  }
    break;

  case 281:
/* Line 1792 of yacc.c  */
#line 1666 "cf-parse.y"
    { DBG( "Have function parameters\n" ); (yyval.s)=(yyvsp[(2) - (3)].s); }
    break;

  case 282:
/* Line 1792 of yacc.c  */
#line 1667 "cf-parse.y"
    { (yyval.s)=NULL; }
    break;

  case 283:
/* Line 1792 of yacc.c  */
#line 1671 "cf-parse.y"
    {
     if ((yyvsp[(1) - (4)].s)) {
       /* Prepend instruction to clear local variables */
       (yyval.x) = f_new_inst();
       (yyval.x)->code = P('c','v');
       (yyval.x)->a1.p = (yyvsp[(1) - (4)].s);
       (yyval.x)->next = (yyvsp[(3) - (4)].x);
     } else
       (yyval.x) = (yyvsp[(3) - (4)].x);
   }
    break;

  case 284:
/* Line 1792 of yacc.c  */
#line 1684 "cf-parse.y"
    { DBG( "Beginning of function %s\n", (yyvsp[(2) - (2)].s)->name );
     (yyvsp[(2) - (2)].s) = cf_define_symbol((yyvsp[(2) - (2)].s), SYM_FUNCTION, NULL);
     cf_push_scope((yyvsp[(2) - (2)].s));
   }
    break;

  case 285:
/* Line 1792 of yacc.c  */
#line 1687 "cf-parse.y"
    {
     (yyvsp[(2) - (5)].s)->def = (yyvsp[(5) - (5)].x);
     (yyvsp[(2) - (5)].s)->aux2 = (yyvsp[(4) - (5)].s);
     DBG("Hmm, we've got one function here - %s\n", (yyvsp[(2) - (5)].s)->name); 
     cf_pop_scope();
   }
    break;

  case 286:
/* Line 1792 of yacc.c  */
#line 1700 "cf-parse.y"
    { (yyval.x) = NULL; }
    break;

  case 287:
/* Line 1792 of yacc.c  */
#line 1701 "cf-parse.y"
    { (yyval.x) = (yyvsp[(1) - (1)].x)->next; (yyvsp[(1) - (1)].x)->next = NULL; }
    break;

  case 288:
/* Line 1792 of yacc.c  */
#line 1704 "cf-parse.y"
    { (yyval.x) = (yyvsp[(1) - (1)].x); (yyvsp[(1) - (1)].x)->next = (yyvsp[(1) - (1)].x); }
    break;

  case 289:
/* Line 1792 of yacc.c  */
#line 1705 "cf-parse.y"
    { (yyval.x) = (yyvsp[(2) - (2)].x); (yyvsp[(2) - (2)].x)->next = (yyvsp[(1) - (2)].x)->next ; (yyvsp[(1) - (2)].x)->next = (yyvsp[(2) - (2)].x); }
    break;

  case 290:
/* Line 1792 of yacc.c  */
#line 1709 "cf-parse.y"
    {
     (yyval.x)=(yyvsp[(1) - (1)].x);
   }
    break;

  case 291:
/* Line 1792 of yacc.c  */
#line 1712 "cf-parse.y"
    {
     (yyval.x)=(yyvsp[(2) - (3)].x);
   }
    break;

  case 292:
/* Line 1792 of yacc.c  */
#line 1721 "cf-parse.y"
    { (yyval.v).type = T_IP; (yyval.v).val.px.ip = (yyvsp[(1) - (1)].a); }
    break;

  case 293:
/* Line 1792 of yacc.c  */
#line 1734 "cf-parse.y"
    { (yyval.v).type = T_INT; (yyval.v).val.i = (yyvsp[(1) - (1)].i); }
    break;

  case 294:
/* Line 1792 of yacc.c  */
#line 1735 "cf-parse.y"
    { (yyval.v).type = T_QUAD; (yyval.v).val.i = (yyvsp[(1) - (1)].i32); }
    break;

  case 295:
/* Line 1792 of yacc.c  */
#line 1736 "cf-parse.y"
    { (yyval.v) = (yyvsp[(1) - (1)].v); }
    break;

  case 296:
/* Line 1792 of yacc.c  */
#line 1737 "cf-parse.y"
    { (yyval.v).type = pair_a((yyvsp[(1) - (1)].i)); (yyval.v).val.i = pair_b((yyvsp[(1) - (1)].i)); }
    break;

  case 297:
/* Line 1792 of yacc.c  */
#line 1741 "cf-parse.y"
    { (yyval.v).type = T_INT; (yyval.v).val.i = (yyvsp[(1) - (1)].i); }
    break;

  case 298:
/* Line 1792 of yacc.c  */
#line 1742 "cf-parse.y"
    { (yyval.v).type = T_INT; (yyval.v).val.i = f_eval_int((yyvsp[(2) - (3)].x)); }
    break;

  case 299:
/* Line 1792 of yacc.c  */
#line 1743 "cf-parse.y"
    { (yyval.v).type = T_QUAD; (yyval.v).val.i = (yyvsp[(1) - (1)].i32); }
    break;

  case 300:
/* Line 1792 of yacc.c  */
#line 1744 "cf-parse.y"
    { (yyval.v) = (yyvsp[(1) - (1)].v); }
    break;

  case 301:
/* Line 1792 of yacc.c  */
#line 1745 "cf-parse.y"
    { (yyval.v).type = pair_a((yyvsp[(1) - (1)].i)); (yyval.v).val.i = pair_b((yyvsp[(1) - (1)].i)); }
    break;

  case 302:
/* Line 1792 of yacc.c  */
#line 1749 "cf-parse.y"
    { (yyval.i) = f_eval_int((yyvsp[(1) - (1)].x)); check_u16((yyval.i)); }
    break;

  case 303:
/* Line 1792 of yacc.c  */
#line 1752 "cf-parse.y"
    { (yyval.i32) = pair((yyvsp[(1) - (1)].i), (yyvsp[(1) - (1)].i)); }
    break;

  case 304:
/* Line 1792 of yacc.c  */
#line 1753 "cf-parse.y"
    { (yyval.i32) = pair((yyvsp[(1) - (3)].i), (yyvsp[(3) - (3)].i)); }
    break;

  case 305:
/* Line 1792 of yacc.c  */
#line 1754 "cf-parse.y"
    { (yyval.i32) = 0xFFFF; }
    break;

  case 306:
/* Line 1792 of yacc.c  */
#line 1758 "cf-parse.y"
    {
     (yyval.e) = f_new_pair_set(pair_a((yyvsp[(2) - (5)].i32)), pair_b((yyvsp[(2) - (5)].i32)), pair_a((yyvsp[(4) - (5)].i32)), pair_b((yyvsp[(4) - (5)].i32)));
   }
    break;

  case 307:
/* Line 1792 of yacc.c  */
#line 1761 "cf-parse.y"
    {
     /* Hack: $2 and $4 should be pair_expr, but that would cause shift/reduce conflict */
     if ((pair_a((yyvsp[(2) - (11)].i32)) != pair_b((yyvsp[(2) - (11)].i32))) || (pair_a((yyvsp[(4) - (11)].i32)) != pair_b((yyvsp[(4) - (11)].i32))))
       cf_error("syntax error");
     (yyval.e) = f_new_pair_item(pair_b((yyvsp[(2) - (11)].i32)), (yyvsp[(8) - (11)].i), pair_b((yyvsp[(4) - (11)].i32)), (yyvsp[(10) - (11)].i)); 
   }
    break;

  case 308:
/* Line 1792 of yacc.c  */
#line 1770 "cf-parse.y"
    { (yyval.i32) = f_eval_int((yyvsp[(1) - (1)].x)); }
    break;

  case 309:
/* Line 1792 of yacc.c  */
#line 1773 "cf-parse.y"
    { (yyval.i) = EC_RT; }
    break;

  case 310:
/* Line 1792 of yacc.c  */
#line 1774 "cf-parse.y"
    { (yyval.i) = EC_RO; }
    break;

  case 311:
/* Line 1792 of yacc.c  */
#line 1775 "cf-parse.y"
    { (yyval.i) = (yyvsp[(2) - (2)].i); }
    break;

  case 312:
/* Line 1792 of yacc.c  */
#line 1776 "cf-parse.y"
    { (yyval.i) = EC_GENERIC; }
    break;

  case 313:
/* Line 1792 of yacc.c  */
#line 1780 "cf-parse.y"
    { (yyval.e) = f_new_ec_item((yyvsp[(2) - (7)].i), 0, (yyvsp[(4) - (7)].i32), (yyvsp[(6) - (7)].i32), (yyvsp[(6) - (7)].i32)); }
    break;

  case 314:
/* Line 1792 of yacc.c  */
#line 1781 "cf-parse.y"
    { (yyval.e) = f_new_ec_item((yyvsp[(2) - (9)].i), 0, (yyvsp[(4) - (9)].i32), (yyvsp[(6) - (9)].i32), (yyvsp[(8) - (9)].i32)); }
    break;

  case 315:
/* Line 1792 of yacc.c  */
#line 1782 "cf-parse.y"
    {  (yyval.e) = f_new_ec_item((yyvsp[(2) - (7)].i), 0, (yyvsp[(4) - (7)].i32), 0, EC_ALL); }
    break;

  case 318:
/* Line 1792 of yacc.c  */
#line 1788 "cf-parse.y"
    { (yyval.e) = f_new_item((yyvsp[(1) - (1)].v), (yyvsp[(1) - (1)].v)); }
    break;

  case 319:
/* Line 1792 of yacc.c  */
#line 1789 "cf-parse.y"
    { (yyval.e) = f_new_item((yyvsp[(1) - (3)].v), (yyvsp[(3) - (3)].v)); }
    break;

  case 322:
/* Line 1792 of yacc.c  */
#line 1795 "cf-parse.y"
    { (yyval.e) = f_new_item((yyvsp[(1) - (1)].v), (yyvsp[(1) - (1)].v)); }
    break;

  case 323:
/* Line 1792 of yacc.c  */
#line 1796 "cf-parse.y"
    { (yyval.e) = f_new_item((yyvsp[(1) - (3)].v), (yyvsp[(3) - (3)].v)); }
    break;

  case 325:
/* Line 1792 of yacc.c  */
#line 1801 "cf-parse.y"
    { (yyval.e) = f_merge_items((yyvsp[(1) - (3)].e), (yyvsp[(3) - (3)].e)); }
    break;

  case 327:
/* Line 1792 of yacc.c  */
#line 1806 "cf-parse.y"
    { (yyval.e) = f_merge_items((yyvsp[(1) - (3)].e), (yyvsp[(3) - (3)].e)); }
    break;

  case 328:
/* Line 1792 of yacc.c  */
#line 1810 "cf-parse.y"
    {
     if (((yyvsp[(3) - (3)].i) < 0) || ((yyvsp[(3) - (3)].i) > MAX_PREFIX_LENGTH) || !ip_is_prefix((yyvsp[(1) - (3)].a), (yyvsp[(3) - (3)].i))) cf_error("Invalid network prefix: %I/%d.", (yyvsp[(1) - (3)].a), (yyvsp[(3) - (3)].i));
     (yyval.v).type = T_PREFIX; (yyval.v).val.px.ip = (yyvsp[(1) - (3)].a); (yyval.v).val.px.len = (yyvsp[(3) - (3)].i);
   }
    break;

  case 329:
/* Line 1792 of yacc.c  */
#line 1817 "cf-parse.y"
    { (yyval.v) = (yyvsp[(1) - (1)].v); }
    break;

  case 330:
/* Line 1792 of yacc.c  */
#line 1818 "cf-parse.y"
    { (yyval.v) = (yyvsp[(1) - (2)].v); (yyval.v).val.px.len |= LEN_PLUS; }
    break;

  case 331:
/* Line 1792 of yacc.c  */
#line 1819 "cf-parse.y"
    { (yyval.v) = (yyvsp[(1) - (2)].v); (yyval.v).val.px.len |= LEN_MINUS; }
    break;

  case 332:
/* Line 1792 of yacc.c  */
#line 1820 "cf-parse.y"
    { 
     if (! ((0 <= (yyvsp[(3) - (6)].i)) && ((yyvsp[(3) - (6)].i) <= (yyvsp[(5) - (6)].i)) && ((yyvsp[(5) - (6)].i) <= MAX_PREFIX_LENGTH))) cf_error("Invalid prefix pattern range: {%d, %d}.", (yyvsp[(3) - (6)].i), (yyvsp[(5) - (6)].i));
     (yyval.v) = (yyvsp[(1) - (6)].v); (yyval.v).val.px.len |= LEN_RANGE | ((yyvsp[(3) - (6)].i) << 16) | ((yyvsp[(5) - (6)].i) << 8);
   }
    break;

  case 333:
/* Line 1792 of yacc.c  */
#line 1827 "cf-parse.y"
    { (yyval.trie) = f_new_trie(cfg_mem); trie_add_fprefix((yyval.trie), &((yyvsp[(1) - (1)].v).val.px)); }
    break;

  case 334:
/* Line 1792 of yacc.c  */
#line 1828 "cf-parse.y"
    { (yyval.trie) = (yyvsp[(1) - (3)].trie); trie_add_fprefix((yyval.trie), &((yyvsp[(3) - (3)].v).val.px)); }
    break;

  case 335:
/* Line 1792 of yacc.c  */
#line 1831 "cf-parse.y"
    { (yyval.e) = NULL; }
    break;

  case 336:
/* Line 1792 of yacc.c  */
#line 1832 "cf-parse.y"
    {
     /* Fill data fields */
     struct f_tree *t;
     for (t = (yyvsp[(2) - (4)].e); t; t = t->left)
       t->data = (yyvsp[(4) - (4)].x);
     (yyval.e) = f_merge_items((yyvsp[(1) - (4)].e), (yyvsp[(2) - (4)].e));
   }
    break;

  case 337:
/* Line 1792 of yacc.c  */
#line 1839 "cf-parse.y"
    { 
     struct f_tree *t = f_new_tree();
     t->from.type = t->to.type = T_VOID;
     t->right = t;
     t->data = (yyvsp[(3) - (3)].x);
     (yyval.e) = f_merge_items((yyvsp[(1) - (3)].e), t);
 }
    break;

  case 338:
/* Line 1792 of yacc.c  */
#line 1851 "cf-parse.y"
    { (yyval.x) = (yyvsp[(1) - (1)].x); }
    break;

  case 339:
/* Line 1792 of yacc.c  */
#line 1852 "cf-parse.y"
    { (yyval.x) = (yyvsp[(2) - (3)].x); }
    break;

  case 340:
/* Line 1792 of yacc.c  */
#line 1856 "cf-parse.y"
    { (yyval.h) = (yyvsp[(2) - (3)].h); }
    break;

  case 341:
/* Line 1792 of yacc.c  */
#line 1857 "cf-parse.y"
    { (yyval.h) = (yyvsp[(2) - (3)].h); }
    break;

  case 342:
/* Line 1792 of yacc.c  */
#line 1861 "cf-parse.y"
    { (yyval.h) = cfg_alloc(sizeof(struct f_path_mask)); (yyval.h)->next = (yyvsp[(2) - (2)].h); (yyval.h)->kind = PM_ASN;      (yyval.h)->val = (yyvsp[(1) - (2)].i); }
    break;

  case 343:
/* Line 1792 of yacc.c  */
#line 1862 "cf-parse.y"
    { (yyval.h) = cfg_alloc(sizeof(struct f_path_mask)); (yyval.h)->next = (yyvsp[(2) - (2)].h); (yyval.h)->kind = PM_ASTERISK; (yyval.h)->val  = 0; }
    break;

  case 344:
/* Line 1792 of yacc.c  */
#line 1863 "cf-parse.y"
    { (yyval.h) = cfg_alloc(sizeof(struct f_path_mask)); (yyval.h)->next = (yyvsp[(2) - (2)].h); (yyval.h)->kind = PM_QUESTION; (yyval.h)->val  = 0; }
    break;

  case 345:
/* Line 1792 of yacc.c  */
#line 1864 "cf-parse.y"
    { (yyval.h) = cfg_alloc(sizeof(struct f_path_mask)); (yyval.h)->next = (yyvsp[(2) - (2)].h); (yyval.h)->kind = PM_ASN_EXPR; (yyval.h)->val = (uintptr_t) (yyvsp[(1) - (2)].x); }
    break;

  case 346:
/* Line 1792 of yacc.c  */
#line 1865 "cf-parse.y"
    { (yyval.h) = NULL; }
    break;

  case 347:
/* Line 1792 of yacc.c  */
#line 1869 "cf-parse.y"
    { (yyval.h) = cfg_alloc(sizeof(struct f_path_mask)); (yyval.h)->next = (yyvsp[(2) - (2)].h); (yyval.h)->kind = PM_ASN;      (yyval.h)->val = (yyvsp[(1) - (2)].i); }
    break;

  case 348:
/* Line 1792 of yacc.c  */
#line 1870 "cf-parse.y"
    { (yyval.h) = cfg_alloc(sizeof(struct f_path_mask)); (yyval.h)->next = (yyvsp[(2) - (2)].h); (yyval.h)->kind = PM_ASTERISK; (yyval.h)->val  = 0; }
    break;

  case 349:
/* Line 1792 of yacc.c  */
#line 1871 "cf-parse.y"
    { (yyval.h) = NULL; }
    break;

  case 350:
/* Line 1792 of yacc.c  */
#line 1875 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'c'; (yyval.x)->aux = T_INT;  (yyval.x)->a2.i = (yyvsp[(1) - (1)].i); }
    break;

  case 351:
/* Line 1792 of yacc.c  */
#line 1876 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'c'; (yyval.x)->aux = T_BOOL; (yyval.x)->a2.i = 1;  }
    break;

  case 352:
/* Line 1792 of yacc.c  */
#line 1877 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'c'; (yyval.x)->aux = T_BOOL; (yyval.x)->a2.i = 0;  }
    break;

  case 353:
/* Line 1792 of yacc.c  */
#line 1878 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'c'; (yyval.x)->aux = T_STRING; (yyval.x)->a2.p = (yyvsp[(1) - (1)].t); }
    break;

  case 354:
/* Line 1792 of yacc.c  */
#line 1879 "cf-parse.y"
    { NEW_F_VAL; (yyval.x) = f_new_inst(); (yyval.x)->code = 'C'; (yyval.x)->a1.p = val; *val = (yyvsp[(1) - (1)].v); }
    break;

  case 355:
/* Line 1792 of yacc.c  */
#line 1880 "cf-parse.y"
    {NEW_F_VAL; (yyval.x) = f_new_inst(); (yyval.x)->code = 'C'; (yyval.x)->a1.p = val; *val = (yyvsp[(1) - (1)].v); }
    break;

  case 356:
/* Line 1792 of yacc.c  */
#line 1881 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'c'; (yyval.x)->aux = T_QUAD;  (yyval.x)->a2.i = (yyvsp[(1) - (1)].i32); }
    break;

  case 357:
/* Line 1792 of yacc.c  */
#line 1882 "cf-parse.y"
    { DBG( "We've got a set here..." ); (yyval.x) = f_new_inst(); (yyval.x)->code = 'c'; (yyval.x)->aux = T_SET; (yyval.x)->a2.p = build_tree((yyvsp[(2) - (3)].e)); DBG( "ook\n" ); }
    break;

  case 358:
/* Line 1792 of yacc.c  */
#line 1883 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'c'; (yyval.x)->aux = T_PREFIX_SET;  (yyval.x)->a2.p = (yyvsp[(2) - (3)].trie); }
    break;

  case 359:
/* Line 1792 of yacc.c  */
#line 1884 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'c'; (yyval.x)->aux = (yyvsp[(1) - (1)].i) >> 16; (yyval.x)->a2.i = (yyvsp[(1) - (1)].i) & 0xffff; }
    break;

  case 360:
/* Line 1792 of yacc.c  */
#line 1885 "cf-parse.y"
    { NEW_F_VAL; (yyval.x) = f_new_inst(); (yyval.x)->code = 'C'; val->type = T_PATH_MASK; val->val.path_mask = (yyvsp[(1) - (1)].h); (yyval.x)->a1.p = val; }
    break;

  case 361:
/* Line 1792 of yacc.c  */
#line 1889 "cf-parse.y"
    { (yyval.x) = f_generate_dpair((yyvsp[(2) - (5)].x), (yyvsp[(4) - (5)].x)); }
    break;

  case 362:
/* Line 1792 of yacc.c  */
#line 1890 "cf-parse.y"
    { (yyval.x) = f_generate_ec((yyvsp[(2) - (7)].i), (yyvsp[(4) - (7)].x), (yyvsp[(6) - (7)].x)); }
    break;

  case 364:
/* Line 1792 of yacc.c  */
#line 1904 "cf-parse.y"
    {
     struct symbol *sym;
     struct f_inst *inst = (yyvsp[(3) - (4)].x);
     if ((yyvsp[(1) - (4)].s)->class != SYM_FUNCTION)
       cf_error("You can't call something which is not a function. Really.");
     DBG("You are calling function %s\n", (yyvsp[(1) - (4)].s)->name);
     (yyval.x) = f_new_inst();
     (yyval.x)->code = P('c','a');
     (yyval.x)->a1.p = inst;
     (yyval.x)->a2.p = (yyvsp[(1) - (4)].s)->def;
     sym = (yyvsp[(1) - (4)].s)->aux2;
     while (sym || inst) {
       if (!sym || !inst)
	 cf_error("Wrong number of arguments for function %s.", (yyvsp[(1) - (4)].s)->name);
       DBG( "You should pass parameter called %s\n", sym->name);
       inst->a1.p = sym;
       sym = sym->aux2;
       inst = inst->next;
     }
   }
    break;

  case 365:
/* Line 1792 of yacc.c  */
#line 1927 "cf-parse.y"
    {
     (yyval.x) = f_new_inst();

     switch ((yyvsp[(1) - (1)].s)->class & 0xff00) {
       case SYM_CONSTANT: (yyval.x)->code = 'C'; break;
       case SYM_VARIABLE: (yyval.x)->code = 'V'; break;
       default: cf_error("%s: variable expected.", (yyvsp[(1) - (1)].s)->name);
     }

     (yyval.x)->a1.p = (yyvsp[(1) - (1)].s)->def;
     (yyval.x)->a2.p = (yyvsp[(1) - (1)].s)->name;
   }
    break;

  case 366:
/* Line 1792 of yacc.c  */
#line 1941 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->aux = T_IP;         (yyval.x)->a2.i = OFFSETOF(struct rta, from);   (yyval.x)->a1.i = 1; }
    break;

  case 367:
/* Line 1792 of yacc.c  */
#line 1943 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->aux = T_IP;         (yyval.x)->a2.i = OFFSETOF(struct rta, gw);     (yyval.x)->a1.i = 1; }
    break;

  case 368:
/* Line 1792 of yacc.c  */
#line 1944 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->aux = T_PREFIX;     (yyval.x)->a2.i = 0x12345678; /* This is actually ok - T_PREFIX is special-cased. */ }
    break;

  case 369:
/* Line 1792 of yacc.c  */
#line 1945 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->aux = T_STRING;     (yyval.x)->a2.i = 0x12345678; /* T_STRING is also special-cased. */ }
    break;

  case 370:
/* Line 1792 of yacc.c  */
#line 1946 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->aux = T_ENUM_RTS;   (yyval.x)->a2.i = OFFSETOF(struct rta, source); }
    break;

  case 371:
/* Line 1792 of yacc.c  */
#line 1947 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->aux = T_ENUM_SCOPE; (yyval.x)->a2.i = OFFSETOF(struct rta, scope);  (yyval.x)->a1.i = 1; }
    break;

  case 372:
/* Line 1792 of yacc.c  */
#line 1948 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->aux = T_ENUM_RTC;   (yyval.x)->a2.i = OFFSETOF(struct rta, cast); }
    break;

  case 373:
/* Line 1792 of yacc.c  */
#line 1949 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->aux = T_ENUM_RTD;   (yyval.x)->a2.i = OFFSETOF(struct rta, dest);   (yyval.x)->a1.i = 1; }
    break;

  case 374:
/* Line 1792 of yacc.c  */
#line 1953 "cf-parse.y"
    { (yyval.x) = (yyvsp[(2) - (3)].x); }
    break;

  case 375:
/* Line 1792 of yacc.c  */
#line 1954 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = '+';        (yyval.x)->a1.p = (yyvsp[(1) - (3)].x); (yyval.x)->a2.p = (yyvsp[(3) - (3)].x); }
    break;

  case 376:
/* Line 1792 of yacc.c  */
#line 1955 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = '-';        (yyval.x)->a1.p = (yyvsp[(1) - (3)].x); (yyval.x)->a2.p = (yyvsp[(3) - (3)].x); }
    break;

  case 377:
/* Line 1792 of yacc.c  */
#line 1956 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = '*';        (yyval.x)->a1.p = (yyvsp[(1) - (3)].x); (yyval.x)->a2.p = (yyvsp[(3) - (3)].x); }
    break;

  case 378:
/* Line 1792 of yacc.c  */
#line 1957 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = '/';        (yyval.x)->a1.p = (yyvsp[(1) - (3)].x); (yyval.x)->a2.p = (yyvsp[(3) - (3)].x); }
    break;

  case 379:
/* Line 1792 of yacc.c  */
#line 1958 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = '&';        (yyval.x)->a1.p = (yyvsp[(1) - (3)].x); (yyval.x)->a2.p = (yyvsp[(3) - (3)].x); }
    break;

  case 380:
/* Line 1792 of yacc.c  */
#line 1959 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = '|';        (yyval.x)->a1.p = (yyvsp[(1) - (3)].x); (yyval.x)->a2.p = (yyvsp[(3) - (3)].x); }
    break;

  case 381:
/* Line 1792 of yacc.c  */
#line 1960 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('=','='); (yyval.x)->a1.p = (yyvsp[(1) - (3)].x); (yyval.x)->a2.p = (yyvsp[(3) - (3)].x); }
    break;

  case 382:
/* Line 1792 of yacc.c  */
#line 1961 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('!','=');     (yyval.x)->a1.p = (yyvsp[(1) - (3)].x); (yyval.x)->a2.p = (yyvsp[(3) - (3)].x); }
    break;

  case 383:
/* Line 1792 of yacc.c  */
#line 1962 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = '<';        (yyval.x)->a1.p = (yyvsp[(1) - (3)].x); (yyval.x)->a2.p = (yyvsp[(3) - (3)].x); }
    break;

  case 384:
/* Line 1792 of yacc.c  */
#line 1963 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('<','=');     (yyval.x)->a1.p = (yyvsp[(1) - (3)].x); (yyval.x)->a2.p = (yyvsp[(3) - (3)].x); }
    break;

  case 385:
/* Line 1792 of yacc.c  */
#line 1964 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = '<';        (yyval.x)->a1.p = (yyvsp[(3) - (3)].x); (yyval.x)->a2.p = (yyvsp[(1) - (3)].x); }
    break;

  case 386:
/* Line 1792 of yacc.c  */
#line 1965 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('<','=');     (yyval.x)->a1.p = (yyvsp[(3) - (3)].x); (yyval.x)->a2.p = (yyvsp[(1) - (3)].x); }
    break;

  case 387:
/* Line 1792 of yacc.c  */
#line 1966 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = '~';        (yyval.x)->a1.p = (yyvsp[(1) - (3)].x); (yyval.x)->a2.p = (yyvsp[(3) - (3)].x); }
    break;

  case 388:
/* Line 1792 of yacc.c  */
#line 1967 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = '!'; (yyval.x)->a1.p = (yyvsp[(2) - (2)].x); }
    break;

  case 389:
/* Line 1792 of yacc.c  */
#line 1968 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('d','e');  (yyval.x)->a1.p = (yyvsp[(3) - (4)].x); }
    break;

  case 390:
/* Line 1792 of yacc.c  */
#line 1970 "cf-parse.y"
    { (yyval.x) = (yyvsp[(1) - (1)].x); }
    break;

  case 391:
/* Line 1792 of yacc.c  */
#line 1971 "cf-parse.y"
    { (yyval.x) = (yyvsp[(1) - (1)].x); }
    break;

  case 392:
/* Line 1792 of yacc.c  */
#line 1972 "cf-parse.y"
    { (yyval.x) = (yyvsp[(1) - (1)].x); }
    break;

  case 393:
/* Line 1792 of yacc.c  */
#line 1974 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'P'; }
    break;

  case 394:
/* Line 1792 of yacc.c  */
#line 1976 "cf-parse.y"
    { (yyval.x) = (yyvsp[(2) - (2)].x); (yyval.x)->code = 'a'; }
    break;

  case 395:
/* Line 1792 of yacc.c  */
#line 1978 "cf-parse.y"
    { (yyval.x) = (yyvsp[(2) - (2)].x); (yyval.x)->code = P('e','a'); }
    break;

  case 396:
/* Line 1792 of yacc.c  */
#line 1980 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('c','p'); (yyval.x)->a1.p = (yyvsp[(1) - (3)].x); (yyval.x)->aux = T_IP; }
    break;

  case 397:
/* Line 1792 of yacc.c  */
#line 1981 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'L'; (yyval.x)->a1.p = (yyvsp[(1) - (3)].x); }
    break;

  case 398:
/* Line 1792 of yacc.c  */
#line 1982 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('i','M'); (yyval.x)->a1.p = (yyvsp[(1) - (6)].x); (yyval.x)->a2.p = (yyvsp[(5) - (6)].x); }
    break;

  case 399:
/* Line 1792 of yacc.c  */
#line 1983 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('a','f'); (yyval.x)->a1.p = (yyvsp[(1) - (3)].x); }
    break;

  case 400:
/* Line 1792 of yacc.c  */
#line 1984 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('a','l'); (yyval.x)->a1.p = (yyvsp[(1) - (3)].x); }
    break;

  case 401:
/* Line 1792 of yacc.c  */
#line 1994 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'E'; (yyval.x)->aux = T_PATH; }
    break;

  case 402:
/* Line 1792 of yacc.c  */
#line 1995 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'E'; (yyval.x)->aux = T_CLIST; }
    break;

  case 403:
/* Line 1792 of yacc.c  */
#line 1996 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'E'; (yyval.x)->aux = T_ECLIST; }
    break;

  case 404:
/* Line 1792 of yacc.c  */
#line 1997 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('A','p'); (yyval.x)->a1.p = (yyvsp[(3) - (6)].x); (yyval.x)->a2.p = (yyvsp[(5) - (6)].x); }
    break;

  case 405:
/* Line 1792 of yacc.c  */
#line 1998 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('C','a'); (yyval.x)->a1.p = (yyvsp[(3) - (6)].x); (yyval.x)->a2.p = (yyvsp[(5) - (6)].x); (yyval.x)->aux = 'a'; }
    break;

  case 406:
/* Line 1792 of yacc.c  */
#line 1999 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('C','a'); (yyval.x)->a1.p = (yyvsp[(3) - (6)].x); (yyval.x)->a2.p = (yyvsp[(5) - (6)].x); (yyval.x)->aux = 'd'; }
    break;

  case 407:
/* Line 1792 of yacc.c  */
#line 2000 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('C','a'); (yyval.x)->a1.p = (yyvsp[(3) - (6)].x); (yyval.x)->a2.p = (yyvsp[(5) - (6)].x); (yyval.x)->aux = 'f'; }
    break;

  case 408:
/* Line 1792 of yacc.c  */
#line 2002 "cf-parse.y"
    { (yyval.x) = f_generate_roa_check((yyvsp[(3) - (4)].s), NULL, NULL); }
    break;

  case 409:
/* Line 1792 of yacc.c  */
#line 2003 "cf-parse.y"
    { (yyval.x) = f_generate_roa_check((yyvsp[(3) - (8)].s), (yyvsp[(5) - (8)].x), (yyvsp[(7) - (8)].x)); }
    break;

  case 410:
/* Line 1792 of yacc.c  */
#line 2008 "cf-parse.y"
    {
     struct symbol *sym;
     struct f_inst *inst = (yyvsp[(3) - (4)].x);
     if ((yyvsp[(1) - (4)].s)->class != SYM_FUNCTION)
       cf_error("You can't call something which is not a function. Really.");
     DBG("You are calling function %s\n", (yyvsp[(1) - (4)].s)->name);
     (yyval.x) = f_new_inst();
     (yyval.x)->code = P('c','a');
     (yyval.x)->a1.p = inst;
     (yyval.x)->a2.p = (yyvsp[(1) - (4)].s)->def;
     sym = (yyvsp[(1) - (4)].s)->aux2;
     while (sym || inst) {
       if (!sym || !inst)
	 cf_error("Wrong number of arguments for function %s.", (yyvsp[(1) - (4)].s)->name);
       DBG( "You should pass parameter called %s\n", sym->name);
       inst->a1.p = sym;
       sym = sym->aux2;
       inst = inst->next;
     }
   }
    break;

  case 411:
/* Line 1792 of yacc.c  */
#line 2031 "cf-parse.y"
    { (yyval.i) = F_QUITBIRD; }
    break;

  case 412:
/* Line 1792 of yacc.c  */
#line 2032 "cf-parse.y"
    { (yyval.i) = F_ACCEPT; }
    break;

  case 413:
/* Line 1792 of yacc.c  */
#line 2033 "cf-parse.y"
    { (yyval.i) = F_REJECT; }
    break;

  case 414:
/* Line 1792 of yacc.c  */
#line 2034 "cf-parse.y"
    { (yyval.i) = F_ERROR; }
    break;

  case 415:
/* Line 1792 of yacc.c  */
#line 2035 "cf-parse.y"
    { (yyval.i) = F_NOP; }
    break;

  case 416:
/* Line 1792 of yacc.c  */
#line 2036 "cf-parse.y"
    { (yyval.i) = F_NONL; }
    break;

  case 417:
/* Line 1792 of yacc.c  */
#line 2040 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'p'; (yyval.x)->a1.p = (yyvsp[(1) - (1)].x); (yyval.x)->a2.p = NULL; }
    break;

  case 418:
/* Line 1792 of yacc.c  */
#line 2043 "cf-parse.y"
    { (yyval.x) = NULL; }
    break;

  case 419:
/* Line 1792 of yacc.c  */
#line 2044 "cf-parse.y"
    { (yyval.x) = (yyvsp[(1) - (1)].x); }
    break;

  case 420:
/* Line 1792 of yacc.c  */
#line 2045 "cf-parse.y"
    {
     if ((yyvsp[(1) - (3)].x)) {
       (yyvsp[(1) - (3)].x)->next = (yyvsp[(3) - (3)].x);
       (yyval.x) = (yyvsp[(1) - (3)].x);
     } else (yyval.x) = (yyvsp[(3) - (3)].x);
   }
    break;

  case 421:
/* Line 1792 of yacc.c  */
#line 2053 "cf-parse.y"
    { 
     (yyval.x) = f_new_inst();
     (yyval.x)->code = 's';
     (yyval.x)->a1.p = NULL;
     (yyval.x)->a2.p = (yyvsp[(1) - (1)].x);
     (yyval.x)->next = NULL;
   }
    break;

  case 422:
/* Line 1792 of yacc.c  */
#line 2060 "cf-parse.y"
    {
     (yyval.x) = f_new_inst();
     (yyval.x)->code = 's';
     (yyval.x)->a1.p = NULL;
     (yyval.x)->a2.p = (yyvsp[(1) - (3)].x);
     (yyval.x)->next = (yyvsp[(3) - (3)].x);
   }
    break;

  case 423:
/* Line 1792 of yacc.c  */
#line 2069 "cf-parse.y"
    { (yyval.x) = NULL; }
    break;

  case 424:
/* Line 1792 of yacc.c  */
#line 2070 "cf-parse.y"
    { (yyval.x) = (yyvsp[(1) - (1)].x); }
    break;

  case 425:
/* Line 1792 of yacc.c  */
#line 2074 "cf-parse.y"
    {
     (yyval.x) = f_new_inst();
     (yyval.x)->code = '?';
     (yyval.x)->a1.p = (yyvsp[(2) - (4)].x);
     (yyval.x)->a2.p = (yyvsp[(4) - (4)].x);
   }
    break;

  case 426:
/* Line 1792 of yacc.c  */
#line 2080 "cf-parse.y"
    {
     struct f_inst *i = f_new_inst();
     i->code = '?';
     i->a1.p = (yyvsp[(2) - (6)].x);
     i->a2.p = (yyvsp[(4) - (6)].x);
     (yyval.x) = f_new_inst();
     (yyval.x)->code = '?';
     (yyval.x)->a1.p = i;
     (yyval.x)->a2.p = (yyvsp[(6) - (6)].x);
   }
    break;

  case 427:
/* Line 1792 of yacc.c  */
#line 2090 "cf-parse.y"
    {
     (yyval.x) = f_new_inst();
     DBG( "Ook, we'll set value\n" );
     if (((yyvsp[(1) - (4)].s)->class & ~T_MASK) != SYM_VARIABLE)
       cf_error( "You may set only variables." );
     (yyval.x)->code = 's';
     (yyval.x)->a1.p = (yyvsp[(1) - (4)].s);
     (yyval.x)->a2.p = (yyvsp[(3) - (4)].x);
   }
    break;

  case 428:
/* Line 1792 of yacc.c  */
#line 2099 "cf-parse.y"
    {
     (yyval.x) = f_new_inst();
     DBG( "Ook, we'll return the value\n" );
     (yyval.x)->code = 'r';
     (yyval.x)->a1.p = (yyvsp[(2) - (3)].x);
   }
    break;

  case 429:
/* Line 1792 of yacc.c  */
#line 2105 "cf-parse.y"
    {
     (yyval.x) = (yyvsp[(2) - (5)].x);
     (yyval.x)->code = P('e','S');
     (yyval.x)->a1.p = (yyvsp[(4) - (5)].x);
   }
    break;

  case 430:
/* Line 1792 of yacc.c  */
#line 2110 "cf-parse.y"
    {
     (yyval.x) = (yyvsp[(2) - (5)].x);
     if (!(yyval.x)->a1.i)
       cf_error( "This static attribute is read-only.");
     (yyval.x)->code = P('a','S');
     (yyval.x)->a1.p = (yyvsp[(4) - (5)].x);
   }
    break;

  case 431:
/* Line 1792 of yacc.c  */
#line 2117 "cf-parse.y"
    {
     (yyval.x) = f_new_inst();
     (yyval.x)->code = P('P','S');
     (yyval.x)->a1.p = (yyvsp[(3) - (4)].x);
   }
    break;

  case 432:
/* Line 1792 of yacc.c  */
#line 2122 "cf-parse.y"
    {
     (yyval.x) = (yyvsp[(4) - (6)].x);
     (yyval.x)->aux = EAF_TYPE_UNDEF | EAF_TEMP;
     (yyval.x)->code = P('e','S');
     (yyval.x)->a1.p = NULL;
   }
    break;

  case 433:
/* Line 1792 of yacc.c  */
#line 2128 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('p',','); (yyval.x)->a1.p = (yyvsp[(2) - (3)].x); (yyval.x)->a2.i = (yyvsp[(1) - (3)].i); }
    break;

  case 434:
/* Line 1792 of yacc.c  */
#line 2129 "cf-parse.y"
    { (yyval.x) = (yyvsp[(1) - (2)].x); }
    break;

  case 435:
/* Line 1792 of yacc.c  */
#line 2130 "cf-parse.y"
    {
      (yyval.x) = f_new_inst();
      (yyval.x)->code = P('S','W');
      (yyval.x)->a1.p = (yyvsp[(2) - (5)].x);
      (yyval.x)->a2.p = build_tree( (yyvsp[(4) - (5)].e) );
   }
    break;

  case 436:
/* Line 1792 of yacc.c  */
#line 2138 "cf-parse.y"
    { (yyval.x) = f_generate_empty((yyvsp[(2) - (5)].x)); }
    break;

  case 437:
/* Line 1792 of yacc.c  */
#line 2139 "cf-parse.y"
    { (yyval.x) = f_generate_complex( P('A','p'), 'x', (yyvsp[(2) - (8)].x), (yyvsp[(6) - (8)].x) ); }
    break;

  case 438:
/* Line 1792 of yacc.c  */
#line 2140 "cf-parse.y"
    { (yyval.x) = f_generate_complex( P('C','a'), 'a', (yyvsp[(2) - (8)].x), (yyvsp[(6) - (8)].x) ); }
    break;

  case 439:
/* Line 1792 of yacc.c  */
#line 2141 "cf-parse.y"
    { (yyval.x) = f_generate_complex( P('C','a'), 'd', (yyvsp[(2) - (8)].x), (yyvsp[(6) - (8)].x) ); }
    break;

  case 440:
/* Line 1792 of yacc.c  */
#line 2142 "cf-parse.y"
    { (yyval.x) = f_generate_complex( P('C','a'), 'f', (yyvsp[(2) - (8)].x), (yyvsp[(6) - (8)].x) ); }
    break;

  case 441:
/* Line 1792 of yacc.c  */
#line 2148 "cf-parse.y"
    {
     this_proto = proto_config_new(&proto_bgp, sizeof(struct bgp_config), (yyvsp[(1) - (2)].i));
     BGP_CFG->hold_time = 240;
     BGP_CFG->connect_retry_time = 120;
     BGP_CFG->initial_hold_time = 240;
     BGP_CFG->compare_path_lengths = 1;
     BGP_CFG->igp_metric = 1;
     BGP_CFG->start_delay_time = 5;
     BGP_CFG->error_amnesia_time = 300;
     BGP_CFG->error_delay_time_min = 60;
     BGP_CFG->error_delay_time_max = 300;
     BGP_CFG->enable_refresh = 1;
     BGP_CFG->enable_as4 = 1;
     BGP_CFG->capabilities = 2;
     BGP_CFG->advertise_ipv4 = 1;
     BGP_CFG->interpret_communities = 1;
     BGP_CFG->default_local_pref = 100;
 }
    break;

  case 444:
/* Line 1792 of yacc.c  */
#line 2171 "cf-parse.y"
    { BGP_CFG->local_as = (yyvsp[(4) - (5)].i); }
    break;

  case 445:
/* Line 1792 of yacc.c  */
#line 2172 "cf-parse.y"
    { BGP_CFG->source_addr = (yyvsp[(3) - (6)].a); BGP_CFG->local_as = (yyvsp[(5) - (6)].i); }
    break;

  case 446:
/* Line 1792 of yacc.c  */
#line 2173 "cf-parse.y"
    {
     if (ipa_nonzero(BGP_CFG->remote_ip))
       cf_error("Only one neighbor per BGP instance is allowed");
     if (!ipa_has_link_scope((yyvsp[(3) - (7)].a)) != !(yyvsp[(4) - (7)].iface))
       cf_error("Link-local address and interface scope must be used together");

     BGP_CFG->remote_ip = (yyvsp[(3) - (7)].a);
     BGP_CFG->iface = (yyvsp[(4) - (7)].iface);
     BGP_CFG->remote_as = (yyvsp[(6) - (7)].i);
   }
    break;

  case 447:
/* Line 1792 of yacc.c  */
#line 2183 "cf-parse.y"
    { BGP_CFG->rr_cluster_id = (yyvsp[(5) - (6)].i32); }
    break;

  case 448:
/* Line 1792 of yacc.c  */
#line 2184 "cf-parse.y"
    { BGP_CFG->rr_client = 1; }
    break;

  case 449:
/* Line 1792 of yacc.c  */
#line 2185 "cf-parse.y"
    { BGP_CFG->rs_client = 1; }
    break;

  case 450:
/* Line 1792 of yacc.c  */
#line 2186 "cf-parse.y"
    { BGP_CFG->hold_time = (yyvsp[(4) - (5)].i); }
    break;

  case 451:
/* Line 1792 of yacc.c  */
#line 2187 "cf-parse.y"
    { BGP_CFG->initial_hold_time = (yyvsp[(5) - (6)].i); }
    break;

  case 452:
/* Line 1792 of yacc.c  */
#line 2188 "cf-parse.y"
    { BGP_CFG->connect_retry_time = (yyvsp[(5) - (6)].i); }
    break;

  case 453:
/* Line 1792 of yacc.c  */
#line 2189 "cf-parse.y"
    { BGP_CFG->keepalive_time = (yyvsp[(4) - (5)].i); }
    break;

  case 454:
/* Line 1792 of yacc.c  */
#line 2190 "cf-parse.y"
    { BGP_CFG->multihop = 64; }
    break;

  case 455:
/* Line 1792 of yacc.c  */
#line 2191 "cf-parse.y"
    { BGP_CFG->multihop = (yyvsp[(3) - (4)].i); if (((yyvsp[(3) - (4)].i)<1) || ((yyvsp[(3) - (4)].i)>255)) cf_error("Multihop must be in range 1-255"); }
    break;

  case 456:
/* Line 1792 of yacc.c  */
#line 2192 "cf-parse.y"
    { BGP_CFG->next_hop_self = 1; BGP_CFG->next_hop_keep = 0; }
    break;

  case 457:
/* Line 1792 of yacc.c  */
#line 2193 "cf-parse.y"
    { BGP_CFG->next_hop_keep = 1; BGP_CFG->next_hop_self = 0; }
    break;

  case 458:
/* Line 1792 of yacc.c  */
#line 2194 "cf-parse.y"
    { BGP_CFG->missing_lladdr = MLL_SELF; }
    break;

  case 459:
/* Line 1792 of yacc.c  */
#line 2195 "cf-parse.y"
    { BGP_CFG->missing_lladdr = MLL_DROP; }
    break;

  case 460:
/* Line 1792 of yacc.c  */
#line 2196 "cf-parse.y"
    { BGP_CFG->missing_lladdr = MLL_IGNORE; }
    break;

  case 461:
/* Line 1792 of yacc.c  */
#line 2197 "cf-parse.y"
    { BGP_CFG->gw_mode = GW_DIRECT; }
    break;

  case 462:
/* Line 1792 of yacc.c  */
#line 2198 "cf-parse.y"
    { BGP_CFG->gw_mode = GW_RECURSIVE; }
    break;

  case 463:
/* Line 1792 of yacc.c  */
#line 2199 "cf-parse.y"
    { BGP_CFG->compare_path_lengths = (yyvsp[(4) - (5)].i); }
    break;

  case 464:
/* Line 1792 of yacc.c  */
#line 2200 "cf-parse.y"
    { BGP_CFG->med_metric = (yyvsp[(4) - (5)].i); }
    break;

  case 465:
/* Line 1792 of yacc.c  */
#line 2201 "cf-parse.y"
    { BGP_CFG->igp_metric = (yyvsp[(4) - (5)].i); }
    break;

  case 466:
/* Line 1792 of yacc.c  */
#line 2202 "cf-parse.y"
    { BGP_CFG->prefer_older = (yyvsp[(4) - (5)].i); }
    break;

  case 467:
/* Line 1792 of yacc.c  */
#line 2203 "cf-parse.y"
    { BGP_CFG->deterministic_med = (yyvsp[(4) - (5)].i); }
    break;

  case 468:
/* Line 1792 of yacc.c  */
#line 2204 "cf-parse.y"
    { BGP_CFG->default_med = (yyvsp[(4) - (5)].i); }
    break;

  case 469:
/* Line 1792 of yacc.c  */
#line 2205 "cf-parse.y"
    { BGP_CFG->default_local_pref = (yyvsp[(4) - (5)].i); }
    break;

  case 470:
/* Line 1792 of yacc.c  */
#line 2206 "cf-parse.y"
    { BGP_CFG->source_addr = (yyvsp[(4) - (5)].a); }
    break;

  case 471:
/* Line 1792 of yacc.c  */
#line 2207 "cf-parse.y"
    { BGP_CFG->start_delay_time = (yyvsp[(5) - (6)].i); }
    break;

  case 472:
/* Line 1792 of yacc.c  */
#line 2208 "cf-parse.y"
    { BGP_CFG->error_amnesia_time = (yyvsp[(5) - (6)].i); }
    break;

  case 473:
/* Line 1792 of yacc.c  */
#line 2209 "cf-parse.y"
    { BGP_CFG->error_delay_time_min = (yyvsp[(5) - (8)].i); BGP_CFG->error_delay_time_max = (yyvsp[(7) - (8)].i); }
    break;

  case 474:
/* Line 1792 of yacc.c  */
#line 2210 "cf-parse.y"
    { BGP_CFG->disable_after_error = (yyvsp[(5) - (6)].i); }
    break;

  case 475:
/* Line 1792 of yacc.c  */
#line 2211 "cf-parse.y"
    { BGP_CFG->enable_refresh = (yyvsp[(5) - (6)].i); }
    break;

  case 476:
/* Line 1792 of yacc.c  */
#line 2212 "cf-parse.y"
    { BGP_CFG->enable_as4 = (yyvsp[(4) - (5)].i); }
    break;

  case 477:
/* Line 1792 of yacc.c  */
#line 2213 "cf-parse.y"
    { BGP_CFG->capabilities = (yyvsp[(3) - (4)].i); }
    break;

  case 478:
/* Line 1792 of yacc.c  */
#line 2214 "cf-parse.y"
    { BGP_CFG->advertise_ipv4 = (yyvsp[(4) - (5)].i); }
    break;

  case 479:
/* Line 1792 of yacc.c  */
#line 2215 "cf-parse.y"
    { BGP_CFG->password = (yyvsp[(3) - (4)].t); }
    break;

  case 480:
/* Line 1792 of yacc.c  */
#line 2216 "cf-parse.y"
    {
     this_proto->in_limit = cfg_allocz(sizeof(struct proto_limit));
     this_proto->in_limit->limit = (yyvsp[(4) - (5)].i);
     this_proto->in_limit->action = PLA_RESTART;
   }
    break;

  case 481:
/* Line 1792 of yacc.c  */
#line 2221 "cf-parse.y"
    { BGP_CFG->passive = (yyvsp[(3) - (4)].i); }
    break;

  case 482:
/* Line 1792 of yacc.c  */
#line 2222 "cf-parse.y"
    { BGP_CFG->interpret_communities = (yyvsp[(4) - (5)].i); }
    break;

  case 483:
/* Line 1792 of yacc.c  */
#line 2223 "cf-parse.y"
    { BGP_CFG->secondary = (yyvsp[(3) - (4)].i); }
    break;

  case 484:
/* Line 1792 of yacc.c  */
#line 2224 "cf-parse.y"
    { BGP_CFG->igp_table = (yyvsp[(4) - (5)].r); }
    break;

  case 485:
/* Line 1792 of yacc.c  */
#line 2225 "cf-parse.y"
    { BGP_CFG->ttl_security = (yyvsp[(4) - (5)].i); }
    break;

  case 486:
/* Line 1792 of yacc.c  */
#line 2236 "cf-parse.y"
    {
     this_proto = proto_config_new(&proto_ospf, sizeof(struct ospf_config), (yyvsp[(1) - (2)].i));
     init_list(&OSPF_CFG->area_list);
     init_list(&OSPF_CFG->vlink_list);
     OSPF_CFG->rfc1583 = DEFAULT_RFC1583;
     OSPF_CFG->tick = DEFAULT_OSPFTICK;
  }
    break;

  case 490:
/* Line 1792 of yacc.c  */
#line 2252 "cf-parse.y"
    { OSPF_CFG->rfc1583 = (yyvsp[(2) - (2)].i); }
    break;

  case 491:
/* Line 1792 of yacc.c  */
#line 2253 "cf-parse.y"
    { OSPF_CFG->stub_router = (yyvsp[(3) - (3)].i); }
    break;

  case 492:
/* Line 1792 of yacc.c  */
#line 2254 "cf-parse.y"
    { OSPF_CFG->ecmp = (yyvsp[(2) - (2)].i) ? DEFAULT_ECMP_LIMIT : 0; }
    break;

  case 493:
/* Line 1792 of yacc.c  */
#line 2255 "cf-parse.y"
    { OSPF_CFG->ecmp = (yyvsp[(2) - (4)].i) ? (yyvsp[(4) - (4)].i) : 0; if ((yyvsp[(4) - (4)].i) < 0) cf_error("ECMP limit cannot be negative"); }
    break;

  case 494:
/* Line 1792 of yacc.c  */
#line 2256 "cf-parse.y"
    { OSPF_CFG->tick = (yyvsp[(2) - (2)].i); if((yyvsp[(2) - (2)].i)<=0) cf_error("Tick must be greater than zero"); }
    break;

  case 496:
/* Line 1792 of yacc.c  */
#line 2260 "cf-parse.y"
    {
  this_area = cfg_allocz(sizeof(struct ospf_area_config));
  add_tail(&OSPF_CFG->area_list, NODE this_area);
  this_area->areaid = (yyvsp[(2) - (2)].i32);
  this_area->default_cost = DEFAULT_STUB_COST;
  this_area->type = OPT_E;
  this_area->transint = DEFAULT_TRANSINT;

  init_list(&this_area->patt_list);
  init_list(&this_area->net_list);
  init_list(&this_area->enet_list);
  init_list(&this_area->stubnet_list);
 }
    break;

  case 497:
/* Line 1792 of yacc.c  */
#line 2275 "cf-parse.y"
    { ospf_area_finish(); }
    break;

  case 500:
/* Line 1792 of yacc.c  */
#line 2284 "cf-parse.y"
    { this_area->type = (yyvsp[(2) - (2)].i) ? 0 : OPT_E; /* We should remove the option */ }
    break;

  case 501:
/* Line 1792 of yacc.c  */
#line 2285 "cf-parse.y"
    { this_area->type = OPT_N; }
    break;

  case 502:
/* Line 1792 of yacc.c  */
#line 2286 "cf-parse.y"
    { this_area->summary = (yyvsp[(2) - (2)].i); }
    break;

  case 503:
/* Line 1792 of yacc.c  */
#line 2287 "cf-parse.y"
    { this_area->default_nssa = (yyvsp[(3) - (3)].i); }
    break;

  case 504:
/* Line 1792 of yacc.c  */
#line 2288 "cf-parse.y"
    { this_area->default_cost = (yyvsp[(3) - (3)].i); check_defcost((yyvsp[(3) - (3)].i)); }
    break;

  case 505:
/* Line 1792 of yacc.c  */
#line 2289 "cf-parse.y"
    { this_area->default_cost = (yyvsp[(3) - (3)].i) | LSA_EXT_EBIT; check_defcost((yyvsp[(3) - (3)].i)); }
    break;

  case 506:
/* Line 1792 of yacc.c  */
#line 2290 "cf-parse.y"
    { this_area->default_cost = (yyvsp[(3) - (3)].i);  check_defcost((yyvsp[(3) - (3)].i)); }
    break;

  case 507:
/* Line 1792 of yacc.c  */
#line 2291 "cf-parse.y"
    { this_area->translator = (yyvsp[(2) - (2)].i); }
    break;

  case 508:
/* Line 1792 of yacc.c  */
#line 2292 "cf-parse.y"
    { this_area->transint = (yyvsp[(3) - (3)].i); }
    break;

  case 509:
/* Line 1792 of yacc.c  */
#line 2293 "cf-parse.y"
    { this_nets = &this_area->net_list; }
    break;

  case 511:
/* Line 1792 of yacc.c  */
#line 2294 "cf-parse.y"
    { this_nets = &this_area->enet_list; }
    break;

  case 518:
/* Line 1792 of yacc.c  */
#line 2306 "cf-parse.y"
    {
     this_stubnet = cfg_allocz(sizeof(struct ospf_stubnet_config));
     add_tail(&this_area->stubnet_list, NODE this_stubnet);
     this_stubnet->px = (yyvsp[(1) - (1)].px);
     this_stubnet->cost = COST_D;
   }
    break;

  case 521:
/* Line 1792 of yacc.c  */
#line 2320 "cf-parse.y"
    { this_stubnet->hidden = (yyvsp[(2) - (2)].i); }
    break;

  case 522:
/* Line 1792 of yacc.c  */
#line 2321 "cf-parse.y"
    { this_stubnet->summary = (yyvsp[(2) - (2)].i); }
    break;

  case 523:
/* Line 1792 of yacc.c  */
#line 2322 "cf-parse.y"
    { this_stubnet->cost = (yyvsp[(2) - (2)].i); }
    break;

  case 524:
/* Line 1792 of yacc.c  */
#line 2326 "cf-parse.y"
    { ospf_iface_finish(); }
    break;

  case 525:
/* Line 1792 of yacc.c  */
#line 2327 "cf-parse.y"
    { ospf_iface_finish(); }
    break;

  case 529:
/* Line 1792 of yacc.c  */
#line 2336 "cf-parse.y"
    { OSPF_PATT->helloint = (yyvsp[(2) - (2)].i) ; if (((yyvsp[(2) - (2)].i)<=0) || ((yyvsp[(2) - (2)].i)>65535)) cf_error("Hello interval must be in range 1-65535"); }
    break;

  case 530:
/* Line 1792 of yacc.c  */
#line 2337 "cf-parse.y"
    { OSPF_PATT->rxmtint = (yyvsp[(2) - (2)].i) ; if ((yyvsp[(2) - (2)].i)<=0) cf_error("Retransmit int must be greater than zero"); }
    break;

  case 531:
/* Line 1792 of yacc.c  */
#line 2338 "cf-parse.y"
    { OSPF_PATT->inftransdelay = (yyvsp[(3) - (3)].i) ; if (((yyvsp[(3) - (3)].i)<=0) || ((yyvsp[(3) - (3)].i)>65535)) cf_error("Transmit delay must be in range 1-65535"); }
    break;

  case 532:
/* Line 1792 of yacc.c  */
#line 2339 "cf-parse.y"
    { OSPF_PATT->waitint = (yyvsp[(2) - (2)].i) ; }
    break;

  case 533:
/* Line 1792 of yacc.c  */
#line 2340 "cf-parse.y"
    { OSPF_PATT->deadint = (yyvsp[(2) - (2)].i) ; if ((yyvsp[(2) - (2)].i)<=1) cf_error("Dead interval must be greater than one"); }
    break;

  case 534:
/* Line 1792 of yacc.c  */
#line 2341 "cf-parse.y"
    { OSPF_PATT->deadc = (yyvsp[(3) - (3)].i) ; if ((yyvsp[(3) - (3)].i)<=1) cf_error("Dead count must be greater than one"); }
    break;

  case 535:
/* Line 1792 of yacc.c  */
#line 2342 "cf-parse.y"
    { OSPF_PATT->autype = OSPF_AUTH_NONE ; }
    break;

  case 536:
/* Line 1792 of yacc.c  */
#line 2343 "cf-parse.y"
    { OSPF_PATT->autype = OSPF_AUTH_SIMPLE ; }
    break;

  case 537:
/* Line 1792 of yacc.c  */
#line 2344 "cf-parse.y"
    { OSPF_PATT->autype = OSPF_AUTH_CRYPT ; }
    break;

  case 539:
/* Line 1792 of yacc.c  */
#line 2349 "cf-parse.y"
    {
  if (this_area->areaid == 0) cf_error("Virtual link cannot be in backbone");
  this_ipatt = cfg_allocz(sizeof(struct ospf_iface_patt));
  add_tail(&OSPF_CFG->vlink_list, NODE this_ipatt);
  init_list(&this_ipatt->ipn_list);
  OSPF_PATT->voa = this_area->areaid;
  OSPF_PATT->vid = (yyvsp[(3) - (3)].i32);
  OSPF_PATT->helloint = HELLOINT_D;
  OSPF_PATT->rxmtint = RXMTINT_D;
  OSPF_PATT->inftransdelay = INFTRANSDELAY_D;
  OSPF_PATT->waitint = WAIT_DMH*HELLOINT_D;
  OSPF_PATT->deadc = DEADC_D;
  OSPF_PATT->deadint = 0;
  OSPF_PATT->type = OSPF_IT_VLINK;
  init_list(&OSPF_PATT->nbma_list);
  OSPF_PATT->autype = OSPF_AUTH_NONE;
  reset_passwords();
 }
    break;

  case 540:
/* Line 1792 of yacc.c  */
#line 2370 "cf-parse.y"
    { OSPF_PATT->cost = (yyvsp[(2) - (2)].i) ; if (((yyvsp[(2) - (2)].i)<=0) || ((yyvsp[(2) - (2)].i)>65535)) cf_error("Cost must be in range 1-65535"); }
    break;

  case 541:
/* Line 1792 of yacc.c  */
#line 2371 "cf-parse.y"
    { OSPF_PATT->helloint = (yyvsp[(2) - (2)].i) ; if (((yyvsp[(2) - (2)].i)<=0) || ((yyvsp[(2) - (2)].i)>65535)) cf_error("Hello interval must be in range 1-65535"); }
    break;

  case 542:
/* Line 1792 of yacc.c  */
#line 2372 "cf-parse.y"
    { OSPF_PATT->pollint = (yyvsp[(2) - (2)].i) ; if ((yyvsp[(2) - (2)].i)<=0) cf_error("Poll int must be greater than zero"); }
    break;

  case 543:
/* Line 1792 of yacc.c  */
#line 2373 "cf-parse.y"
    { OSPF_PATT->rxmtint = (yyvsp[(2) - (2)].i) ; if ((yyvsp[(2) - (2)].i)<=0) cf_error("Retransmit int must be greater than zero"); }
    break;

  case 544:
/* Line 1792 of yacc.c  */
#line 2374 "cf-parse.y"
    { OSPF_PATT->waitint = (yyvsp[(2) - (2)].i) ; }
    break;

  case 545:
/* Line 1792 of yacc.c  */
#line 2375 "cf-parse.y"
    { OSPF_PATT->deadint = (yyvsp[(2) - (2)].i) ; if ((yyvsp[(2) - (2)].i)<=1) cf_error("Dead interval must be greater than one"); }
    break;

  case 546:
/* Line 1792 of yacc.c  */
#line 2376 "cf-parse.y"
    { OSPF_PATT->deadc = (yyvsp[(3) - (3)].i) ; if ((yyvsp[(3) - (3)].i)<=1) cf_error("Dead count must be greater than one"); }
    break;

  case 547:
/* Line 1792 of yacc.c  */
#line 2377 "cf-parse.y"
    { OSPF_PATT->type = OSPF_IT_BCAST ; }
    break;

  case 548:
/* Line 1792 of yacc.c  */
#line 2378 "cf-parse.y"
    { OSPF_PATT->type = OSPF_IT_BCAST ; }
    break;

  case 549:
/* Line 1792 of yacc.c  */
#line 2379 "cf-parse.y"
    { OSPF_PATT->type = OSPF_IT_NBMA ; }
    break;

  case 550:
/* Line 1792 of yacc.c  */
#line 2380 "cf-parse.y"
    { OSPF_PATT->type = OSPF_IT_NBMA ; }
    break;

  case 551:
/* Line 1792 of yacc.c  */
#line 2381 "cf-parse.y"
    { OSPF_PATT->type = OSPF_IT_PTP ; }
    break;

  case 552:
/* Line 1792 of yacc.c  */
#line 2382 "cf-parse.y"
    { OSPF_PATT->type = OSPF_IT_PTP ; }
    break;

  case 553:
/* Line 1792 of yacc.c  */
#line 2383 "cf-parse.y"
    { OSPF_PATT->type = OSPF_IT_PTMP ; }
    break;

  case 554:
/* Line 1792 of yacc.c  */
#line 2384 "cf-parse.y"
    { OSPF_PATT->type = OSPF_IT_PTMP ; }
    break;

  case 555:
/* Line 1792 of yacc.c  */
#line 2385 "cf-parse.y"
    { OSPF_PATT->real_bcast = (yyvsp[(3) - (3)].i); if (OSPF_VERSION != 2) cf_error("Real broadcast option requires OSPFv2"); }
    break;

  case 556:
/* Line 1792 of yacc.c  */
#line 2386 "cf-parse.y"
    { OSPF_PATT->ptp_netmask = (yyvsp[(3) - (3)].i); if (OSPF_VERSION != 2) cf_error("Real netmask option requires OSPFv2"); }
    break;

  case 557:
/* Line 1792 of yacc.c  */
#line 2387 "cf-parse.y"
    { OSPF_PATT->inftransdelay = (yyvsp[(3) - (3)].i) ; if (((yyvsp[(3) - (3)].i)<=0) || ((yyvsp[(3) - (3)].i)>65535)) cf_error("Transmit delay must be in range 1-65535"); }
    break;

  case 558:
/* Line 1792 of yacc.c  */
#line 2388 "cf-parse.y"
    { OSPF_PATT->priority = (yyvsp[(2) - (2)].i) ; if (((yyvsp[(2) - (2)].i)<0) || ((yyvsp[(2) - (2)].i)>255)) cf_error("Priority must be in range 0-255"); }
    break;

  case 559:
/* Line 1792 of yacc.c  */
#line 2389 "cf-parse.y"
    { OSPF_PATT->strictnbma = (yyvsp[(3) - (3)].i) ; }
    break;

  case 560:
/* Line 1792 of yacc.c  */
#line 2390 "cf-parse.y"
    { OSPF_PATT->stub = (yyvsp[(2) - (2)].i) ; }
    break;

  case 561:
/* Line 1792 of yacc.c  */
#line 2391 "cf-parse.y"
    { OSPF_PATT->check_link = (yyvsp[(3) - (3)].i); }
    break;

  case 562:
/* Line 1792 of yacc.c  */
#line 2392 "cf-parse.y"
    { OSPF_PATT->ecmp_weight = (yyvsp[(3) - (3)].i) - 1; if (((yyvsp[(3) - (3)].i)<1) || ((yyvsp[(3) - (3)].i)>256)) cf_error("ECMP weight must be in range 1-256"); }
    break;

  case 564:
/* Line 1792 of yacc.c  */
#line 2394 "cf-parse.y"
    { OSPF_PATT->autype = OSPF_AUTH_NONE ; }
    break;

  case 565:
/* Line 1792 of yacc.c  */
#line 2395 "cf-parse.y"
    { OSPF_PATT->autype = OSPF_AUTH_SIMPLE ; }
    break;

  case 566:
/* Line 1792 of yacc.c  */
#line 2396 "cf-parse.y"
    { OSPF_PATT->autype = OSPF_AUTH_CRYPT ; }
    break;

  case 567:
/* Line 1792 of yacc.c  */
#line 2397 "cf-parse.y"
    { OSPF_PATT->rxbuf = OSPF_RXBUF_LARGE ; }
    break;

  case 568:
/* Line 1792 of yacc.c  */
#line 2398 "cf-parse.y"
    { OSPF_PATT->rxbuf = OSPF_RXBUF_NORMAL ; }
    break;

  case 569:
/* Line 1792 of yacc.c  */
#line 2399 "cf-parse.y"
    { OSPF_PATT->rxbuf = (yyvsp[(3) - (3)].i) ; if (((yyvsp[(3) - (3)].i) < OSPF_RXBUF_MINSIZE) || ((yyvsp[(3) - (3)].i) > OSPF_MAX_PKT_SIZE)) cf_error("Buffer size must be in range 256-65535"); }
    break;

  case 570:
/* Line 1792 of yacc.c  */
#line 2400 "cf-parse.y"
    { OSPF_PATT->tx_tos = (yyvsp[(2) - (2)].i); }
    break;

  case 571:
/* Line 1792 of yacc.c  */
#line 2401 "cf-parse.y"
    { OSPF_PATT->tx_priority = (yyvsp[(3) - (3)].i); }
    break;

  case 572:
/* Line 1792 of yacc.c  */
#line 2402 "cf-parse.y"
    { OSPF_PATT->ttl_security = (yyvsp[(3) - (3)].i); }
    break;

  case 573:
/* Line 1792 of yacc.c  */
#line 2403 "cf-parse.y"
    { OSPF_PATT->ttl_security = 2; }
    break;

  case 578:
/* Line 1792 of yacc.c  */
#line 2415 "cf-parse.y"
    {
   this_pref = cfg_allocz(sizeof(struct area_net_config));
   add_tail(this_nets, NODE this_pref);
   this_pref->px.addr = (yyvsp[(1) - (1)].px).addr;
   this_pref->px.len = (yyvsp[(1) - (1)].px).len;
 }
    break;

  case 580:
/* Line 1792 of yacc.c  */
#line 2425 "cf-parse.y"
    { this_pref->hidden = 1; }
    break;

  case 581:
/* Line 1792 of yacc.c  */
#line 2426 "cf-parse.y"
    { this_pref->tag = (yyvsp[(2) - (2)].i); }
    break;

  case 584:
/* Line 1792 of yacc.c  */
#line 2435 "cf-parse.y"
    { (yyval.i) = 0; }
    break;

  case 585:
/* Line 1792 of yacc.c  */
#line 2436 "cf-parse.y"
    { (yyval.i) = 1; }
    break;

  case 586:
/* Line 1792 of yacc.c  */
#line 2440 "cf-parse.y"
    {
   this_nbma = cfg_allocz(sizeof(struct nbma_node));
   add_tail(&OSPF_PATT->nbma_list, NODE this_nbma);
   this_nbma->ip=(yyvsp[(1) - (3)].a);
   this_nbma->eligible=(yyvsp[(2) - (3)].i);
 }
    break;

  case 587:
/* Line 1792 of yacc.c  */
#line 2449 "cf-parse.y"
    {
  this_ipatt = cfg_allocz(sizeof(struct ospf_iface_patt));
  add_tail(&this_area->patt_list, NODE this_ipatt);
  init_list(&this_ipatt->ipn_list);
  OSPF_PATT->cost = COST_D;
  OSPF_PATT->helloint = HELLOINT_D;
  OSPF_PATT->pollint = POLLINT_D;
  OSPF_PATT->rxmtint = RXMTINT_D;
  OSPF_PATT->inftransdelay = INFTRANSDELAY_D;
  OSPF_PATT->priority = PRIORITY_D;
  OSPF_PATT->waitint = WAIT_DMH*HELLOINT_D;
  OSPF_PATT->deadc = DEADC_D;
  OSPF_PATT->deadint = 0;
  OSPF_PATT->type = OSPF_IT_UNDEF;
  init_list(&OSPF_PATT->nbma_list);
  OSPF_PATT->autype = OSPF_AUTH_NONE;
  OSPF_PATT->ptp_netmask = 2; /* not specified */
  OSPF_PATT->tx_tos = IP_PREC_INTERNET_CONTROL;
  OSPF_PATT->tx_priority = sk_priority_control;
  reset_passwords();
 }
    break;

  case 589:
/* Line 1792 of yacc.c  */
#line 2474 "cf-parse.y"
    { set_instance_id((yyvsp[(2) - (2)].i)); }
    break;

  case 594:
/* Line 1792 of yacc.c  */
#line 2488 "cf-parse.y"
    { ospf_iface_finish(); }
    break;

  case 596:
/* Line 1792 of yacc.c  */
#line 2493 "cf-parse.y"
    { (yyval.t) = NULL; }
    break;

  case 597:
/* Line 1792 of yacc.c  */
#line 2499 "cf-parse.y"
    { ospf_sh(proto_get_named((yyvsp[(3) - (4)].s), &proto_ospf)); }
    break;

  case 598:
/* Line 1792 of yacc.c  */
#line 2502 "cf-parse.y"
    { ospf_sh_neigh(proto_get_named((yyvsp[(4) - (6)].s), &proto_ospf), (yyvsp[(5) - (6)].t)); }
    break;

  case 599:
/* Line 1792 of yacc.c  */
#line 2505 "cf-parse.y"
    { ospf_sh_iface(proto_get_named((yyvsp[(4) - (6)].s), &proto_ospf), (yyvsp[(5) - (6)].t)); }
    break;

  case 600:
/* Line 1792 of yacc.c  */
#line 2510 "cf-parse.y"
    { ospf_sh_state(proto_get_named((yyvsp[(4) - (6)].s), &proto_ospf), 0, 1); }
    break;

  case 601:
/* Line 1792 of yacc.c  */
#line 2513 "cf-parse.y"
    { ospf_sh_state(proto_get_named((yyvsp[(5) - (7)].s), &proto_ospf), 0, 0); }
    break;

  case 602:
/* Line 1792 of yacc.c  */
#line 2518 "cf-parse.y"
    { ospf_sh_state(proto_get_named((yyvsp[(4) - (6)].s), &proto_ospf), 1, 1); }
    break;

  case 603:
/* Line 1792 of yacc.c  */
#line 2521 "cf-parse.y"
    { ospf_sh_state(proto_get_named((yyvsp[(5) - (7)].s), &proto_ospf), 1, 0); }
    break;

  case 604:
/* Line 1792 of yacc.c  */
#line 2525 "cf-parse.y"
    { ospf_sh_lsadb((yyvsp[(4) - (5)].ld)); }
    break;

  case 605:
/* Line 1792 of yacc.c  */
#line 2528 "cf-parse.y"
    {
     (yyval.ld) = cfg_allocz(sizeof(struct lsadb_show_data));
   }
    break;

  case 606:
/* Line 1792 of yacc.c  */
#line 2531 "cf-parse.y"
    { (yyval.ld) = (yyvsp[(1) - (2)].ld); (yyval.ld)->scope = LSA_SCOPE_AS; }
    break;

  case 607:
/* Line 1792 of yacc.c  */
#line 2532 "cf-parse.y"
    { (yyval.ld) = (yyvsp[(1) - (3)].ld); (yyval.ld)->scope = LSA_SCOPE_AREA; (yyval.ld)->area = (yyvsp[(3) - (3)].i32); }
    break;

  case 608:
/* Line 1792 of yacc.c  */
#line 2533 "cf-parse.y"
    { (yyval.ld) = (yyvsp[(1) - (2)].ld); (yyval.ld)->scope = 1; /* hack, 0 is no filter */ }
    break;

  case 609:
/* Line 1792 of yacc.c  */
#line 2534 "cf-parse.y"
    { (yyval.ld) = (yyvsp[(1) - (3)].ld); (yyval.ld)->type = (yyvsp[(3) - (3)].i); }
    break;

  case 610:
/* Line 1792 of yacc.c  */
#line 2535 "cf-parse.y"
    { (yyval.ld) = (yyvsp[(1) - (3)].ld); (yyval.ld)->lsid = (yyvsp[(3) - (3)].i32); }
    break;

  case 611:
/* Line 1792 of yacc.c  */
#line 2536 "cf-parse.y"
    { (yyval.ld) = (yyvsp[(1) - (2)].ld); (yyval.ld)->router = SH_ROUTER_SELF; }
    break;

  case 612:
/* Line 1792 of yacc.c  */
#line 2537 "cf-parse.y"
    { (yyval.ld) = (yyvsp[(1) - (3)].ld); (yyval.ld)->router = (yyvsp[(3) - (3)].i32); }
    break;

  case 613:
/* Line 1792 of yacc.c  */
#line 2538 "cf-parse.y"
    { (yyval.ld) = (yyvsp[(1) - (2)].ld); (yyval.ld)->name = (yyvsp[(2) - (2)].s); }
    break;

  case 614:
/* Line 1792 of yacc.c  */
#line 2544 "cf-parse.y"
    {
     this_proto = proto_config_new(&proto_pipe, sizeof(struct pipe_config), (yyvsp[(1) - (2)].i));
     PIPE_CFG->mode = PIPE_TRANSPARENT;
  }
    break;

  case 617:
/* Line 1792 of yacc.c  */
#line 2553 "cf-parse.y"
    {
     if ((yyvsp[(4) - (5)].s)->class != SYM_TABLE)
       cf_error("Routing table name expected");
     PIPE_CFG->peer = (yyvsp[(4) - (5)].s)->def;
   }
    break;

  case 618:
/* Line 1792 of yacc.c  */
#line 2558 "cf-parse.y"
    { PIPE_CFG->mode = PIPE_OPAQUE; }
    break;

  case 619:
/* Line 1792 of yacc.c  */
#line 2559 "cf-parse.y"
    { PIPE_CFG->mode = PIPE_TRANSPARENT; }
    break;

  case 620:
/* Line 1792 of yacc.c  */
#line 2566 "cf-parse.y"
    {
  this_proto = proto_config_new(&proto_radv, sizeof(struct radv_config), (yyvsp[(1) - (2)].i));
  init_list(&RADV_CFG->patt_list);
  init_list(&RADV_CFG->pref_list);
  init_list(&RADV_CFG->rdnss_list);
  init_list(&RADV_CFG->dnssl_list);
}
    break;

  case 623:
/* Line 1792 of yacc.c  */
#line 2577 "cf-parse.y"
    { add_tail(&RADV_CFG->pref_list, NODE this_radv_prefix); }
    break;

  case 624:
/* Line 1792 of yacc.c  */
#line 2578 "cf-parse.y"
    { init_list(&radv_dns_list); }
    break;

  case 625:
/* Line 1792 of yacc.c  */
#line 2578 "cf-parse.y"
    { add_tail_list(&RADV_CFG->rdnss_list, &radv_dns_list); }
    break;

  case 626:
/* Line 1792 of yacc.c  */
#line 2579 "cf-parse.y"
    { init_list(&radv_dns_list); }
    break;

  case 627:
/* Line 1792 of yacc.c  */
#line 2579 "cf-parse.y"
    { add_tail_list(&RADV_CFG->dnssl_list, &radv_dns_list); }
    break;

  case 628:
/* Line 1792 of yacc.c  */
#line 2580 "cf-parse.y"
    {
     RADV_CFG->trigger_prefix = (yyvsp[(2) - (2)].px).addr;
     RADV_CFG->trigger_pxlen = (yyvsp[(2) - (2)].px).len;
     RADV_CFG->trigger_valid = 1;
   }
    break;

  case 632:
/* Line 1792 of yacc.c  */
#line 2597 "cf-parse.y"
    {
  this_ipatt = cfg_allocz(sizeof(struct radv_iface_config));
  add_tail(&RADV_CFG->patt_list, NODE this_ipatt);
  init_list(&this_ipatt->ipn_list);
  init_list(&RADV_IFACE->pref_list);
  init_list(&RADV_IFACE->rdnss_list);
  init_list(&RADV_IFACE->dnssl_list);

  RADV_IFACE->min_ra_int = -1; /* undefined */
  RADV_IFACE->max_ra_int = DEFAULT_MAX_RA_INT;
  RADV_IFACE->min_delay = DEFAULT_MIN_DELAY;
  RADV_IFACE->current_hop_limit = DEFAULT_CURRENT_HOP_LIMIT;
  RADV_IFACE->default_lifetime = -1;
  RADV_IFACE->default_lifetime_sensitive = 1;
}
    break;

  case 633:
/* Line 1792 of yacc.c  */
#line 2614 "cf-parse.y"
    { RADV_IFACE->min_ra_int = (yyvsp[(4) - (4)].i); if ((yyvsp[(4) - (4)].i) < 3) cf_error("Min RA interval must be at least 3"); }
    break;

  case 634:
/* Line 1792 of yacc.c  */
#line 2615 "cf-parse.y"
    { RADV_IFACE->max_ra_int = (yyvsp[(4) - (4)].i); if (((yyvsp[(4) - (4)].i) < 4) || ((yyvsp[(4) - (4)].i) > 1800)) cf_error("Max RA interval must be in range 4-1800"); }
    break;

  case 635:
/* Line 1792 of yacc.c  */
#line 2616 "cf-parse.y"
    { RADV_IFACE->min_delay = (yyvsp[(3) - (3)].i); if ((yyvsp[(3) - (3)].i) <= 0) cf_error("Min delay must be positive"); }
    break;

  case 636:
/* Line 1792 of yacc.c  */
#line 2617 "cf-parse.y"
    { RADV_IFACE->managed = (yyvsp[(2) - (2)].i); }
    break;

  case 637:
/* Line 1792 of yacc.c  */
#line 2618 "cf-parse.y"
    { RADV_IFACE->other_config = (yyvsp[(3) - (3)].i); }
    break;

  case 638:
/* Line 1792 of yacc.c  */
#line 2619 "cf-parse.y"
    { RADV_IFACE->link_mtu = (yyvsp[(3) - (3)].i); if ((yyvsp[(3) - (3)].i) < 0) cf_error("Link MTU must be 0 or positive"); }
    break;

  case 639:
/* Line 1792 of yacc.c  */
#line 2620 "cf-parse.y"
    { RADV_IFACE->reachable_time = (yyvsp[(3) - (3)].i); if (((yyvsp[(3) - (3)].i) < 0) || ((yyvsp[(3) - (3)].i) > 3600000)) cf_error("Reachable time must be in range 0-3600000"); }
    break;

  case 640:
/* Line 1792 of yacc.c  */
#line 2621 "cf-parse.y"
    { RADV_IFACE->retrans_timer = (yyvsp[(3) - (3)].i); if ((yyvsp[(3) - (3)].i) < 0) cf_error("Retrans timer must be 0 or positive"); }
    break;

  case 641:
/* Line 1792 of yacc.c  */
#line 2622 "cf-parse.y"
    { RADV_IFACE->current_hop_limit = (yyvsp[(4) - (4)].i); if (((yyvsp[(4) - (4)].i) < 0) || ((yyvsp[(4) - (4)].i) > 255))  cf_error("Current hop limit must be in range 0-255"); }
    break;

  case 642:
/* Line 1792 of yacc.c  */
#line 2623 "cf-parse.y"
    {
     RADV_IFACE->default_lifetime = (yyvsp[(3) - (4)].i);
     if (((yyvsp[(3) - (4)].i) < 0) || ((yyvsp[(3) - (4)].i) > 9000))  cf_error("Default lifetime must be in range 0-9000");
     if ((yyvsp[(4) - (4)].i) != -1) RADV_IFACE->default_lifetime_sensitive = (yyvsp[(4) - (4)].i);
   }
    break;

  case 643:
/* Line 1792 of yacc.c  */
#line 2628 "cf-parse.y"
    { add_tail(&RADV_IFACE->pref_list, NODE this_radv_prefix); }
    break;

  case 644:
/* Line 1792 of yacc.c  */
#line 2629 "cf-parse.y"
    { init_list(&radv_dns_list); }
    break;

  case 645:
/* Line 1792 of yacc.c  */
#line 2629 "cf-parse.y"
    { add_tail_list(&RADV_IFACE->rdnss_list, &radv_dns_list); }
    break;

  case 646:
/* Line 1792 of yacc.c  */
#line 2630 "cf-parse.y"
    { init_list(&radv_dns_list); }
    break;

  case 647:
/* Line 1792 of yacc.c  */
#line 2630 "cf-parse.y"
    { add_tail_list(&RADV_IFACE->dnssl_list, &radv_dns_list); }
    break;

  case 648:
/* Line 1792 of yacc.c  */
#line 2631 "cf-parse.y"
    { RADV_IFACE->rdnss_local = (yyvsp[(3) - (3)].i); }
    break;

  case 649:
/* Line 1792 of yacc.c  */
#line 2632 "cf-parse.y"
    { RADV_IFACE->dnssl_local = (yyvsp[(3) - (3)].i); }
    break;

  case 650:
/* Line 1792 of yacc.c  */
#line 2636 "cf-parse.y"
    {
  struct radv_iface_config *ic = RADV_IFACE;

  if (ic->min_ra_int == (u32) -1)
    ic->min_ra_int = _MAX(ic->max_ra_int / 3, 3);

  if (ic->default_lifetime == (u32) -1)
    ic->default_lifetime = 3 * ic->max_ra_int;

  if ((ic->min_ra_int > 3) &&
      (ic->min_ra_int > (ic->max_ra_int * 3 / 4)))
    cf_error("Min RA interval must be at most 3/4 * Max RA interval %d %d", ic->min_ra_int, ic->max_ra_int);

  if ((ic->default_lifetime > 0) && (ic->default_lifetime < ic->max_ra_int))
    cf_error("Default lifetime must be either 0 or at least Max RA interval");
}
    break;

  case 656:
/* Line 1792 of yacc.c  */
#line 2669 "cf-parse.y"
    {
  this_radv_prefix = cfg_allocz(sizeof(struct radv_prefix_config));
  RADV_PREFIX->prefix = (yyvsp[(1) - (1)].px).addr;
  RADV_PREFIX->pxlen = (yyvsp[(1) - (1)].px).len;

  RADV_PREFIX->onlink = 1;
  RADV_PREFIX->autonomous = 1;
  RADV_PREFIX->valid_lifetime = DEFAULT_VALID_LIFETIME;
  RADV_PREFIX->preferred_lifetime = DEFAULT_PREFERRED_LIFETIME;
}
    break;

  case 657:
/* Line 1792 of yacc.c  */
#line 2681 "cf-parse.y"
    { RADV_PREFIX->skip = (yyvsp[(2) - (2)].i); }
    break;

  case 658:
/* Line 1792 of yacc.c  */
#line 2682 "cf-parse.y"
    { RADV_PREFIX->onlink = (yyvsp[(2) - (2)].i); }
    break;

  case 659:
/* Line 1792 of yacc.c  */
#line 2683 "cf-parse.y"
    { RADV_PREFIX->autonomous = (yyvsp[(2) - (2)].i); }
    break;

  case 660:
/* Line 1792 of yacc.c  */
#line 2684 "cf-parse.y"
    {
     RADV_PREFIX->valid_lifetime = (yyvsp[(3) - (4)].i);
     if ((yyvsp[(3) - (4)].i) < 0) cf_error("Valid lifetime must be 0 or positive");
     if ((yyvsp[(4) - (4)].i) != -1) RADV_PREFIX->valid_lifetime_sensitive = (yyvsp[(4) - (4)].i);
   }
    break;

  case 661:
/* Line 1792 of yacc.c  */
#line 2689 "cf-parse.y"
    {
     RADV_PREFIX->preferred_lifetime = (yyvsp[(3) - (4)].i);
     if ((yyvsp[(3) - (4)].i) < 0) cf_error("Preferred lifetime must be 0 or positive");
     if ((yyvsp[(4) - (4)].i) != -1) RADV_PREFIX->preferred_lifetime_sensitive = (yyvsp[(4) - (4)].i);
   }
    break;

  case 662:
/* Line 1792 of yacc.c  */
#line 2697 "cf-parse.y"
    {
  if (RADV_PREFIX->preferred_lifetime > RADV_PREFIX->valid_lifetime)
    cf_error("Preferred lifetime must be at most Valid lifetime");

  if (RADV_PREFIX->valid_lifetime_sensitive > RADV_PREFIX->preferred_lifetime_sensitive)
    cf_error("Valid lifetime sensitive requires that Preferred lifetime is sensitive too");
}
    break;

  case 668:
/* Line 1792 of yacc.c  */
#line 2721 "cf-parse.y"
    {
  struct radv_rdnss_config *cf = cfg_allocz(sizeof(struct radv_rdnss_config));
  add_tail(&radv_dns_list, NODE cf);

  cf->server = (yyvsp[(1) - (1)].a);
  cf->lifetime_mult = DEFAULT_DNS_LIFETIME_MULT;
}
    break;

  case 669:
/* Line 1792 of yacc.c  */
#line 2730 "cf-parse.y"
    {
  RADV_RDNSS->lifetime = 0;
  RADV_RDNSS->lifetime_mult = DEFAULT_DNS_LIFETIME_MULT;
}
    break;

  case 672:
/* Line 1792 of yacc.c  */
#line 2737 "cf-parse.y"
    { RADV_RDNSS->lifetime = (yyvsp[(2) - (2)].i); RADV_RDNSS->lifetime_mult = radv_mult_val; }
    break;

  case 673:
/* Line 1792 of yacc.c  */
#line 2741 "cf-parse.y"
    {
  if (EMPTY_LIST(radv_dns_list))
    cf_error("No nameserver in RDNSS section");

  struct radv_rdnss_config *cf;
  WALK_LIST(cf, radv_dns_list)
  {
    cf->lifetime = RADV_RDNSS->lifetime;
    cf->lifetime_mult = RADV_RDNSS->lifetime_mult;
  }
}
    break;

  case 678:
/* Line 1792 of yacc.c  */
#line 2765 "cf-parse.y"
    {
  struct radv_dnssl_config *cf = cfg_allocz(sizeof(struct radv_dnssl_config));
  add_tail(&radv_dns_list, NODE cf);

  cf->domain = (yyvsp[(1) - (1)].t);
  cf->lifetime_mult = DEFAULT_DNS_LIFETIME_MULT;

  if (radv_process_domain(cf) < 0)
    cf_error("Invalid domain dame");
}
    break;

  case 679:
/* Line 1792 of yacc.c  */
#line 2777 "cf-parse.y"
    {
  RADV_DNSSL->lifetime = 0;
  RADV_DNSSL->lifetime_mult = DEFAULT_DNS_LIFETIME_MULT;
}
    break;

  case 682:
/* Line 1792 of yacc.c  */
#line 2784 "cf-parse.y"
    { RADV_DNSSL->lifetime = (yyvsp[(2) - (2)].i); RADV_DNSSL->lifetime_mult = radv_mult_val; }
    break;

  case 683:
/* Line 1792 of yacc.c  */
#line 2788 "cf-parse.y"
    {
  if (EMPTY_LIST(radv_dns_list))
    cf_error("No domain in DNSSL section");

  struct radv_dnssl_config *cf;
  WALK_LIST(cf, radv_dns_list)
  {
    cf->lifetime = RADV_DNSSL->lifetime;
    cf->lifetime_mult = RADV_DNSSL->lifetime_mult;
  }
}
    break;

  case 688:
/* Line 1792 of yacc.c  */
#line 2812 "cf-parse.y"
    { (yyval.i) = (yyvsp[(1) - (1)].i); radv_mult_val = 0; }
    break;

  case 689:
/* Line 1792 of yacc.c  */
#line 2813 "cf-parse.y"
    { (yyval.i) = 0; radv_mult_val = (yyvsp[(2) - (2)].i); if (((yyvsp[(2) - (2)].i) < 1) || ((yyvsp[(2) - (2)].i) > 254)) cf_error("Multiplier must be in range 1-254"); }
    break;

  case 690:
/* Line 1792 of yacc.c  */
#line 2817 "cf-parse.y"
    { (yyval.i) = -1; }
    break;

  case 691:
/* Line 1792 of yacc.c  */
#line 2818 "cf-parse.y"
    { (yyval.i) = (yyvsp[(2) - (2)].i); }
    break;

  case 692:
/* Line 1792 of yacc.c  */
#line 2824 "cf-parse.y"
    {
     this_proto = proto_config_new(&proto_rip, sizeof(struct rip_proto_config), (yyvsp[(1) - (2)].i));
     rip_init_config(RIP_CFG);
   }
    break;

  case 695:
/* Line 1792 of yacc.c  */
#line 2833 "cf-parse.y"
    { RIP_CFG->infinity = (yyvsp[(3) - (4)].i); }
    break;

  case 696:
/* Line 1792 of yacc.c  */
#line 2834 "cf-parse.y"
    { RIP_CFG->port = (yyvsp[(3) - (4)].i); }
    break;

  case 697:
/* Line 1792 of yacc.c  */
#line 2835 "cf-parse.y"
    { RIP_CFG->period = (yyvsp[(3) - (4)].i); }
    break;

  case 698:
/* Line 1792 of yacc.c  */
#line 2836 "cf-parse.y"
    { RIP_CFG->garbage_time = (yyvsp[(4) - (5)].i); }
    break;

  case 699:
/* Line 1792 of yacc.c  */
#line 2837 "cf-parse.y"
    { RIP_CFG->timeout_time = (yyvsp[(4) - (5)].i); }
    break;

  case 700:
/* Line 1792 of yacc.c  */
#line 2838 "cf-parse.y"
    {RIP_CFG->authtype = (yyvsp[(3) - (4)].i); }
    break;

  case 702:
/* Line 1792 of yacc.c  */
#line 2840 "cf-parse.y"
    { RIP_CFG->honor = HO_ALWAYS; }
    break;

  case 703:
/* Line 1792 of yacc.c  */
#line 2841 "cf-parse.y"
    { RIP_CFG->honor = HO_NEIGHBOR; }
    break;

  case 704:
/* Line 1792 of yacc.c  */
#line 2842 "cf-parse.y"
    { RIP_CFG->honor = HO_NEVER; }
    break;

  case 706:
/* Line 1792 of yacc.c  */
#line 2847 "cf-parse.y"
    { (yyval.i)=AT_PLAINTEXT; }
    break;

  case 707:
/* Line 1792 of yacc.c  */
#line 2848 "cf-parse.y"
    { (yyval.i)=AT_MD5; }
    break;

  case 708:
/* Line 1792 of yacc.c  */
#line 2849 "cf-parse.y"
    { (yyval.i)=AT_NONE; }
    break;

  case 709:
/* Line 1792 of yacc.c  */
#line 2854 "cf-parse.y"
    { (yyval.i)=IM_BROADCAST; }
    break;

  case 710:
/* Line 1792 of yacc.c  */
#line 2855 "cf-parse.y"
    { (yyval.i)=0; }
    break;

  case 711:
/* Line 1792 of yacc.c  */
#line 2856 "cf-parse.y"
    { (yyval.i)=IM_QUIET; }
    break;

  case 712:
/* Line 1792 of yacc.c  */
#line 2857 "cf-parse.y"
    { (yyval.i)=IM_NOLISTEN; }
    break;

  case 713:
/* Line 1792 of yacc.c  */
#line 2858 "cf-parse.y"
    { (yyval.i)=IM_VERSION1 | IM_BROADCAST; }
    break;

  case 715:
/* Line 1792 of yacc.c  */
#line 2862 "cf-parse.y"
    { RIP_IPATT->metric = (yyvsp[(2) - (2)].i); }
    break;

  case 716:
/* Line 1792 of yacc.c  */
#line 2863 "cf-parse.y"
    { RIP_IPATT->mode |= (yyvsp[(2) - (2)].i); }
    break;

  case 717:
/* Line 1792 of yacc.c  */
#line 2864 "cf-parse.y"
    { RIP_IPATT->tx_tos = (yyvsp[(2) - (2)].i); }
    break;

  case 718:
/* Line 1792 of yacc.c  */
#line 2865 "cf-parse.y"
    { RIP_IPATT->tx_priority = (yyvsp[(3) - (3)].i); }
    break;

  case 719:
/* Line 1792 of yacc.c  */
#line 2866 "cf-parse.y"
    { RIP_IPATT->ttl_security = (yyvsp[(3) - (3)].i); }
    break;

  case 720:
/* Line 1792 of yacc.c  */
#line 2867 "cf-parse.y"
    { RIP_IPATT->ttl_security = 2; }
    break;

  case 725:
/* Line 1792 of yacc.c  */
#line 2881 "cf-parse.y"
    {
     this_ipatt = cfg_allocz(sizeof(struct rip_patt));
     add_tail(&RIP_CFG->iface_list, NODE this_ipatt);
     init_list(&this_ipatt->ipn_list);
     RIP_IPATT->metric = 1;
     RIP_IPATT->tx_tos = IP_PREC_INTERNET_CONTROL;
     RIP_IPATT->tx_priority = sk_priority_control;
     RIP_IPATT->ttl_security = RIP_DEFAULT_TTL_SECURITY;
   }
    break;

  case 727:
/* Line 1792 of yacc.c  */
#line 2900 "cf-parse.y"
    {
     this_proto = proto_config_new(&proto_static, sizeof(struct static_config), (yyvsp[(1) - (2)].i));
     static_init_config((struct static_config *) this_proto);
  }
    break;

  case 730:
/* Line 1792 of yacc.c  */
#line 2909 "cf-parse.y"
    { STATIC_CFG->check_link = (yyvsp[(4) - (5)].i); }
    break;

  case 731:
/* Line 1792 of yacc.c  */
#line 2910 "cf-parse.y"
    { STATIC_CFG->igp_table = (yyvsp[(4) - (5)].r); }
    break;

  case 733:
/* Line 1792 of yacc.c  */
#line 2914 "cf-parse.y"
    {
     this_srt = cfg_allocz(sizeof(struct static_route));
     add_tail(&STATIC_CFG->other_routes, &this_srt->n);
     this_srt->net = (yyvsp[(2) - (2)].px).addr;
     this_srt->masklen = (yyvsp[(2) - (2)].px).len;
  }
    break;

  case 734:
/* Line 1792 of yacc.c  */
#line 2923 "cf-parse.y"
    {
     last_srt_nh = this_srt_nh;
     this_srt_nh = cfg_allocz(sizeof(struct static_route));
     this_srt_nh->dest = RTD_NONE;
     this_srt_nh->via = (yyvsp[(2) - (3)].a);
     this_srt_nh->via_if = (yyvsp[(3) - (3)].iface);
     this_srt_nh->if_name = (void *) this_srt; /* really */
   }
    break;

  case 735:
/* Line 1792 of yacc.c  */
#line 2931 "cf-parse.y"
    {
     this_srt_nh->masklen = (yyvsp[(3) - (3)].i) - 1; /* really */
     if (((yyvsp[(3) - (3)].i)<1) || ((yyvsp[(3) - (3)].i)>256)) cf_error("Weight must be in range 1-256"); 
   }
    break;

  case 736:
/* Line 1792 of yacc.c  */
#line 2938 "cf-parse.y"
    { this_srt->mp_next = this_srt_nh; }
    break;

  case 737:
/* Line 1792 of yacc.c  */
#line 2939 "cf-parse.y"
    { last_srt_nh->mp_next = this_srt_nh; }
    break;

  case 738:
/* Line 1792 of yacc.c  */
#line 2943 "cf-parse.y"
    {
      this_srt->dest = RTD_ROUTER;
      this_srt->via = (yyvsp[(3) - (4)].a);
      this_srt->via_if = (yyvsp[(4) - (4)].iface);
   }
    break;

  case 739:
/* Line 1792 of yacc.c  */
#line 2948 "cf-parse.y"
    {
      this_srt->dest = RTD_DEVICE;
      this_srt->if_name = (yyvsp[(3) - (3)].t);
      rem_node(&this_srt->n);
      add_tail(&STATIC_CFG->iface_routes, &this_srt->n);
   }
    break;

  case 740:
/* Line 1792 of yacc.c  */
#line 2954 "cf-parse.y"
    {
      this_srt->dest = RTD_MULTIPATH;
   }
    break;

  case 741:
/* Line 1792 of yacc.c  */
#line 2957 "cf-parse.y"
    {
      this_srt->dest = RTDX_RECURSIVE;
      this_srt->via = (yyvsp[(3) - (3)].a);
   }
    break;

  case 742:
/* Line 1792 of yacc.c  */
#line 2962 "cf-parse.y"
    { this_srt->dest = RTD_BLACKHOLE; }
    break;

  case 743:
/* Line 1792 of yacc.c  */
#line 2963 "cf-parse.y"
    { this_srt->dest = RTD_UNREACHABLE; }
    break;

  case 744:
/* Line 1792 of yacc.c  */
#line 2964 "cf-parse.y"
    { this_srt->dest = RTD_BLACKHOLE; }
    break;

  case 745:
/* Line 1792 of yacc.c  */
#line 2965 "cf-parse.y"
    { this_srt->dest = RTD_UNREACHABLE; }
    break;

  case 746:
/* Line 1792 of yacc.c  */
#line 2966 "cf-parse.y"
    { this_srt->dest = RTD_PROHIBIT; }
    break;

  case 747:
/* Line 1792 of yacc.c  */
#line 2970 "cf-parse.y"
    { static_show(proto_get_named((yyvsp[(3) - (4)].s), &proto_static)); }
    break;

  case 810:
/* Line 1792 of yacc.c  */
#line 2978 "cf-parse.y"
    { bgp_check_config(BGP_CFG); }
    break;

  case 811:
/* Line 1792 of yacc.c  */
#line 2978 "cf-parse.y"
    { ospf_proto_finish(); }
    break;

  case 814:
/* Line 1792 of yacc.c  */
#line 2978 "cf-parse.y"
    { RIP_CFG->passwords = get_passwords(); }
    break;

  case 823:
/* Line 1792 of yacc.c  */
#line 2981 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT | EAF_TEMP, T_INT, EA_KRT_SOURCE); }
    break;

  case 824:
/* Line 1792 of yacc.c  */
#line 2981 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT | EAF_TEMP, T_INT, EA_KRT_METRIC); }
    break;

  case 825:
/* Line 1792 of yacc.c  */
#line 2981 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_IP_ADDRESS, T_IP, EA_KRT_PREFSRC); }
    break;

  case 826:
/* Line 1792 of yacc.c  */
#line 2981 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_KRT_REALM); }
    break;

  case 827:
/* Line 1792 of yacc.c  */
#line 2982 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_GEN_IGP_METRIC); }
    break;

  case 828:
/* Line 1792 of yacc.c  */
#line 2982 "cf-parse.y"
    { (yyval.x) = NULL; }
    break;

  case 829:
/* Line 1792 of yacc.c  */
#line 2983 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT, T_ENUM_BGP_ORIGIN, EA_CODE(EAP_BGP, BA_ORIGIN)); }
    break;

  case 830:
/* Line 1792 of yacc.c  */
#line 2984 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_AS_PATH, T_PATH, EA_CODE(EAP_BGP, BA_AS_PATH)); }
    break;

  case 831:
/* Line 1792 of yacc.c  */
#line 2985 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_IP_ADDRESS, T_IP, EA_CODE(EAP_BGP, BA_NEXT_HOP)); }
    break;

  case 832:
/* Line 1792 of yacc.c  */
#line 2986 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_CODE(EAP_BGP, BA_MULTI_EXIT_DISC)); }
    break;

  case 833:
/* Line 1792 of yacc.c  */
#line 2987 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_CODE(EAP_BGP, BA_LOCAL_PREF)); }
    break;

  case 834:
/* Line 1792 of yacc.c  */
#line 2988 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_OPAQUE, T_ENUM_EMPTY, EA_CODE(EAP_BGP, BA_ATOMIC_AGGR)); }
    break;

  case 835:
/* Line 1792 of yacc.c  */
#line 2989 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_CODE(EAP_BGP, BA_AGGREGATOR)); }
    break;

  case 836:
/* Line 1792 of yacc.c  */
#line 2990 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT_SET, T_CLIST, EA_CODE(EAP_BGP, BA_COMMUNITY)); }
    break;

  case 837:
/* Line 1792 of yacc.c  */
#line 2991 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_ROUTER_ID, T_QUAD, EA_CODE(EAP_BGP, BA_ORIGINATOR_ID)); }
    break;

  case 838:
/* Line 1792 of yacc.c  */
#line 2992 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT_SET, T_CLIST, EA_CODE(EAP_BGP, BA_CLUSTER_LIST)); }
    break;

  case 839:
/* Line 1792 of yacc.c  */
#line 2993 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_EC_SET, T_ECLIST, EA_CODE(EAP_BGP, BA_EXT_COMMUNITY)); }
    break;

  case 840:
/* Line 1792 of yacc.c  */
#line 2993 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT | EAF_TEMP, T_INT, EA_OSPF_METRIC1); }
    break;

  case 841:
/* Line 1792 of yacc.c  */
#line 2993 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT | EAF_TEMP, T_INT, EA_OSPF_METRIC2); }
    break;

  case 842:
/* Line 1792 of yacc.c  */
#line 2993 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT | EAF_TEMP, T_INT, EA_OSPF_TAG); }
    break;

  case 843:
/* Line 1792 of yacc.c  */
#line 2993 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_ROUTER_ID | EAF_TEMP, T_QUAD, EA_OSPF_ROUTER_ID); }
    break;

  case 844:
/* Line 1792 of yacc.c  */
#line 2993 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT | EAF_TEMP, T_INT, EA_RIP_METRIC); }
    break;

  case 845:
/* Line 1792 of yacc.c  */
#line 2993 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT | EAF_TEMP, T_INT, EA_RIP_TAG); }
    break;


/* Line 1792 of yacc.c  */
#line 8708 "cf-parse.tab.c"
      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", yyr1[yyn], &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;

  /* Now `shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*------------------------------------.
| yyerrlab -- here on detecting error |
`------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYEMPTY : YYTRANSLATE (yychar);

  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if ! YYERROR_VERBOSE
      yyerror (YY_("syntax error"));
#else
# define YYSYNTAX_ERROR yysyntax_error (&yymsg_alloc, &yymsg, \
                                        yyssp, yytoken)
      {
        char const *yymsgp = YY_("syntax error");
        int yysyntax_error_status;
        yysyntax_error_status = YYSYNTAX_ERROR;
        if (yysyntax_error_status == 0)
          yymsgp = yymsg;
        else if (yysyntax_error_status == 1)
          {
            if (yymsg != yymsgbuf)
              YYSTACK_FREE (yymsg);
            yymsg = (char *) YYSTACK_ALLOC (yymsg_alloc);
            if (!yymsg)
              {
                yymsg = yymsgbuf;
                yymsg_alloc = sizeof yymsgbuf;
                yysyntax_error_status = 2;
              }
            else
              {
                yysyntax_error_status = YYSYNTAX_ERROR;
                yymsgp = yymsg;
              }
          }
        yyerror (yymsgp);
        if (yysyntax_error_status == 2)
          goto yyexhaustedlab;
      }
# undef YYSYNTAX_ERROR
#endif
    }



  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
	 error, discard it.  */

      if (yychar <= YYEOF)
	{
	  /* Return failure if at end of input.  */
	  if (yychar == YYEOF)
	    YYABORT;
	}
      else
	{
	  yydestruct ("Error: discarding",
		      yytoken, &yylval);
	  yychar = YYEMPTY;
	}
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:

  /* Pacify compilers like GCC when the user code never invokes
     YYERROR and the label yyerrorlab therefore never appears in user
     code.  */
  if (/*CONSTCOND*/ 0)
     goto yyerrorlab;

  /* Do not reclaim the symbols of the rule which action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;	/* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
	{
	  yyn += YYTERROR;
	  if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
	    {
	      yyn = yytable[yyn];
	      if (0 < yyn)
		break;
	    }
	}

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
	YYABORT;


      yydestruct ("Error: popping",
		  yystos[yystate], yyvsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", yystos[yyn], yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#if !defined yyoverflow || YYERROR_VERBOSE
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval);
    }
  /* Do not reclaim the symbols of the rule which action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
		  yystos[*yyssp], yyvsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
#if YYERROR_VERBOSE
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
#endif
  /* Make sure YYID is used.  */
  return YYID (yyresult);
}


/* Line 2055 of yacc.c  */
#line 2995 "cf-parse.y"

/* C Code from ../../conf/confbase.Y */

/* C Code from ../../sysdep/unix/config.Y */

/* C Code from ../../sysdep/unix/krt.Y */

/* C Code from ../../sysdep/linux/netlink.Y */

/* C Code from ../../nest/config.Y */

/* C Code from ../../proto/bgp/config.Y */

/* C Code from ../../proto/ospf/config.Y */

/* C Code from ../../proto/pipe/config.Y */

/* C Code from ../../proto/radv/config.Y */

/* C Code from ../../proto/rip/config.Y */

/* C Code from ../../proto/static/config.Y */

